import java.applet.*;
import java.awt.*;
import java.io.*;
import java.net.*;


public class App extends Applet  {

	static Toolkit
				tk				= Toolkit.getDefaultToolkit();

	static Font		
				regFont			= new Font("Helvetica", Font.PLAIN, 12 ),
				boldFont		= new Font("Helvetica", Font.PLAIN, 12 );

	static Pendulum
				pendulum		= new Pendulum();

	static Graph	
				graph			= new Graph();

	static Torus
				torus			= new Torus();

	static Panel
				panParam		= new Panel(),
				panAnim			= new Panel(),
				panOptions		= new Panel(),
				panGraph		= new Panel(),
				panClone		= new Panel(),
				panGraphClone	= new Panel(),
				panTorusOpt		= new Panel(),
				panBtnResetShow	= new Panel(),
				panBtnAnim		= new Panel();

	static UnderlinedLabel
				labPosition		= new UnderlinedLabel("Position at start, degrees from vertical",'p'),  
				labRotation		= new UnderlinedLabel("Rotation at start, laps/s about its axis",'r'),
				labGraphTime	= new UnderlinedLabel("Graph (s)",'g');

	static Label
				labParameters	= new Label("Parameters"),
				labBlank1Param	= new Label(""),
				labArm1Param	= new Label("Arm1"),				
				labArm2Param	= new Label("Arm2"),
				labLength		= new Label("Length of arm (mm)"),
				labWidth		= new Label("Width of arm (mm)"),
				labMass			= new Label("Mass of arm (g)"),
				labExtMass		= new Label("Adj. weight (g)"),
				labPosExtMass	= new Label("Position of weight"),
				labFriction		= new Label("Inv. damping (1/s)"),
				labM1Big		= new Label("Mass at end (g)"),
			
				labAnimation	= new Label("Animation"),
				labBlankAnim	= new Label(""),
				labCurTime		= new Label("Time"),
				
				labArm1Pos		= new Label("Arm1"),				
				labArm2Pos		= new Label("Arm2"),				
				labArm1Rot		= new Label("Arm1"),				
				labArm2Rot		= new Label("Arm2"),

				
				labOptions		= new Label("Graph options"),
				labOptArm2		= new Label("Position and rotation of arm2"),							

				labGraphType	= new Label("Graph type"),

				labClone		= new Label("Clone"),
				labClonePos		= new Label("Difference in position at start (degrees)"),
				labClonePosArm1	= new Label("Arm 1"),
				labClonePosArm2	= new Label("Arm 2"),
				labCloneRot		= new Label("Difference in rotation at start (degrees/s)"),
				labCloneRotArm1	= new Label("Arm 1"),
				labCloneRotArm2	= new Label("Arm 2"),
				labClonePosition= new Label("Position"),
				labCloneRotation= new Label("Rotation"),

				labCloneGraph	= new Label("Graph type");

	static TextField
				text_a1			= new TextField(),
				text_b1			= new TextField(),
				text_mArm1		= new TextField(),
				text_m1			= new TextField(),
				text_k1			= new TextField(),
				text_m1Big		= new TextField(),

				text_a2			= new TextField(),
				text_b2			= new TextField(),
				text_mArm2		= new TextField(),
				text_m2			= new TextField(),
				text_k2			= new TextField(),

				textGraphTime	= new TextField(),
				textCurTime		= new TextField(),

				textPosArm1		= new TextField(),
				textRotArm1		= new TextField(),
				textPosArm2		= new TextField(),
				textRotArm2		= new TextField(),

				textDposArm1	= new TextField(),
				textDposArm2	= new TextField(),
				textDrotArm1	= new TextField(),
				textDrotArm2	= new TextField();

	static UnderlinedButton				
				btnReset		= new UnderlinedButton("Reset"),
				btnStart		= new UnderlinedButton("Start"),
				btnPause		= new UnderlinedButton("Pause"),
				btnStop			= new UnderlinedButton("Stop"),
				btnExit			= new UnderlinedButton("Exit");
				
	static Scrollbar
				scrbar_m1		= new Scrollbar(Scrollbar.HORIZONTAL,50,10,0,100),
				scrbar_m2		= new Scrollbar(Scrollbar.HORIZONTAL,50,10,0,100);

	static CheckboxGroup	
				absGroup		= new CheckboxGroup(),
				graphGroup		= new CheckboxGroup();

	static Checkbox	
				chkboxArm2Abs	= new Checkbox("Vertical line",absGroup,false),
				chkboxArm2Rel	= new Checkbox("From arm1",absGroup,true),

				chkboxRunGraph	= new Checkbox("Real time"),
				chkboxClone		= new Checkbox("Double runs"),

				chkboxEnergy	= new Checkbox("Energy", graphGroup, true),
				chkboxNone		= new Checkbox("None", graphGroup, false),
				chkboxPos_Time	= new Checkbox("Pos(time)", graphGroup, false),
				chkboxPos2_Pos1	= new Checkbox("Pos2(pos1)", graphGroup, false),
				chkboxRot_Time	= new Checkbox("Rot(time)", graphGroup, false),
				chkboxRot2_Rot1	= new Checkbox("Rot2(rot1)", graphGroup, false),
				chkboxE1E2_Time	= new Checkbox("E1(t) E2(t)", graphGroup, false),
				chkboxPosTorus	= new Checkbox("Torus", graphGroup, false),
				chkboxEkEp_Time	= new Checkbox("Ek(t) Ep(t)", graphGroup, false),
				chkboxRot1_Pos1	= new Checkbox("Rot1(pos1)", graphGroup, false),
				chkboxEkp12_Time= new Checkbox("Ekp12(t)", graphGroup, false),
				chkboxRot2_Pos2	= new Checkbox("Rot2(pos2)", graphGroup, false),
				chkboxPosArm1	= new Checkbox("Arm1", graphGroup, false),
				chkboxPosArm2	= new Checkbox("Arm2", graphGroup, false),
				chkboxRotArm1	= new Checkbox("Arm1", graphGroup, false),
				chkboxRotArm2	= new Checkbox("Arm2", graphGroup, false),

				chkboxCircles	= new Checkbox("Circles", null, true),
				chkboxBackside	= new Checkbox("Backside", null, true),

				prevGraph,
				prevClone;

	static GridBagLayout		
				gbl				= new GridBagLayout();
						
	static GridBagConstraints	
				gbc				= new GridBagConstraints();

	static CardLayout
				cardLayout		= new CardLayout();

	final static int
				origin = 0,
				clone = 1;

	static int	status = 0,
				fontSize;

	static boolean
				virgin			= true,
				txtActive		= false;

	static int initCount=0;


	//-----------------------------------------------------------------------
	//					init
	//_______________________________________________________________________	
	public void init() {
				
		initCount++;
		setLayout();
		setGraphType();
		setTextFields();
		btnStart.requestFocus();		
	}


	//-----------------------------------------------------------------------
	//					stop
	//_______________________________________________________________________	
	public void stop() {
		int status=0;
		Graph.stop();
	}


	//-----------------------------------------------------------------------
	//								paint
	//_______________________________________________________________________
	public void paint(Graphics g)  {		

		if (virgin)  {
			panTorusOpt.hide();
			btnStop.disable();
			btnPause.disable();
			panClone.hide();
			chkboxRunGraph.setState(true);
			prevClone = chkboxPosArm1;
			prevGraph = chkboxEnergy;
			virgin = false;
		}
	}

					
	//-----------------------------------------------------------------------
	//					addComponent
	//_______________________________________________________________________	
	protected void addComponent(Container cont,Component comp,
					int gridX, int gridY, int gridW, int gridH, 
					int anchor, int fill, double weightX, double weightY,
					int margT, int margB, int margL, int margR,
					int intPadX, int intPadY)  {
		
		Insets marg = new Insets(margT,margL,margB,margR);

		gbc.anchor = anchor;
		gbc.fill = fill;
		gbc.gridheight = gridH;
		gbc.gridwidth = gridW;
		gbc.gridx = gridX;
		gbc.gridy = gridY;
		gbc.insets = marg;
		gbc.ipadx = intPadX;
		gbc.ipady = intPadY;
		gbc.weightx = weightX;
		gbc.weighty = weightY;

		gbl.setConstraints(comp,gbc);
		cont.add(comp);		
	}


	//-----------------------------------------------------------------------
	//					setLayout
	//_______________________________________________________________________	
	private void setLayout()  {
		int		mT=0,mB=0,mL=0,mR=0;
		double 	w0=0,w1=1;

	if(initCount>1)	{
		gbl = new GridBagLayout();
		gbc = new GridBagConstraints();	
	}
	else {
		scrbar_m1.setLineIncrement(10);
		scrbar_m2.setLineIncrement(10);
		
		

		setBackground(new Color(0Xd0d0d0));
		// adapt fontSize to screenresolution
		if ( tk.getScreenSize().height < 700 )  {
			fontSize = 8;
			Graph.margL = 30;
			Graph.margT = 30;
			Graph.margB = 25;
			Graph.margR = 145;
			setFont(new Font("Courier",Font.BOLD, 10));
			graph.setFont(new Font("Courier",Font.BOLD, 9));
		}
		else if ( tk.getScreenSize().height < 800 )  {
			fontSize = 10;
			Graph.margL = 40;
			Graph.margT = 30;
			Graph.margB = 35;
			Graph.margR = 140;
			setFont(new Font("Helvetica",Font.PLAIN, 11));
			graph.setFont(new Font("Helvetica",Font.PLAIN, 9));
		}
		else  {
			fontSize = 12;
			Graph.margL = 50;
			Graph.margT = 30;
			Graph.margB = 35;
			Graph.margR = 150;
			setFont(new Font("Helvetica",Font.PLAIN, 12));
			graph.setFont(new Font("Helvetica",Font.PLAIN, 12));
		}
		Graph.fm = getFontMetrics( graph.getFont() );
		Graph.txtBoxW = Graph.fm.stringWidth("-9.99") + 5;
		Graph.txtBoxH = Graph.fm.getAscent() + 2;

		regFont	= new Font("Helvetica", Font.PLAIN, fontSize );
		boldFont = new Font("Helvetica", Font.BOLD, fontSize );
		
		labParameters.setFont(new Font("Helvetica",Font.BOLD, fontSize + 4));
		labAnimation.setFont(new Font("Helvetica",Font.BOLD, fontSize + 4));
		labOptions.setFont(new Font("Helvetica",Font.BOLD, fontSize + 4));
		labGraphType.setFont(new Font("Helvetica",Font.BOLD, fontSize + 4));
		labClone.setFont(new Font("Helvetica",Font.BOLD, fontSize + 4));
		labCloneGraph.setFont(new Font("Helvetica",Font.BOLD, fontSize + 4));
		labClonePosition.setFont(new Font("Helvetica",Font.PLAIN, fontSize + 2));
		labCloneRotation.setFont(new Font("Helvetica",Font.PLAIN, fontSize + 2));

		textCurTime.setBackground(new Color(0Xd0d0d0));
		textCurTime.setText("     ");
		textCurTime.disable();

		// Parameters
		panParam.setLayout(gbl);
		addComponent(panParam,labParameters,	0,0,3,1,gbc.CENTER,gbc.NONE,w0,w1,mT,mB,mL,mR,0,0);	
		addComponent(panParam,labBlank1Param,	0,1,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panParam,labArm1Param,		1,1,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panParam,labArm2Param,		2,1,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);

		addComponent(panParam,labLength,		0,2,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panParam,text_a1,			1,2,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panParam,text_a2,			2,2,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);

		addComponent(panParam,labWidth,			0,3,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panParam,text_b1,			1,3,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panParam,text_b2,			2,3,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);

		addComponent(panParam,labMass,			0,4,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panParam,text_mArm1,		1,4,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panParam,text_mArm2,		2,4,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);

		addComponent(panParam,labExtMass,		0,5,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panParam,text_m1,			1,5,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panParam,text_m2,			2,5,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);

		addComponent(panParam,labPosExtMass,	0,6,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panParam,scrbar_m1,		1,6,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panParam,scrbar_m2,		2,6,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);

		addComponent(panParam,labFriction,		0,7,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panParam,text_k1,			1,7,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panParam,text_k2,			2,7,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);

		addComponent(panParam,labM1Big,			0,8,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panParam,text_m1Big,		1,8,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panParam,btnReset,			2,8,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT+2,mB+2,mL,mR,0,0);
	

		// Animation
		panAnim.setLayout(gbl);
		addComponent(panAnim,labAnimation,		0,0,4,1,gbc.CENTER,gbc.NONE,w0,w1,mT,mB,mL,mR,0,0);


		addComponent(panAnim,labGraphTime,		0,1,1,1,gbc.WEST,gbc.NONE,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panAnim,textGraphTime,		1,1,1,1,gbc.WEST,gbc.NONE,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panAnim,labCurTime,		2,1,1,1,gbc.WEST,gbc.NONE,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panAnim,textCurTime,		3,1,1,1,gbc.WEST,gbc.NONE,w0,w1,mT,mB,mL,mR,0,0);

		addComponent(panAnim,labPosition,		0,2,4,1,gbc.WEST,gbc.NONE,w0,w1,mT,mB,mL,mR,0,0);

		addComponent(panAnim,labArm1Pos,		0,3,1,1,gbc.EAST,gbc.NONE,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panAnim,textPosArm1,		1,3,1,1,gbc.WEST,gbc.NONE,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panAnim,labArm2Pos,		2,3,1,1,gbc.EAST,gbc.NONE,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panAnim,textPosArm2,		3,3,1,1,gbc.WEST,gbc.NONE,w0,w1,mT,mB,mL,mR,0,0);

		addComponent(panAnim,labRotation,		0,4,4,1,gbc.WEST,gbc.NONE,w0,w1,mT,mB,mL,mR,0,0);

		addComponent(panAnim,labArm1Rot,		0,5,1,1,gbc.EAST,gbc.NONE,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panAnim,textRotArm1,		1,5,1,1,gbc.WEST,gbc.NONE,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panAnim,labArm2Rot,		2,5,1,1,gbc.EAST,gbc.NONE,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panAnim,textRotArm2,		3,5,1,1,gbc.WEST,gbc.NONE,w0,w1,mT,mB,mL,mR,0,0);

		// Buttons
		panBtnAnim.setLayout(gbl);
		addComponent(panBtnAnim,btnStart,		0,0,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,22,0);
		addComponent(panBtnAnim,btnPause,		1,0,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,22,0);
		addComponent(panBtnAnim,btnStop,		2,0,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,22,0);
		addComponent(panBtnAnim,btnExit,		3,0,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,22,0);

		// Options
		panOptions.setLayout(gbl);
		addComponent(panOptions,labOptions,		0,0,2,1,gbc.CENTER,gbc.NONE,w0,w1,mT,mB,mL,mR,0,0);		

		addComponent(panOptions,chkboxRunGraph,	0,1,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panOptions,chkboxClone,	1,1,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);

		addComponent(panOptions,labOptArm2,		0,2,2,1,gbc.WEST,gbc.NONE,w0,w1,mT,mB,mL,mR,0,0);

		addComponent(panOptions,chkboxArm2Rel,	0,3,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panOptions,chkboxArm2Abs,	1,3,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);
		
		// GraphType
		panGraph.setLayout(gbl);
		addComponent(panGraph,labGraphType,		0,0,2,1,gbc.CENTER,gbc.NONE,w0,w1,mT,mB,mL,mR,0,0);

		addComponent(panGraph,chkboxEnergy,		0,1,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panGraph,chkboxNone,		1,1,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);

		addComponent(panGraph,chkboxPos_Time,	0,2,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panGraph,chkboxPos2_Pos1,	1,2,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);

		addComponent(panGraph,chkboxRot_Time,	0,3,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panGraph,chkboxRot2_Rot1,	1,3,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);

		addComponent(panGraph,chkboxE1E2_Time,	0,4,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panGraph,chkboxPosTorus,	1,4,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);

		addComponent(panGraph,chkboxEkEp_Time,	0,5,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panGraph,chkboxRot1_Pos1,	1,5,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);

		addComponent(panGraph,chkboxEkp12_Time, 0,6,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panGraph,chkboxRot2_Pos2,  1,6,1,1,gbc.WEST,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,0,0);

		// Clone
		panClone.setLayout(gbl);

		addComponent(panClone,labClone,			0,0,4,1,gbc.CENTER,gbc.NONE,w0,w1,mT,mB,mL,mR,0,0);

		addComponent(panClone,labClonePos,		0,1,4,1,gbc.WEST,gbc.NONE,w0,w1,mT,mB,mL,mR,0,0);

		addComponent(panClone,labClonePosArm1,	0,2,1,1,gbc.EAST,gbc.NONE,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panClone,textDposArm1,		1,2,1,1,gbc.WEST,gbc.NONE,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panClone,labClonePosArm2,	2,2,1,1,gbc.EAST,gbc.NONE,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panClone,textDposArm2,		3,2,1,1,gbc.WEST,gbc.NONE,w0,w1,mT,mB,mL,mR,0,0);

		addComponent(panClone,labCloneRot,		0,3,4,1,gbc.WEST,gbc.NONE,w0,w1,mT,mB,mL,mR,0,0);
	
		addComponent(panClone,labCloneRotArm1,	0,4,1,1,gbc.EAST,gbc.NONE,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panClone,textDrotArm1,		1,4,1,1,gbc.WEST,gbc.NONE,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panClone,labCloneRotArm2,	2,4,1,1,gbc.EAST,gbc.NONE,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panClone,textDrotArm2,		3,4,1,1,gbc.WEST,gbc.NONE,w0,w1,mT,mB,mL,mR,0,0);

		addComponent(panClone,labCloneGraph,	0,5,4,1,gbc.CENTER,gbc.NONE,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panClone,labClonePosition,	0,6,2,1,gbc.CENTER,gbc.NONE,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(panClone,labCloneRotation,	2,6,2,1,gbc.CENTER,gbc.NONE,w0,w1,mT,mB,mL,mR,0,0);

		addComponent(panClone,chkboxPosArm1,	0,7,1,1,gbc.CENTER,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,10,0);
		addComponent(panClone,chkboxPosArm2,	1,7,1,1,gbc.CENTER,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,10,0);		
		addComponent(panClone,chkboxRotArm1,	2,7,1,1,gbc.CENTER,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,10,0);
		addComponent(panClone,chkboxRotArm2,	3,7,1,1,gbc.CENTER,gbc.HORIZONTAL,w0,w1,mT,mB,mL,mR,10,0);

		//GraphClone
		panGraphClone.setLayout(cardLayout);
		panGraphClone.add("Graph",panGraph);
		panGraphClone.add("Clone",panClone);

		pendulum.setBackground(Color.lightGray);
		graph.setBackground(Color.lightGray);

		panTorusOpt.setLayout( new BorderLayout() );
		panTorusOpt.add("West",chkboxCircles );
		panTorusOpt.add("East",chkboxBackside );

		graph.setLayout( new BorderLayout() );
		graph.add("South",panTorusOpt);		

	}		
		// Layout for application		
		setLayout(gbl);
		setBackground(new Color(0Xd0d0d0));
		pendulum.setBackground(Color.lightGray);
		graph.setBackground(Color.lightGray);

		addComponent(this,panParam,				0,0,1,1,gbc.CENTER,gbc.NONE,w0,w1,mT,mB,mL,mR,0,0);
		addComponent(this,panAnim,				0,1,1,1,gbc.CENTER,gbc.NONE,w0,0.7*w1,mT,mB,mL,mR,0,0);
		addComponent(this,panBtnAnim,			0,2,1,1,gbc.CENTER,gbc.HORIZONTAL,w0,0.15*w1,mT,mB,mL,mR,0,0);
		addComponent(this,pendulum,				1,0,1,3,gbc.CENTER,gbc.BOTH,w1,w1,5,5,5,5,0,0);

		addComponent(this,panOptions,			0,3,1,1,gbc.CENTER,gbc.HORIZONTAL,w0,0.7*w1,mT,mB,mL,mR,0,0);
		addComponent(this,panGraphClone,		0,4,1,1,gbc.CENTER,gbc.NONE,w0,1.2*w1,mT,mB,mL,mR,0,0);
		addComponent(this,graph,				1,3,1,2,gbc.CENTER,gbc.BOTH,w1,w1,5,5,5,5,0,0);
		cardLayout.show(panGraphClone,"Graph");		
  }

	//-----------------------------------------------------------------------
	//					setGraphType
	//_______________________________________________________________________	
	public static void setGraphType()  {
		
		if ( chkboxNone.getState() ) 
			Graph.graphType = "None";
		else if ( chkboxEnergy.getState() ) 
			Graph.graphType = "Ebox";
		else if ( chkboxPos_Time.getState()  || chkboxRot_Time.getState()  || 
			 	  chkboxE1E2_Time.getState() || chkboxEkEp_Time.getState() || 
				  chkboxEkp12_Time.getState()|| chkboxPosArm1.getState()   ||
				  chkboxPosArm2.getState()	 || chkboxRotArm1.getState()   ||
				  chkboxRotArm2.getState()  )
			Graph.graphType = "Time";
		else if ( chkboxPos2_Pos1.getState() || chkboxRot2_Rot1.getState() || 
			  	  chkboxRot1_Pos1.getState() || chkboxRot2_Pos2.getState()   ) 
			Graph.graphType = "Phase";
		else if ( chkboxPosTorus.getState() )
			Graph.graphType = "Torus";
	}

	//-----------------------------------------------------------------------
	//					readParameters
	//_______________________________________________________________________	
	public static void readParameters() {

		Pendulum.a1 = (new Double(text_a1.getText())).doubleValue() / 1000;
		Pendulum.r1 = Pendulum.a1 / 2;
		Pendulum.a2 = (new Double( text_a2.getText())).doubleValue() / 1000;
		Pendulum.r2 = Pendulum.a2 / 2;
		Pendulum.b1 = (new Double( text_b1.getText())).doubleValue() / 1000;
		Pendulum.b2 = (new Double( text_b2.getText())).doubleValue() /1000;
		Pendulum.mArm1 = (new Double( text_mArm1.getText())).doubleValue() / 1000;
		Pendulum.mArm2 = (new Double( text_mArm2.getText())).doubleValue() / 1000;
		Pendulum.m1 = (new Double( text_m1.getText())).doubleValue() / 1000;
		Pendulum.m2 = (new Double( text_m2.getText())).doubleValue() / 1000;
		Pendulum.m1Pos = Pendulum.r1 * (double) (scrbar_m1.getValue()) / 
						(double) (scrbar_m1.getMaximum());
		Pendulum.m2Pos = Pendulum.r2 * (double) (scrbar_m2.getValue()) / 
						(double) (scrbar_m2.getMaximum());
		Pendulum.k1 = (new Double( text_k1.getText())).doubleValue();
		Pendulum.k2 = (new Double( text_k2.getText())).doubleValue();
		Pendulum.m1Big = (new Double( text_m1Big.getText())).doubleValue() / 1000;

		Pendulum.setConstants();
	}

	//-----------------------------------------------------------------------
	//					readStartvalues
	//_______________________________________________________________________	
	public static void readStartvalues() {

		double	pos1 = ( new Double(textPosArm1.getText()) ).doubleValue(),
				pos2 = ( new Double(textPosArm2.getText()) ).doubleValue(),
				rot1 = ( new Double(textRotArm1.getText()) ).doubleValue(),
				rot2 = ( new Double(textRotArm2.getText()) ).doubleValue();

		Graph.graphTime = ( new Double(textGraphTime.getText()) ).doubleValue();		
		Graph.phi1_start[origin] = Math.PI / 180 * (pos1 - 90);
		Graph.phi2_start[origin] = Math.PI / 180 * (pos2 - 90) - Graph.phi1_start[origin];
		Graph.w1_start[origin] = 2 * Math.PI * rot1 ;
		Graph.w2_start[origin] = 2 * Math.PI * rot2 ;
		Graph.Dphi1 =  Math.PI/180 *( new Double(textDposArm1.getText()) ).doubleValue();
		Graph.Dphi2 =  Math.PI/180 *( new Double(textDposArm2.getText()) ).doubleValue();
		Graph.Dw1 =    Math.PI/180 *( new Double(textDrotArm1.getText()) ).doubleValue();
		Graph.Dw2 =	 Math.PI/180 *( new Double(textDrotArm2.getText()) ).doubleValue();
		Graph.phi1_start[clone] = Graph.phi1_start[origin] + Graph.Dphi1;
		Graph.phi2_start[clone] = Graph.phi2_start[origin] + Graph.Dphi2;
		Graph.w1_start[clone]   = Graph.w1_start[origin] + Graph.Dw1;
		Graph.w2_start[clone] =   Graph.w2_start[origin] + Graph.Dw2;
	}

	//-----------------------------------------------------------------------
	//							setTextFields
	//_______________________________________________________________________	
	private void setTextFields()  {
		double	pos1,pos2,rot1,rot2;
		
		text_a1.setText( String.valueOf(1000*Pendulum.a1).substring(0,3) );
		text_a2.setText( String.valueOf(1000*Pendulum.a2).substring(0,3) );
		text_b1.setText( String.valueOf(1000*Pendulum.b1).substring(0,2) );
		text_b2.setText( String.valueOf(1000*Pendulum.b2).substring(0,2) );
		text_mArm1.setText( String.valueOf(1000*Pendulum.mArm1).substring(0,3) );
		text_mArm2.setText( String.valueOf(1000*Pendulum.mArm2).substring(0,3) );
		text_m1.setText( String.valueOf(1000*Pendulum.m1).substring(0,3) );
		text_m2.setText( String.valueOf(1000*Pendulum.m2).substring(0,3) );
		text_k1.setText( String.valueOf(Pendulum.k1).substring(0,1) );
		text_k2.setText( String.valueOf(Pendulum.k2).substring(0,1) );
		text_m1Big.setText( String.valueOf(1000*Pendulum.m1Big).substring(0,3) );
		
		pos1 = Graph.phi1_start[origin]*180/Math.PI + 90;
		pos2 = (Graph.phi1_start[origin] + Graph.phi2_start[origin])*180/Math.PI + 90;
		rot1 = Graph.w1_start[origin] /(2*Math.PI);
		rot2 = Graph.w2_start[origin] /(2*Math.PI);

		textGraphTime.setText( String.valueOf(Graph.graphTime).substring(0,2) );
		textPosArm1.setText( String.valueOf(pos1).substring(0,2) );
		textPosArm2.setText( String.valueOf(pos2).substring(0,3) );
		textRotArm1.setText( String.valueOf(rot1).substring(0,4) );
		textRotArm2.setText( String.valueOf(rot2).substring(0,3) );

		textDposArm1.setText( String.valueOf(Graph.Dphi1) );
		textDposArm2.setText( String.valueOf(Graph.Dphi2) );
		textDrotArm1.setText( String.valueOf(Graph.Dw1) );
		textDrotArm2.setText( String.valueOf(Graph.Dw2) );
	}

	//-----------------------------------------------------------------------
	//					numKey
	//_______________________________________________________________________	
	public boolean numKey(int key) {

		return ( Character.isDigit((char)key)  ||  key == (int)'-' );
	}

	//-----------------------------------------------------------------------
	//					handleEvent
	//_______________________________________________________________________	
	public boolean handleEvent(Event evt) {

		if (evt.id == Event.SCROLL_ABSOLUTE ||	
			evt.id == Event.SCROLL_PAGE_DOWN ||	evt.id == Event.SCROLL_PAGE_UP ||
			evt.id == Event.SCROLL_LINE_DOWN ||	evt.id == Event.SCROLL_LINE_UP)  {
			readParameters();
			readStartvalues();
			Pendulum.drawPendulum(Graph.phi1_start[origin], Graph.phi2_start[origin]);
		}
		else if (evt.id == Event.KEY_PRESS)  {
			if ( evt.target.getClass().getName() == "java.awt.TextField" && 
			!txtActive && numKey(evt.key) )  {	// 1st numkey pressed
				((TextField)evt.target).setBackground(Color.white);
				txtActive = true;
				((TextField)(evt.target)).setText("");
			}
			else {
				if ( evt.key == (int)'r' || evt.key == (int)'R' )		
					reset();
				else if ( evt.key == (int)'d' || evt.key == (int)'D' )	
					textPosArm1.requestFocus();
				else if ( evt.key == (int)'l' || evt.key == (int)'L' )	
					textRotArm1.requestFocus();
				else if ( evt.key == (int)'g' || evt.key == (int)'G' )	
					textGraphTime.requestFocus();
				else if ( evt.key == (int)'p' || evt.key == (int)'P' )	
					Graph.pauseContinue();
				else if ( evt.key == (int)'c' || evt.key == (int)'C' )	
					Graph.pauseContinue();
				else if ( evt.key == (int)'s' || evt.key == (int)'S' )	
					if (Graph.phase == 0)
						Graph.start();
					else
						Graph.stop();
				else if (evt.key == (int)'x' || evt.key == (int)'X' )  {
					URL		url = null;

//					try { url = new URL( "file:///C:/PM/PMprojects/Web/Index.htm"); }
					try { url = new URL( "http://www.PMprojects.net/Pendulum/Index.htm"); }
					catch ( MalformedURLException e) {;}
					getAppletContext().showDocument( url );
					Runtime.getRuntime().exit(status);
				}
				if (Character.isLetter((char)evt.key))				
					return true;
			}			
		}	
		else if  (evt.id == Event.LOST_FOCUS &&	 
		(evt.target.getClass().getName() == "java.awt.TextField") )  {
			((TextField)evt.target).setBackground(Color.white);
			txtActive = false;
			ifNewValRespond(evt);
		}	
		else if  (evt.id == Event.GOT_FOCUS &&	 
		(evt.target.getClass().getName() == "java.awt.TextField") )  {
			((TextField)evt.target).setBackground(Color.cyan);
		}			
	return super.handleEvent(evt);
	}

	//-----------------------------------------------------------------------
	//					action
	//_______________________________________________________________________	
	public boolean action(Event evt, Object obj) {
		int		mT=1,mB=1,mL=1,mR=1,
				w0=0,w1=1;
		
		boolean chkbox;
		String strBox ="java.awt.Checkbox";

		chkbox = ( strBox.compareTo(evt.target.getClass().getName()) == 0 );
		if (chkbox)   {
			if (  ((Checkbox)evt.target).getCheckboxGroup() == graphGroup )
				if ( chkboxClone.getState() == true )
					prevClone = (Checkbox)evt.target;
				else
					prevGraph = (Checkbox)evt.target;
		}			
		if (evt.target.getClass().getName() == "java.awt.TextField")   {
			txtActive = false;
			ifNewValRespond(evt);
		}
		else if (evt.target == chkboxClone)  {
			if ( chkboxClone.getState() == true )  {
				prevClone.setState(true);
				cardLayout.show(panGraphClone,"Clone");
			}
			if ( chkboxClone.getState() == false )  {
				prevGraph.setState(true);
				cardLayout.show(panGraphClone,"Graph");
			}
		}
		if (evt.target == btnReset)  			reset();
		else if (evt.target == btnStart)  		Graph.start();
		else if (evt.target == btnPause)  		Graph.pauseContinue();
		else if (evt.target == btnStop)  		Graph.stop();
		else if (evt.target == btnExit )  {		
			URL		url = null;
//			try { url = new URL( "file:///C:/PM/PMprojects/Web/Index.htm"); }
			try { url = new URL( "http://www.PMprojects.net/Pendulum/Index.htm"); }
			catch ( MalformedURLException e) {;}
			getAppletContext().showDocument( url );
			Runtime.getRuntime().exit(status);
		}
		else if (chkbox)  {
			if ( Graph.phase > 0 && !Graph.pause)  {				
				Graph.suspended = true;
				Graph.threadAnim.suspend();
			}
			setGraphType();
			Graph.arm2Abs = chkboxArm2Abs.getState();
			Graph.runGraph = chkboxRunGraph.getState();
			graph.repaint();
		}
		return false;
	}

	//-----------------------------------------------------------------------
	//					reset()
	//_______________________________________________________________________	
	public void reset()  {

		if (Graph.phase > 0)
			Graph.stop();	
		Pendulum.setStandard();
		Pendulum.setConstants();
		Graph.setStandard();
		textCurTime.setText("");
		setTextFields();
		scrbar_m1.setValue(50);
		scrbar_m2.setValue(50);
		Graph.getEnergyMaxMin(); 
		Pendulum.drawPendulum(Graph.phi1_start[origin], Graph.phi2_start[origin]);
		App.graph.repaint();
	}

	//-----------------------------------------------------------------------
	//					ifNewValRespond
	//_______________________________________________________________________	
	public void ifNewValRespond(Event evt)  {
		boolean	equals = false;

		double  newVal;

		newVal = (  new Double( ((TextField)evt.target).getText() )  ).doubleValue();
		if		(evt.target == text_a1)  
			equals = (newVal/1000 == Pendulum.a1);
		else if (evt.target == text_b1)  
			equals = (newVal/1000 == Pendulum.b1);
		else if (evt.target == text_mArm1)  
			equals = (newVal/1000 == Pendulum.mArm1);
		else if (evt.target == text_m1)  
			equals = (newVal/1000 == Pendulum.m1);
		else if (evt.target == text_m1Big)  
			equals = (newVal/1000 == Pendulum.m1Big);
		else if (evt.target == text_k1)  
			equals = (newVal == Pendulum.k1);
		else if	(evt.target == text_a2)  
			equals = (newVal/1000 == Pendulum.a2);
		else if (evt.target == text_b2)  
			equals = (newVal/1000 == Pendulum.b2);
		else if (evt.target == text_mArm2)  
			equals = (newVal/1000 == Pendulum.mArm2);
		else if (evt.target == text_m2)  
			equals = (newVal/1000 == Pendulum.m2);
		else if (evt.target == text_mArm1)  
			equals = (newVal/1000 == Pendulum.mArm2);
		else if (evt.target == text_k1)  
			equals = (newVal == Pendulum.k2);
		else if (evt.target == textGraphTime)  
			equals = (newVal == Graph.graphTime) ;
		else if (evt.target == textPosArm1)  
			equals = (Math.PI / 180 * (newVal - 90) == Graph.phi1_start[origin]);
		else if (evt.target == textPosArm2)  
			equals = (Math.PI / 180 * (newVal - 90) - Graph.phi1_start[origin] 
												    == Graph.phi2_start[origin]);
		else if (evt.target == textRotArm1)  
			equals = (2 * Math.PI * newVal == Graph.w1_start[origin]) ;
		else if (evt.target == textRotArm2)  
			equals = (2 * Math.PI * newVal == Graph.w2_start[origin]) ;

		if (!equals)  {
			readParameters();
			readStartvalues();
			Graph.getEnergyMaxMin(); 
			Pendulum.drawPendulum(Graph.phi1_start[origin],Graph.phi2_start[origin]);			
			if ( Graph.phase > 0 )  {
				Graph.suspended = true;
				Graph.threadAnim.suspend();
				Graph.restartAnimation();
			}
			App.graph.repaint();

		}
	}

/*
	//-----------------------------------------------------------------------
	//					main
	//_______________________________________________________________________	
	public static void main(String args[])  {
		Frame		frame	= new Frame("Project P");
		App			app		= new App();

		app.resize(800,600);
		app.init();		
		frame.setLayout( new FlowLayout() );
		frame.add(app);
		frame.pack();
		frame.show();
	}
*/	
}


	//-----------------------------------------------------------------------
	//					UnderlinedLabel
	//_______________________________________________________________________	
	class UnderlinedLabel extends Label  {
		char		chr;
	
	public UnderlinedLabel(String text,char c){
			super(text);    
			chr = c;
		}

		public void paint(Graphics g) {

			super.paint(g);
			if (this.chr == 'p')	g.drawLine(94,17,100,17);
			if (this.chr == 'r')	g.drawLine(93,17,96,17);
			if (this.chr == 'g')	g.drawLine(3,17,9,17);
		}
	}

	//-----------------------------------------------------------------------
	//					UnderlinedButton
	//_______________________________________________________________________	
	class UnderlinedButton extends Button  {

		public UnderlinedButton(String text){
			super(text);    
		}

		public void setLabel(String label)  {
			super.setLabel(label);
		}

		public void paint(Graphics g) {

			super.paint(g);
			if (this.isEnabled() ) {
				if (this.getLabel() == "Reset")   g.drawLine(8,17,15,17);
				if (this.getLabel() == "Start")   g.drawLine(18,17,25,17);
				if (this.getLabel() == "Pause")   g.drawLine(17,17,25,17);
				if (this.getLabel() == "Continue")g.drawLine(11,17,18,17);
				if (this.getLabel() == "Stop")    g.drawLine(18,17,25,17);
				if (this.getLabel() == "Exit")    g.drawLine(25,17,31,17);
			}
		}
	}
