import java.io.*;
import java.awt.*;
import java.lang.Math;



// ------------- FG ---------------------------------------------------------------
class FG {
	double	f,g;
}


// ------------- GraphInfo --------------------------------------------------------
class GraphInfo  {
		String	txt;	
		Color	col;
		boolean bold;
		}

// ------------- Graph --------------------------------------------------------
public class Graph extends Panel implements Runnable {

	static FontMetrics
					fm;

	static Image	imageBuf,
					imageTorus;

	static Thread	threadAnim; 

	static Graphics	g,
					gBuf;

	static boolean	virgin,
					pause,
					suspended,
					arm2Abs,
					runGraph,
					boxPosUp;

	static final int
					txtH = 10,
					axisExtra = 6,
					tickLen = 4,
					origin = 0,
					clone = 1;

	static final double	
					dt=0.001,	// timeStep in RungeKutta
					frameDuration=0.02; 


	static int		txtBoxW = 0,
					txtBoxH = 0,
					margL,
					margT,
					margB,
					margR,
					infoBoxSize,
					nStepsPerPhase,
					nStepsPerFrame,
					nFramesPerPhase,
					curFrameNo,
					phase,
					milliSecs,
					pixMaxLeft,
					pixMaxRight,
					pixMaxDown,
					pixMaxUp,
					nGraphs,
					fmH,
					curWidth,
					curHeight,
					pixE0,pixX0,pixY0,
					xUL,yUL,
					xAxisPos,
					yAxisPos,
					ptX[] = new int[5],
					ptY[] = new int[5],					
					ptXprev[] = new int[5],
					ptYprev[] = new int[5];


	static double	boxW,
					boxSep,
					graphTime,
					oldGraphTime,
					curTstart,
					//startValues
					phi1_start[] = new double[2],
					phi2_start[] = new double[2],
					w1_start[] = new double[2],
					w2_start[] = new double[2],
					Dphi1 = 0,
					Dphi2 = 0,
					Dw1 = 0,
					Dw2 = 0,
					//EnergyValues
					Ek,Ek1,Ek2,
					Ep,Ep1,Ep2,
					Etot,E1,E2,
					//MinMaxValues
					pos1_min[] =    new double[2],
					pos1_max[] =    new double[2],
					pos2Abs_min[] = new double[2],
					pos2Abs_max[] = new double[2],
					pos2Rel_min[] = new double[2],
					pos2Rel_max[] = new double[2],
					pos12Abs_min,
					pos12Abs_max,
					pos12Rel_min,
					pos12Rel_max,
					rot1_min[] =    new double[2],
					rot1_max[] =    new double[2],
					rot2Abs_min[] = new double[2],
					rot2Abs_max[] = new double[2],
					rot2Rel_min[] = new double[2],
					rot2Rel_max[] = new double[2],
					rot12Abs_min,
					rot12Abs_max,
					rot12Rel_min,
					rot12Rel_max,
					E12_min,
					E12_max,
					Ekp_min,
					Ekp_max,
					Ekp12_min,
					Ekp12_max,
					Emin,
					Emax,	// MinMaxValues for energychart
					yMin,
					yMax,
					xMin,
					xMax,
					y[][][];

	static String	strYaxis,strXaxis,
					strYmin,strYmax,
					strXmin,strXmax,
					strX[] = new String[4],
					graphType = new String();

	static GraphInfo
					graphInfo[] = new GraphInfo[5];


	//-----------------------------------------------------------------------
	//								Graph
	//_______________________________________________________________________
	Graph()  {
		int i;

		for(i=0; i<=4; i++)  
			graphInfo[i] = new GraphInfo();
		fmH = 8;
		virgin = true;
		pause = false;
		suspended = false;
		phase = 0;
		curFrameNo = 0;
		setStandard();
		oldGraphTime = 10;
		nStepsPerPhase = (int)(graphTime/dt);
		nStepsPerFrame = (int)(frameDuration/dt);
		nFramesPerPhase = (int)(graphTime/frameDuration);
		y = new double[2][5][nFramesPerPhase];
		y[origin][1][0] = phi1_start[origin];
		y[origin][2][0] = phi2_start[origin];
		y[origin][3][0] = w1_start[origin];
		y[origin][4][0] = w2_start[origin];
		getEnergyMaxMin(); 
	}

	//-----------------------------------------------------------------------
	//								setStandard
	//_______________________________________________________________________
	static public void setStandard()  {

		graphTime = 10;
		phi1_start[origin] = Math.PI*(40 - 90)/180;
		phi2_start[origin] = Math.PI*(-20 - 90)/180 -phi1_start[origin];
		w1_start[origin]   = 2*Math.PI * (-0.3);		
		w2_start[origin]   = 2*Math.PI * 0.3;	
		Dphi1 = 0.0;
		Dphi2 = 0.0;
		Dw1 = 0.0;
		Dw2 = 0.0;
		phi1_start[clone] = phi1_start[origin] + Math.PI/180 * Dphi1;
		phi2_start[clone] = phi2_start[origin] + Math.PI/180 * Dphi2;
		w1_start[clone]   = w1_start[origin] + Math.PI/180 * Dw1;
		w2_start[clone]   = w2_start[origin] + Math.PI/180 * Dw2;

	}

	//-----------------------------------------------------------------------
	//					resetAnimation
	//_______________________________________________________________________
	static public void resetAnimation()  {

		phase = 0;
		milliSecs = 0;
		curFrameNo = 0;
		curTstart = 0;
		nStepsPerPhase = (int)(graphTime/dt);
		nStepsPerFrame = (int)(frameDuration/dt);
		nFramesPerPhase = (int)(graphTime/frameDuration);		
		if (graphTime>oldGraphTime )  
			y = new double[2][5][nFramesPerPhase];
		oldGraphTime = graphTime;
		y[origin][1][0] = phi1_start[origin];
		y[origin][2][0] = phi2_start[origin];
		y[origin][3][0] = w1_start[origin];
		y[origin][4][0] = w2_start[origin];
		y[clone][1][0] = phi1_start[clone];
		y[clone][2][0] = phi2_start[clone];
		y[clone][3][0] = w1_start[clone];
		y[clone][4][0] = w2_start[clone];
	}

	//-----------------------------------------------------------------------
	//					restartAnimation
	//_______________________________________________________________________
	static public void restartAnimation()  {
		double ratioDone;
		
		ratioDone = (double)curFrameNo / (double)nFramesPerPhase;
		nStepsPerPhase = (int)(graphTime/dt);
		nStepsPerFrame = (int)(frameDuration/dt);
		nFramesPerPhase = (int)(graphTime/frameDuration);		
		curFrameNo = (int) (ratioDone * nFramesPerPhase);
		if (graphTime>oldGraphTime )  
			y = new double[2][5][nFramesPerPhase];
		oldGraphTime = graphTime;
		Runge_Kutta(y[origin], dt, nStepsPerPhase);
		Runge_Kutta(y[clone], dt, nStepsPerPhase);
		getMinMax();
	}



	//-----------------------------------------------------------------------
	//								paint
	//_______________________________________________________________________
	public void paint(Graphics g)  {		

		if (imageTorus==null || curWidth != size().width || 
								curHeight != size().height)  {

			curWidth = App.graph.size().width;
			curHeight = App.graph.size().height;
			pixMaxDown = curHeight-margB;
			pixMaxUp = margT;
			pixMaxLeft = margL;
			pixMaxRight = curWidth - margR;
			infoBoxSize = curHeight / 14;
			boxSep = (double)(pixMaxRight - pixMaxLeft) / 39.0;
			boxW = 2* boxSep;
			Torus.setTorusData();
			imageTorus = App.graph.createImage( curWidth, curHeight );
			gBuf = imageTorus.getGraphics();
			Torus.drawTorus(gBuf);
			imageBuf = App.graph.createImage( curWidth, curHeight );
		}
		g.clearRect(0,0,curWidth,curHeight);
		g.setFont( App.regFont );
		if ( !(graphType =="Torus")) App.panTorusOpt.hide();
		if ( graphType == "None" )			;
		else if ( graphType == "Ebox" )		energyDiagram();
		else if ( graphType == "Time" )		initTimeGraph();
		else if ( graphType == "Phase" )	initPhaseGraph();		
		else if ( graphType == "Torus" )	initTorusGraph();
		if (suspended && !pause)  {
			suspended = false;
			threadAnim.resume();
		}
	}
	
	//-----------------------------------------------------------------------
	//								f_g
	//_______________________________________________________________________
	
	static private FG getFG(double y1,double y2,double y3,double y4)  {
		FG		fg = new FG();

		double	cos_y1,
				cos_y2,
				cos_y1py2,
				sin_y2,
				A,A1,A2,
				B,C,D,E,
				k1,k2;

		A =  Pendulum.constA;
		A1 = Pendulum.constA1;
		A2 = Pendulum.constA2;
		B =  Pendulum.constB;
		C =  Pendulum.constC;
		D =  Pendulum.constD;
		E =  Pendulum.constE;
		k1 = Pendulum.k1;
		k2 = Pendulum.k2;

		cos_y1 = Math.cos(y1);
		cos_y2 = Math.cos(y2);
		cos_y1py2 = Math.cos(y1+y2);
		sin_y2 = Math.sin(y2);
		fg.f = (2*C*D*cos_y1 + (4*C*(k1*A1+k2*A2) - k2*(4*C*C + B*B*cos_y2*cos_y2))*y3
				+ B*E*cos_y2*cos_y1py2 + 4*B*C*y3*y4*sin_y2
				+ (2*B*C - B*B*cos_y2)*y3*y3*sin_y2 + 2*B*C*y4*y4*sin_y2 ) 
				/ ((2*C - B*cos_y2)*(2*C - B*cos_y2) - 4*C*(A-B*cos_y2));
		fg.g = (2*(B*cos_y2 - A)*fg.f - 2*B*y3*y4*sin_y2 - B*y4*y4*sin_y2 - D*cos_y1
				- E*cos_y1py2 + 2*(k2*B*cos_y2 - k1*A1-k2*A2)*y3 - k2*(2*C-B*cos_y2)*y4) 
				/ (2*C - B*cos_y2);
		return (fg);
	}

	//-----------------------------------------------------------------------
	//								Runge_Kutta
	//_______________________________________________________________________

	static public void Runge_Kutta(double[][] y,double dt,int nSteps)  {
		int		i,
				stepNo,
				frameNo;

		double	yTmp[] = new double[5],
				k[][] = new double[5][5];

		FG		var = new FG();

		for (i=1; i<5; i++)
			yTmp[i] = y[i][0];
		for (stepNo=1; stepNo < nSteps ; stepNo++)  {
			var = getFG(yTmp[1], yTmp[2], yTmp[3], yTmp[4]);
			k[1][1] = yTmp[3];
			k[1][2] = yTmp[4];
			k[1][3] = var.f;
			k[1][4] = var.g;
			var = getFG(yTmp[1] + dt/2*k[1][1], yTmp[2] + dt/2*k[1][2],
						yTmp[3] + dt/2*k[1][3], yTmp[4] + dt/2*k[1][4]);
			k[2][1] = yTmp[3] + dt/2*k[1][3];
			k[2][2] = yTmp[4] + dt/2*k[1][4];
			k[2][3] = var.f;
			k[2][4] = var.g;
			var = getFG(yTmp[1] + dt/2*k[2][1], yTmp[2] + dt/2*k[2][2],
						yTmp[3] + dt/2*k[2][3], yTmp[4] + dt/2*k[2][4]);
			k[3][1] = yTmp[3] + dt/2*k[2][3];
			k[3][2] = yTmp[4] + dt/2*k[2][4];
			k[3][3] = var.f;
			k[3][4] = var.g;
			var = getFG(yTmp[1] + dt*k[3][1], yTmp[2] + dt*k[3][2],
						yTmp[3] + dt*k[3][3], yTmp[4] + dt*k[3][4]);
			k[4][1] = yTmp[3] + dt*k[3][3];
			k[4][2] = yTmp[4] + dt*k[3][4];
			k[4][3] = var.f;
			k[4][4] = var.g;
			yTmp[1] = yTmp[1] + dt/6 * ( k[1][1] + 2*k[2][1] + 2*k[3][1] + k[4][1] );
			yTmp[2] = yTmp[2] + dt/6 * ( k[1][2] + 2*k[2][2] + 2*k[3][2] + k[4][2] );
			yTmp[3] = yTmp[3] + dt/6 * ( k[1][3] + 2*k[2][3] + 2*k[3][3] + k[4][3] );
			yTmp[4] = yTmp[4] + dt/6 * ( k[1][4] + 2*k[2][4] + 2*k[3][4] + k[4][4] );
			if ( stepNo % nStepsPerFrame == 0 )  {
				frameNo = stepNo / nStepsPerFrame;
				for (i=1; i<5; i++) 
					y[i][frameNo] = yTmp[i];
			}
		}
	}

	//-----------------------------------------------------------------------
	//								energy
	//_______________________________________________________________________

	static public void energy(double phi1,double phi2,double w1,double w2)  {
		double			g=9.8,
						cos_phi2,
						sin_phi1;

		cos_phi2=Math.cos(phi2);
		sin_phi1=Math.sin(phi1);

		Ek1=Pendulum.constA1*w1*w1;
		Ek2=Pendulum.constA2*w1*w1-Pendulum.constB*w1*w1*cos_phi2+Pendulum.constC*w2*w2+
			(2*Pendulum.constC-Pendulum.constB*cos_phi2)*w1*w2;
		Ek=Ek1+Ek2;
		Ep1=(Pendulum.m1Big*Pendulum.r1+Pendulum.m1*Pendulum.m1Pos)*g*sin_phi1;
		Ep2=Pendulum.mArm2*g*(-Pendulum.r1*sin_phi1)+
			Pendulum.m2*g*(-Pendulum.r1*sin_phi1+Pendulum.m2Pos*Math.sin(phi1+phi2));
		Ep=Ep1+Ep2;
		E1=Ek1+Ep1;
		E2=Ek2+Ep2;
		Etot=Ek+Ep;
	}

	//-----------------------------------------------------------------------
	//								getEnergyMaxMin
	//_______________________________________________________________________

	static public void getEnergyMaxMin()  {

		energy(phi1_start[origin],phi2_start[origin],w1_start[origin],w2_start[origin]);

		Emin = Misc.mini4(Ek1,Ek2,Ep1,Ep2);
		Emin = Misc.mini4(Ep, Emin, 0, 0 );	// Force hor-axis to be in place
		Emax = Misc.maxi4(Ep1,Ep2,Ep,Ek);
		Emax = Misc.maxi4(Emax,E1,E2,Etot);
	}

	//-----------------------------------------------------------------------
	//								getMinMax
	//_______________________________________________________________________
	static public void getMinMax()  {
		double	Pi = Math.PI;

		int		frameNo,
				simNo;

		double	pos1[]		= new double[2],
				pos2Abs[]	= new double[2],
				pos2Rel[]	= new double[2],
				rot1[]		= new double[2],
				rot2Abs[]	= new double[2],
				rot2Rel[]	= new double[2],
				Ek_min,Ek_max,
				Ek1_min,Ek1_max,
				Ek2_min,Ek2_max,
				Ep_min,Ep_max,
				Ep1_min,Ep1_max,
				Ep2_min,Ep2_max,
				E1_min,E1_max,
				E2_min,E2_max,
				Etot_min,Etot_max;

		for (simNo=origin; simNo<=clone; simNo++)  {
			pos1_min[simNo] = y[simNo][1][0]+Pi/2;
			pos1_max[simNo] = y[simNo][1][0]+Pi/2;
			pos2Abs_min[simNo] = y[simNo][1][0]+y[simNo][2][0]+Pi/2;
			pos2Abs_max[simNo] = y[simNo][1][0]+y[simNo][2][0]+Pi/2;
			pos2Rel_min[simNo] = y[simNo][2][0];
			pos2Rel_max[simNo] = y[simNo][2][0];

			rot1_min[simNo] = y[simNo][3][0];
			rot1_max[simNo] = y[simNo][3][0];
			rot2Abs_min[simNo] = y[simNo][3][0]+y[simNo][4][0];
			rot2Abs_max[simNo] = y[simNo][3][0]+y[simNo][4][0];
			rot2Rel_min[simNo] = y[simNo][4][0];
			rot2Rel_max[simNo] = y[simNo][4][0];
		}

		energy(y[origin][1][0],y[origin][2][0],y[origin][3][0],y[origin][4][0]);

		Ek1_min = Ek1_max = Ek1;
		Ek2_min = Ek2_max = Ek2;
		Ep1_min = Ep1_max = Ep1;
		Ep2_min = Ep2_max = Ep2;
		E1_min = E1_max = E1;
		E2_min = E2_max = E2;
		Ek_min = Ek_max = Ek;
		Ep_min = Ep_max = Ep;
		Etot_min = Etot_max = Etot;

		for(frameNo = 0 ; frameNo < nFramesPerPhase ; frameNo += 1 )  {
			for (simNo=origin; simNo<=clone; simNo++)  {
				pos1[simNo] = y[simNo][1][frameNo]+Pi/2;
				pos2Abs[simNo] = y[simNo][1][frameNo]+y[simNo][2][frameNo]+Pi/2;
				pos2Rel[simNo] = y[simNo][2][frameNo];
				rot1[simNo] = y[simNo][3][frameNo];
				rot2Abs[simNo] = y[simNo][3][frameNo]+y[simNo][4][frameNo];
				rot2Rel[simNo] = y[simNo][4][frameNo];

				if (pos1[simNo] < pos1_min[simNo])			pos1_min[simNo] = pos1[simNo];
				if (pos1[simNo] > pos1_max[simNo])			pos1_max[simNo] = pos1[simNo];
				if (pos2Abs[simNo] < pos2Abs_min[simNo])	pos2Abs_min[simNo] = pos2Abs[simNo];
				if (pos2Abs[simNo] > pos2Abs_max[simNo])	pos2Abs_max[simNo] = pos2Abs[simNo];
				if (pos2Rel[simNo] < pos2Rel_min[simNo])	pos2Rel_min[simNo] = pos2Rel[simNo];
				if (pos2Rel[simNo] > pos2Rel_max[simNo])	pos2Rel_max[simNo] = pos2Rel[simNo];

				if (rot1[simNo] < rot1_min[simNo])			rot1_min[simNo] = rot1[simNo];
				if (rot1[simNo] > rot1_max[simNo])			rot1_max[simNo] = rot1[simNo];
				if (rot2Abs[simNo] < rot2Abs_min[simNo])	rot2Abs_min[simNo] = rot2Abs[simNo];
				if (rot2Abs[simNo] > rot2Abs_max[simNo])	rot2Abs_max[simNo] = rot2Abs[simNo];
				if (rot2Rel[simNo] < rot2Rel_min[simNo])	rot2Rel_min[simNo] = rot2Rel[simNo];
				if (rot2Rel[simNo] > rot2Rel_max[simNo])	rot2Rel_max[simNo] = rot2Rel[simNo];
			}
			energy(y[origin][1][frameNo],y[origin][2][frameNo],
				   y[origin][3][frameNo],y[origin][4][frameNo]);

			if (Ek1<Ek1_min)  Ek1_min = Ek1;
			if (Ek1>Ek1_max)  Ek1_max = Ek1;
			if (Ek2<Ek2_min)  Ek2_min = Ek2;
			if (Ek2>Ek2_max)  Ek2_max = Ek2;

			if (Ep1<Ep1_min)  Ep1_min = Ep1;
			if (Ep1>Ep1_max)  Ep1_max = Ep1;
			if (Ep2<Ep2_min)  Ep2_min = Ep2;
			if (Ep2>Ep2_max)  Ep2_max = Ep2;

			if (E1<E1_min)  E1_min = E1;
			if (E1>E1_max)  E1_max = E1;
			if (E2<E2_min)  E2_min = E2;
			if (E2>E2_max)  E2_max = E2;

			if (Ek<Ek_min)  Ek_min = Ek;
			if (Ek>Ek_max)  Ek_max = Ek;
			if (Ep<Ep_min)  Ep_min = Ep;
			if (Ep>Ep_max)  Ep_max = Ep;

			if (Etot<Etot_min)  Etot_min = Etot;
			if (Etot>Etot_max)  Etot_max = Etot;
		}

	for (simNo=origin; simNo<=clone; simNo++)  {
		pos1_min[simNo] /= 2*Pi;
		pos1_max[simNo] /= 2*Pi;
		pos2Abs_min[simNo] /= 2*Pi;
		pos2Abs_max[simNo] /= 2*Pi;
		pos2Rel_min[simNo] /= 2*Pi;
		pos2Rel_max[simNo] /= 2*Pi;

		rot1_min[simNo] /= 2*Pi;
		rot1_max[simNo] /= 2*Pi;
		rot2Abs_min[simNo] /= 2*Pi;
		rot2Abs_max[simNo] /= 2*Pi;
		rot2Rel_min[simNo] /= 2*Pi;
		rot2Rel_max[simNo] /= 2*Pi;
	}

	pos12Abs_min = ( pos1_min[origin] < pos2Abs_min[origin] ? pos1_min[origin] : pos2Abs_min[origin] );
	pos12Abs_max = ( pos1_max[origin] > pos2Abs_max[origin] ? pos1_max[origin] : pos2Abs_max[origin] );
	pos12Rel_min = ( pos1_min[origin] < pos2Rel_min[origin] ? pos1_min[origin] : pos2Rel_min[origin] );
	pos12Rel_max = ( pos1_max[origin] > pos2Rel_max[origin] ? pos1_max[origin] : pos2Rel_max[origin] );

	rot12Abs_min = ( rot1_min[origin] < rot2Abs_min[origin] ? rot1_min[origin] : rot2Abs_min[origin] );
	rot12Abs_max = ( rot1_max[origin] > rot2Abs_max[origin] ? rot1_max[origin] : rot2Abs_max[origin] );
	rot12Rel_min = ( rot1_min[origin] < rot2Rel_min[origin] ? rot1_min[origin] : rot2Rel_min[origin] );
	rot12Rel_max = ( rot1_max[origin] > rot2Rel_max[origin] ? rot1_max[origin] : rot2Rel_max[origin] );

	Ekp_min = Misc.mini4(Ek_min,Ep_min,Etot_min,Etot_min);  
	Ekp_max = Misc.maxi4(Ek_max,Ep_max,Etot_max,Etot_max);  

	E12_min = Misc.mini4(E1_min,E2_min,Etot_min,Etot_min);  
	E12_max = Misc.maxi4(E1_max,E2_max,Etot_max,Etot_max);  

	Ekp12_min = Misc.mini4(Ek1_min,Ek2_min,Ep1_min,Ep2_min);
	Ekp12_max = Misc.maxi4(Ek1_max,Ek2_max,Ep1_max,Ep2_max);

	Emin = Misc.mini4(Ekp12_min, E12_min, Ekp_min, Ekp_min);
	Emax = Misc.maxi4(Ekp12_max, E12_max, Ekp_max, Ekp_max);
	}

	//-----------------------------------------------------------------------
	//								energyDiagram
	//_______________________________________________________________________
	public void energyDiagram()  {			
		int curXpix;

        gBuf = imageBuf.getGraphics();
		gBuf.clearRect(0,0,curWidth,curHeight);

		pixE0 = Misc.pix(pixMaxDown,pixMaxUp,Emin,Emax,0);
		yMin = Emin;
		yMax = Emax;

		// y-axis
		gBuf.setColor(Color.black);
		gBuf.drawLine(pixMaxLeft, pixMaxDown + axisExtra, pixMaxLeft, pixMaxUp - axisExtra);
		gBuf.drawString( "Energy", pixMaxLeft - fm.stringWidth("Energy") / 2, pixMaxUp - axisExtra - 5 );
		// Eboxes
		curXpix = (int) (pixMaxLeft + 3*boxSep);
		drawEbox(gBuf, curXpix,Pendulum.colArm1,Ek1,"Ek1");
		curXpix = (int) (pixMaxLeft + boxW + 4*boxSep);
		drawEbox(gBuf, curXpix,Pendulum.colArm1,Ep1,"Ep1");
		curXpix = (int) (pixMaxLeft + 2*boxW + 5*boxSep);
		drawEbox(gBuf, curXpix,Pendulum.colArm2,Ek2,"Ek2");
		curXpix = (int) (pixMaxLeft + 3*boxW + 6*boxSep);
		drawEbox(gBuf, curXpix,Pendulum.colArm2,Ep2,"Ep2");
		curXpix = (int) (pixMaxLeft + 4*boxW + 10*boxSep);
		drawEbox(gBuf, curXpix,Pendulum.colArm1,E1,"E1");
		curXpix = (int) (pixMaxLeft + 5*boxW + 11*boxSep);
		drawEbox(gBuf, curXpix,Pendulum.colArm2,E2,"E2");
		curXpix = (int) (pixMaxLeft + 6*boxW + 15*boxSep);
		drawEbox(gBuf, curXpix,Pendulum.colEk,Ek,"Ek");
		curXpix = (int) (pixMaxLeft + 7*boxW + 16*boxSep); 
		drawEbox(gBuf, curXpix,Pendulum.colEp,Ep,"Ep");
		curXpix = (int) (pixMaxLeft + 8*boxW + 20*boxSep);
		drawEbox(gBuf, curXpix,Pendulum.colBase,Etot,"Etot");
		curXpix = (int) (pixMaxLeft + 9*boxW + 21*boxSep);
		// x-axis
		gBuf.setColor(Color.black);
		gBuf.drawLine( pixMaxLeft - axisExtra, pixE0, curXpix, pixE0);
		// Evalues
		xUL = curXpix + (curWidth - curXpix - 4*txtBoxW)/ 2; 
		yUL = (pixMaxDown+pixMaxUp) / 2 - 2*txtBoxH;
		gBuf.draw3DRect(xUL - 5, yUL, 4*txtBoxW + 5, 4*txtBoxH + 5, true);
		gBuf.setColor(Color.black);
		gBuf.drawString( "  (J)", xUL, yUL + txtBoxH );
		gBuf.drawString( "Ek", xUL + txtBoxW, yUL + txtBoxH );
		gBuf.drawString( "Ep", xUL + 2*txtBoxW, yUL + txtBoxH );
		gBuf.drawString( "Etot", xUL + 3*txtBoxW, yUL + txtBoxH );
		
		gBuf.drawString( "Arm1", xUL, yUL + 2*txtBoxH );
		gBuf.drawString( "Arm2", xUL, yUL + 3*txtBoxH );
		gBuf.drawString( "Both", xUL, yUL + 4*txtBoxH );

		gBuf.drawString( String.valueOf(Ek1).substring(0,Misc.nChr(Ek1)), 
							xUL + txtBoxW, yUL + 2*txtBoxH );
		gBuf.drawString( String.valueOf(Ep1).substring(0,Misc.nChr(Ep1)), 
							xUL + 2*txtBoxW, yUL + 2*txtBoxH );
		gBuf.drawString( String.valueOf(E1).substring(0,Misc.nChr(E1)), 
							xUL + 3*txtBoxW, yUL + 2*txtBoxH );
		gBuf.drawString( String.valueOf(Ek2).substring(0,Misc.nChr(Ek2)), 
							xUL + txtBoxW, yUL + 3*txtBoxH );
		gBuf.drawString( String.valueOf(Ep2).substring(0,Misc.nChr(Ep2)), 
							xUL + 2*txtBoxW, yUL + 3*txtBoxH );
		gBuf.drawString( String.valueOf(E2).substring(0,Misc.nChr(E2)), 
							xUL + 3*txtBoxW, yUL + 3*txtBoxH );
		gBuf.drawString( String.valueOf(Ek).substring(0,Misc.nChr(Ek)), 
							xUL + txtBoxW, yUL + 4*txtBoxH );
		gBuf.drawString( String.valueOf(Ep).substring(0,Misc.nChr(Ep)), 
							xUL + 2*txtBoxW, yUL + 4*txtBoxH );
		gBuf.drawString( String.valueOf(Etot).substring(0,Misc.nChr(Etot)), 
							xUL + 3*txtBoxW, yUL + 4*txtBoxH );
		App.graph.getGraphics().drawImage( imageBuf, 0, 0, this );
		gBuf.dispose();
  }

	//-----------------------------------------------------------------------
	//								drawEbox
	//_______________________________________________________________________
	private static void drawEbox(Graphics g, int curX,Color col,double energy, String info)  {
		int pixE;

		g.setColor(col);
		pixE=Misc.pix(pixMaxDown,pixMaxUp,Emin,Emax,energy);
		if (pixE < pixE0 )
			g.fillRect(curX,pixE,(int)boxW,pixE0-pixE);
		else
			g.fillRect(curX,pixE0,(int)boxW,pixE-pixE0);
		g.setColor(Color.black);
		g.drawString(info,curX,pixMaxUp - axisExtra - 5);
	}

	//-----------------------------------------------------------------------
	//								infoBox
	//_______________________________________________________________________
	private static void infoBox(Graphics g, GraphInfo[] graphInfo)  {
		int space = 5,
			i,
			strW = 0,
			rectW = 0,
			xUL,yUL;

		for (i=1; i <= nGraphs; i++)  {
			strW = fm.stringWidth(graphInfo[i].txt);
			rectW = strW > rectW ? strW : rectW;
		}
		rectW = space + infoBoxSize + space + rectW + 2*space;

		xUL = pixMaxRight + axisExtra + (margR - axisExtra - rectW) / 2 ;
		yUL = (boxPosUp ?  infoBoxSize : curHeight - infoBoxSize - nGraphs * (infoBoxSize + space)  );


		for (i=1; i <= nGraphs; i++)  {
			g.setColor( graphInfo[i].col );
			g.fillRect( xUL + space, yUL + space + (i-1) * (infoBoxSize + space),
														infoBoxSize,infoBoxSize);
			g.setColor( Color.black );
			g.setFont( graphInfo[i].bold ? App.boldFont : App.regFont );
			g.drawString ( graphInfo[i].txt, xUL + space + infoBoxSize + space,
									     	 yUL + i * (space + infoBoxSize) - 5 );
			}
		g.draw3DRect(xUL, yUL, rectW,nGraphs * (space + infoBoxSize) + space, true);
		g.setFont( App.regFont );
	}
		
	//-----------------------------------------------------------------------
	//								initTimeGraph
	//_______________________________________________________________________
	public static void initTimeGraph()  {
		int 
			strPos = 0,
			i = 0,
			simNo = 0,
			xAxisLen,
			graphNo,
			endFrame=0;
		
		double	
			xAxisTstep = 0,
			xTick = 0,
			pos1[] = new double[2],
			pos2[] = new double[2],
			rot1[] = new double[2],
			rot2[] = new double[2];

		String str;

        gBuf = imageBuf.getGraphics();
		gBuf.clearRect(0,0,curWidth,curHeight);
		if (phase > 0)  {
			for(simNo=origin; simNo<=clone; simNo++)  {
				pos1[simNo] = (y[simNo][1][0] + Math.PI/2) / (2*Math.PI);
				pos2[simNo] = (arm2Abs ?  (y[simNo][1][0] + y[simNo][2][0] + Math.PI/2 ) : 
										   y[simNo][2][0]) /(2*Math.PI);
				rot1[simNo] = y[simNo][3][0] / (2*Math.PI);
				rot2[simNo] = (arm2Abs ?  (y[simNo][3][0] + y[simNo][4][0]) : 
										   y[simNo][4][0]) /(2*Math.PI);
			}
			energy( y[origin][1][0], y[origin][2][0],y[origin][3][0], y[origin][4][0] );
			xMin = 0;
			xMax = (double) nFramesPerPhase;
			for (i=1;i<=4;i++)  
				ptX[i] = pixMaxLeft;
		}
		// collect info different graphTypes
		if (App.chkboxPosArm1.getState() || App.chkboxPosArm2.getState() || 
			App.chkboxRotArm1.getState() || App.chkboxRotArm2.getState() )  {
			nGraphs = 2;
			graphInfo[1].txt = "Original";
			graphInfo[1].col = Pendulum.colOrig;			
			graphInfo[1].bold = false;
			graphInfo[2].txt = "Clone";
			graphInfo[2].col = Pendulum.colClone;			
			graphInfo[2].bold = false;
		}
		if (App.chkboxPos_Time.getState() == true )  {
			strYaxis = "Position (laps)";
			nGraphs = 2;
			graphInfo[1].txt = "Arm1";
			graphInfo[1].col = Pendulum.colArm1;			
			graphInfo[1].bold = false;
			graphInfo[2].txt = "Arm2";
			graphInfo[2].col = Pendulum.colArm2;			
			graphInfo[2].bold = false;
			if ( phase > 0 )  {
				yMin =  ( arm2Abs ? pos12Abs_min : pos12Rel_min );
				yMax =  ( arm2Abs ? pos12Abs_max : pos12Rel_max );
				ptY[1] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, pos1[origin] );
				ptY[2] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, pos2[origin] );
			}

		}
		else if (App.chkboxRot_Time.getState() == true )  {
			strYaxis = "Rotation (laps/s)";
			nGraphs = 2;
			graphInfo[1].txt = "Arm1";
			graphInfo[1].col = Pendulum.colArm1;			
			graphInfo[1].bold = false;
			graphInfo[2].txt = "Arm2";
			graphInfo[2].col = Pendulum.colArm2;			
			graphInfo[2].bold = false;
			if ( phase > 0 )  {
				yMin =  ( arm2Abs ? rot12Abs_min : rot12Rel_min );
				yMax =  ( arm2Abs ? rot12Abs_max : rot12Rel_max );
				ptY[1] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, rot1[origin] );
				ptY[2] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, rot2[origin] );
			}
		}
		else if (App.chkboxE1E2_Time.getState() == true )  {
			strYaxis = "Energy (J)";
			nGraphs = 3;
			graphInfo[1].txt = "Arm1";
			graphInfo[1].col = Pendulum.colArm1;			
			graphInfo[1].bold = false;
			graphInfo[2].txt = "Arm2";
			graphInfo[2].col = Pendulum.colArm2;			
			graphInfo[2].bold = false;
			graphInfo[3].txt = "Total";
			graphInfo[3].col = Pendulum.colBase;			
			graphInfo[3].bold = true;
			if ( phase > 0 )  {
				yMin = E12_min;
				yMax = E12_max;
				ptY[1] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, E1 );
				ptY[2] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, E2 );
				ptY[3] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, Etot );
			}
		}
		else if (App.chkboxEkEp_Time.getState() == true )  {
			strYaxis = "Energy (J)";
			nGraphs = 3;
			graphInfo[1].txt = "Ek";
			graphInfo[1].col = Pendulum.colEk;			
			graphInfo[1].bold = false;
			graphInfo[2].txt = "Ep";
			graphInfo[2].col = Pendulum.colEp;			
			graphInfo[2].bold = false;
			graphInfo[3].txt = "Total";
			graphInfo[3].col = Pendulum.colBase;			
			graphInfo[3].bold = true;
			if ( phase > 0 )  {
				yMin = Ekp_min;
				yMax = Ekp_max;
				ptY[1] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, Ek );
				ptY[2] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, Ep );
				ptY[3] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, Etot );
			}
		}
		else if (App.chkboxEkp12_Time.getState() == true )  {
			strYaxis = "Energy (J)";
			nGraphs = 4;
			graphInfo[1].txt = "Ek1";
			graphInfo[1].col = Pendulum.colArm1;			
			graphInfo[1].bold = true;
			graphInfo[2].txt = "Ep1";
			graphInfo[2].col = Pendulum.colArm1;			
			graphInfo[2].bold = false;
			graphInfo[3].txt = "Ek2";
			graphInfo[3].col = Pendulum.colArm2;			
			graphInfo[3].bold = true;
			graphInfo[4].txt = "Ep2";
			graphInfo[4].col = Pendulum.colArm2;			
			graphInfo[4].bold = false;
			if ( phase > 0 )  {
				yMin = Ekp12_min;
				yMax = Ekp12_max;
				ptY[1] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, Ek1 );
				ptY[2] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, Ep1 );
				ptY[3] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, Ek2 );
				ptY[4] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, Ep2 );
			}
		}
		else if (App.chkboxPosArm1.getState() == true )  {
			strYaxis = "Arm1 (laps)";
			if ( phase > 0 )  {
				yMin =  Misc.mini( pos1_min[origin], pos1_min[clone] );
				yMax =  Misc.maxi( pos1_max[origin], pos1_max[clone] );
				ptY[1] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, pos1[origin] );
				ptY[2] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, pos1[clone] );
			}
		}
		else if (App.chkboxPosArm2.getState() == true )  {
			strYaxis = "Arm2 (laps)";
			if ( phase > 0 )  {
				yMin =  arm2Abs ? Misc.mini( pos2Abs_min[origin], pos2Abs_min[clone] ) : 
								  Misc.mini( pos2Rel_min[origin], pos2Rel_min[clone] ) ; 
				yMax =  arm2Abs ? Misc.maxi( pos2Abs_max[origin], pos2Abs_max[clone] ) : 
								  Misc.maxi( pos2Rel_max[origin], pos2Rel_max[clone] ) ; 
				ptY[1] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, pos2[origin] );
				ptY[2] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, pos2[clone] );
			}
		}
		else if (App.chkboxRotArm1.getState() == true )  {
			strYaxis = "Arm1 (laps/s)";
			if ( phase > 0 )  {
				yMin =  Misc.mini( rot1_min[origin], rot1_min[clone] );
				yMax =  Misc.maxi( rot1_max[origin], rot1_max[clone] );
				ptY[1] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, rot1[origin] );
				ptY[2] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, rot1[clone] );
			}
		}
		else if (App.chkboxRotArm2.getState() == true )  {
			strYaxis = "Arm2 (laps/s)";
			if ( phase > 0 )  {
				yMin =  arm2Abs ? Misc.mini( rot2Abs_min[origin], rot2Abs_min[clone] ) : 
								  Misc.mini( rot2Rel_min[origin], rot2Rel_min[clone] ) ; 
				yMax =  arm2Abs ? Misc.maxi( rot2Abs_max[origin], rot2Abs_max[clone] ) : 
								  Misc.maxi( rot2Rel_max[origin], rot2Rel_max[clone] ) ; 
				ptY[1] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, rot2[origin] );
				ptY[2] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, rot2[clone] );
			}
		}
		if ( phase == 0)  {
			strYmin = "Min";
			strYmax = "Max";
			pixY0=(pixMaxDown + pixMaxUp)/2;
			boxPosUp = true;
		}
		else  {
			strYmin = String.valueOf(yMin).substring(0,Misc.nChr(yMin));
			strYmax = String.valueOf(yMax).substring(0,Misc.nChr(yMax));
			pixY0 =  Misc.pix(pixMaxDown,pixMaxUp,yMin,yMax,0);
			boxPosUp = ( pixY0 >  ( pixMaxUp + pixMaxDown )/2   ?  true : false );
		}
		// y-Axis
		gBuf.setColor(Color.black);
		strPos = pixMaxLeft - fm.stringWidth(strYaxis) / 2;
		gBuf.drawString( strYaxis, strPos > 0 ? strPos : 5, pixMaxUp - axisExtra - 5 );
		gBuf.drawLine( pixMaxLeft, pixMaxDown + axisExtra, pixMaxLeft, pixMaxUp - axisExtra);
		// ticks
		gBuf.drawLine( pixMaxLeft - tickLen, pixMaxDown, pixMaxLeft + tickLen, pixMaxDown);  
		gBuf.drawLine( pixMaxLeft - tickLen, pixMaxUp, pixMaxLeft + tickLen, pixMaxUp);
		gBuf.drawString( strYmin, pixMaxLeft - fm.stringWidth(strYmin) - 10, pixMaxDown + fmH/2 );		
		gBuf.drawString( strYmax, pixMaxLeft - fm.stringWidth(strYmax) - 10, pixMaxUp + fmH/2 );
		
		// x-Axis
		graphNo = (phase==0 ? 1 : phase );
		xAxisLen = pixMaxRight - pixMaxLeft;
		xAxisTstep = graphTime / 4;
		if (pixY0 < margT+axisExtra || pixY0 > curHeight-margB-axisExtra)  {  // put x-Axis at bottom
			xAxisPos = pixMaxDown + 10;
			boxPosUp = true;
			// tick at position 0
			gBuf.drawLine( margL, xAxisPos+tickLen, margL, xAxisPos-tickLen );
			xTick = curTstart;
			str = String.valueOf(xTick).substring(0,Misc.nChr(xTick));
			gBuf.drawString( str,pixMaxLeft - fm.stringWidth(str)/2, xAxisPos+tickLen+fm.getHeight());
		}
		else
			xAxisPos = pixY0;
		gBuf.drawLine( pixMaxLeft - axisExtra, xAxisPos, pixMaxRight + axisExtra, xAxisPos );		
		gBuf.drawString( "Time (s)",pixMaxRight + axisExtra + 5, xAxisPos + fmH/2);  //(fm.getHeight())/2 
		// ticks pos 1 to 4
		for  (i=1; i<=4; i++)  { 
			gBuf.drawLine( pixMaxLeft + i * (xAxisLen/4), xAxisPos + tickLen, 
				        pixMaxLeft + i * (xAxisLen/4), xAxisPos - tickLen) ;
			xTick = curTstart +  + i*xAxisTstep;
			str = String.valueOf(xTick).substring(0,Misc.nChr(xTick));   
			gBuf.drawString( str, pixMaxLeft + i * (xAxisLen/4) - fm.stringWidth(str)/2, 
							   xAxisPos + tickLen + fm.getHeight() );
		}
		infoBox(gBuf, graphInfo);
		App.graph.getGraphics().drawImage( imageBuf, 0, 0, App.graph );
		gBuf.dispose();
		// draw non-timer part of graph
		if ( phase > 0 )  {		// draw start of Animation
			if (runGraph && curFrameNo > 0)   
				endFrame = curFrameNo;
			if ( !runGraph)  // complete phase
				endFrame = nFramesPerPhase;
			if (endFrame > 0)
				graphStep(1,endFrame-1);
		}
	}

	//-----------------------------------------------------------------------
	//								initPhaseGraph
	//_______________________________________________________________________
	public static void initPhaseGraph()   {
		int strPos,
			endFrame=0;

		double
			pos1=0,
			pos2=0,
			rot1=0,
			rot2=0;

        gBuf = imageBuf.getGraphics();
		gBuf.clearRect(0,0,curWidth,curHeight);

		nGraphs = 1;
		graphInfo[1].col = Color.black;
		graphInfo[1].bold = false;
		if (phase > 0)  {
			pos1 = (y[origin][1][0] + Math.PI/2) / (2*Math.PI);
			pos2 = (arm2Abs ?  (y[origin][1][0] + y[origin][2][0] + Math.PI/2 ) : 
								y[origin][2][0]) /(2*Math.PI);
			rot1 = y[origin][3][0] / (2*Math.PI);
			rot2 = (arm2Abs ?  (y[origin][3][0] + y[origin][4][0]) : 
								y[origin][4][0]) /(2*Math.PI);

			energy( y[origin][1][0], y[origin][2][0],y[origin][3][0], y[origin][4][0] );
		}
	
		// collect info different graphTypes
		if (App.chkboxPos2_Pos1.getState() == true )  {
			strYaxis = "Position arm2 (laps)";
			strXaxis = "Position arm1 (laps)";
			if ( phase > 0 )  {
				xMin = pos1_min[origin];
				xMax = pos1_max[origin];
				yMin =  ( arm2Abs ? pos2Abs_min[origin] : pos2Rel_min[origin] );
				yMax =  ( arm2Abs ? pos2Abs_max[origin] : pos2Rel_max[origin] );			
				ptX[1] = Misc.pix( pixMaxLeft, pixMaxRight, xMin, xMax, pos1 );
				ptY[1] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, pos2 );
			}
		}
		else if (App.chkboxRot2_Rot1.getState() == true )  {
			strYaxis = "Rotation arm2 (laps/s)";
			strXaxis = "Rotation arm1 (laps/s)";
			if ( phase > 0 )  {
				xMin = rot1_min[origin];
				xMax = rot1_max[origin];
				yMin =  ( arm2Abs ? rot2Abs_min[origin] : rot2Rel_min[origin] );
				yMax =  ( arm2Abs ? rot2Abs_max[origin] : rot2Rel_max[origin] );			
				ptX[1] = Misc.pix( pixMaxLeft, pixMaxRight, xMin, xMax, rot1 );
				ptY[1] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, rot2 );
			}			
		}
		else if (App.chkboxRot1_Pos1.getState() == true )  {
			strYaxis = "Rotation arm1 (laps/s)";
			strXaxis = "Position arm1 (laps)";
			if ( phase > 0 )  {
				xMin = pos1_min[origin];
				xMax = pos1_max[origin];
				yMin = rot1_min[origin];
				yMax = rot1_max[origin];			
				ptX[1] = Misc.pix( pixMaxLeft, pixMaxRight, xMin, xMax, pos1 );
				ptY[1] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, rot1 );
			}
		}
		else if (App.chkboxRot2_Pos2.getState() == true )  {
			strYaxis = "Rotation arm2 (laps/s)";
			strXaxis = "Position arm2 (laps)";
			if ( phase > 0 )  {
				xMin =  ( arm2Abs ? pos2Abs_min[origin] : pos2Rel_min[origin] );
				xMax =  ( arm2Abs ? pos2Abs_max[origin] : pos2Rel_max[origin] );			
				yMin =  ( arm2Abs ? rot2Abs_min[origin] : rot2Rel_min[origin] );
				yMax =  ( arm2Abs ? rot2Abs_max[origin] : rot2Rel_max[origin] );			
				ptX[1] = Misc.pix( pixMaxLeft, pixMaxRight, xMin, xMax, pos2 );
				ptY[1] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, rot2 );
			}
		}
		if ( phase == 0)  {
			pixY0 = (pixMaxDown+pixMaxUp)/2;
			pixX0 = (pixMaxLeft+pixMaxRight)/2;
			strYmin = "Min";
			strYmax = "Max";			
			strXmin = "Min";
			strXmax = "Max";			
		}
		else  {
			pixY0 =  Misc.pix(pixMaxDown,pixMaxUp,yMin,yMax,0);
			pixX0 =  Misc.pix(pixMaxLeft,pixMaxRight,xMin,xMax,0);
			strYmin = String.valueOf(yMin).substring(0,Misc.nChr(yMin));
			strYmax = String.valueOf(yMax).substring(0,Misc.nChr(yMax));
			strXmin = String.valueOf(xMin).substring(0,Misc.nChr(xMin));
			strXmax = String.valueOf(xMax).substring(0,Misc.nChr(xMax));
		}
		if (	pixY0 < (pixMaxDown-axisExtra) && pixY0 > (pixMaxUp+axisExtra) &&
			    pixX0 > (pixMaxLeft+axisExtra) && pixX0 < (pixMaxRight-axisExtra) )  {
			// let axis intersect
			xAxisPos = pixY0;
			yAxisPos = pixX0;
		} 
		else  {	// axes at left and bottom
			xAxisPos = pixMaxDown +10;
			yAxisPos = pixMaxLeft - 10;;
		}

		gBuf.setColor(Color.black);
		// y-Axis		
		strPos = yAxisPos - fm.stringWidth(strYaxis)/2;
		strPos = strPos>0 ?  strPos : 5;
		gBuf.drawString( strYaxis, strPos, pixMaxUp - axisExtra - 5 );
		gBuf.drawLine( yAxisPos, pixMaxDown + axisExtra, yAxisPos, pixMaxUp - axisExtra);			

		gBuf.drawLine( yAxisPos - tickLen, pixMaxDown, yAxisPos + tickLen, pixMaxDown);  // minTick
		gBuf.drawString( strYmin, yAxisPos - fm.stringWidth(strYmin) - 10, pixMaxDown + fmH/2 );

		gBuf.drawLine( yAxisPos - tickLen, pixMaxUp, yAxisPos + tickLen, pixMaxUp);	// maxTick
		gBuf.drawString( strYmax, yAxisPos - fm.stringWidth(strYmax) - 10, pixMaxUp + fmH/2 );


		// x-Axis
		gBuf.drawString( strXaxis, pixMaxRight + axisExtra + 5, xAxisPos + fmH/2);
		gBuf.drawLine( pixMaxLeft - axisExtra, xAxisPos, pixMaxRight + axisExtra, xAxisPos);			

		gBuf.drawLine( pixMaxLeft, xAxisPos + tickLen, pixMaxLeft, xAxisPos - tickLen);  // minTick
		gBuf.drawString( strXmin, pixMaxLeft - fm.stringWidth(strXmin)/2, xAxisPos + tickLen + fm.getHeight());

		gBuf.drawLine( pixMaxRight, xAxisPos + tickLen, pixMaxRight, xAxisPos - tickLen);  // maxTick
		gBuf.drawString( strXmax, pixMaxRight - fm.stringWidth(strXmax)/2, xAxisPos + tickLen + fm.getHeight());

		App.graph.getGraphics().drawImage( imageBuf, 0, 0, App.graph );
		gBuf.dispose();
		// draw non-timer part of graph
		if ( phase > 0 )  {		// draw start of Animation
			if (runGraph && curFrameNo > 0)   // draw start of Animation
				endFrame = curFrameNo;
			if ( !runGraph)  // complete phase
				endFrame = nFramesPerPhase;
			if (endFrame > 0)
				graphStep(1,endFrame-1);
		}
	}

	//-----------------------------------------------------------------------
	//								graphStep
	//_______________________________________________________________________
	static public void graphStep(int startFrame, int endFrame)  {
		int		simNo = 0,
				frameNo = 0,
				graphNo = 0;
				
		double	pos1[] = new double[2],
				pos2[] = new double[2],
				rot1[] = new double[2],
				rot2[] = new double[2];

		for( frameNo = startFrame; frameNo<=endFrame; frameNo++ )  {
			for(simNo=origin; simNo<=clone; simNo++)  {
				pos1[simNo] = (y[simNo][1][frameNo] + Math.PI/2) / (2*Math.PI);
				pos2[simNo] = (arm2Abs ?  (y[simNo][1][frameNo] + y[simNo][2][frameNo] + Math.PI/2 ) :
										   y[simNo][2][frameNo])  / (2*Math.PI);
				rot1[simNo] = y[simNo][3][frameNo] / (2*Math.PI);
				rot2[simNo] = (arm2Abs ?  (y[simNo][3][frameNo] + y[simNo][4][frameNo]) : 
										   y[simNo][4][frameNo])  / (2*Math.PI);
			}
			energy( y[origin][1][frameNo], y[origin][2][frameNo], 
					y[origin][3][frameNo], y[origin][4][frameNo] );
			for (graphNo=1; graphNo<=nGraphs; graphNo++)  {
				ptXprev[graphNo] = ptX[graphNo];
				ptYprev[graphNo] = ptY[graphNo];
			}
			// get current values for PtX and PtY
			if (graphType == "Time")  {
				for (graphNo=1; graphNo<=nGraphs ; graphNo++)  
					ptX[graphNo] = Misc.pix( pixMaxLeft, pixMaxRight, xMin, xMax, frameNo );
			}
			if (App.chkboxPos_Time.getState() == true )  {			
				ptY[1] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, pos1[origin] );
				ptY[2] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, pos2[origin] );
			}
			else if (App.chkboxRot_Time.getState() == true )  {
				ptY[1] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, rot1[origin] );
				ptY[2] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, rot2[origin] );
			}
			else if (App.chkboxE1E2_Time.getState() == true )  {
				ptY[1] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, E1 );
				ptY[2] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, E2 );
				ptY[3] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, Etot );
			}
			else if (App.chkboxEkEp_Time.getState() == true )  {
				ptY[1] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, Ek );
				ptY[2] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, Ep );
				ptY[3] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, Etot );
			}
			else if (App.chkboxEkp12_Time.getState() == true )  {
				ptY[1] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, Ek1 );
				ptY[2] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, Ep1 );
				ptY[3] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, Ek2 );
				ptY[4] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, Ep2 );
			}
			else if (App.chkboxPosArm1.getState() == true )  {
				ptY[1] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, pos1[origin] );
				ptY[2] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, pos1[clone] );
			}
			else if (App.chkboxPosArm2.getState() == true )  {
				ptY[1] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, pos2[origin] );
				ptY[2] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, pos2[clone] );
			}
			else if (App.chkboxRotArm1.getState() == true )  {
				ptY[1] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, rot1[origin] );
				ptY[2] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, rot1[clone] );
			}
			else if (App.chkboxRotArm2.getState() == true )  {
				ptY[1] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, rot2[origin] );
				ptY[2] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, rot2[clone] );
			}
			else if (App.chkboxPos2_Pos1.getState() == true )  {
				ptX[1] = Misc.pix( pixMaxLeft, pixMaxRight, xMin, xMax, pos1[origin] );
				ptY[1] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, pos2[origin] );
			}
			else if (App.chkboxRot2_Rot1.getState() == true )  {
				ptX[1] = Misc.pix( pixMaxLeft, pixMaxRight, xMin, xMax, rot1[origin] );
				ptY[1] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, rot2[origin] );
			}
			else if (App.chkboxRot1_Pos1.getState() == true )  {
				ptX[1] = Misc.pix( pixMaxLeft, pixMaxRight, xMin, xMax, pos1[origin] );
				ptY[1] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, rot1[origin] );
			}
			else if (App.chkboxRot2_Pos2.getState() == true )  {
				ptX[1] = Misc.pix( pixMaxLeft, pixMaxRight, xMin, xMax, pos2[origin] );
				ptY[1] = Misc.pix( pixMaxDown, pixMaxUp, yMin, yMax, rot2[origin] );
			}			
			for (graphNo=1; graphNo<=nGraphs; graphNo++)  {
				g = App.graph.getGraphics();
				g.setColor( graphInfo[graphNo].col );
				if (  (App.chkboxPosArm1.getState() || App.chkboxPosArm2.getState() || 
					   App.chkboxRotArm1.getState() || App.chkboxRotArm2 .getState() ) 
					   && graphNo==2)
					g.drawLine( ptXprev[graphNo], ptYprev[graphNo] - 1, ptX[graphNo], ptY[graphNo] - 1 );
				else if ( !graphInfo[graphNo].bold )
					g.drawLine( ptXprev[graphNo], ptYprev[graphNo], ptX[graphNo], ptY[graphNo] );
				else  {
					g.drawLine( ptXprev[graphNo], ptYprev[graphNo] + 1, ptX[graphNo], ptY[graphNo] + 1 );
					g.drawLine( ptXprev[graphNo], ptYprev[graphNo],     ptX[graphNo], ptY[graphNo]     );
					g.drawLine( ptXprev[graphNo], ptYprev[graphNo] - 1, ptX[graphNo], ptY[graphNo] - 1 );
				}
				g.dispose();					
			}
		}
	}
	
	//-----------------------------------------------------------------------
	//								initTorusGraph
	//_______________________________________________________________________
	static public void initTorusGraph()  {

		double	aRad=0,
				bRad=0,
				rWC[] = new double[4],
				rVC[] = new double[4];

		int		endFrame=0,
				frameNo=0;

		g = App.graph.getGraphics();
		g.drawImage( imageTorus, 0, 0, App.graph );			
		if (phase == 0 || pause )  {
			App.panTorusOpt.show();
			Torus.axes(g);
		}
		else
			App.panTorusOpt.hide();
		if (App.chkboxCircles.getState() == true )
				Torus.circles(g);
		if (phase == 0) 
				Torus.dot(g);
		else  {
			aRad = y[origin][1][0];
			bRad = arm2Abs ? (y[origin][1][0] + y[origin][2][0] + Math.PI/2 ) : y[origin][2][0];
			Torus.getWC( aRad, bRad, rWC );
			Torus.getVC( rWC, rVC );
			ptX[1] = Misc.pix( Torus.pixMaxLeft, Torus.pixMaxRight, 
							   Torus.torusXmin, Torus.torusXmax, rVC[1]);
			ptY[1] = Misc.pix( Torus.pixMaxDown, Torus.pixMaxUp, 
							   Torus.torusYmin, Torus.torusYmax, rVC[2]);
			if ( runGraph && curFrameNo>0)    // draw start of Animation
				endFrame = curFrameNo;
			if ( !runGraph ) // complete phase
				endFrame = nFramesPerPhase;
			torusGraphStep(1,endFrame-1);
		}
		g.dispose();
	}

	//-----------------------------------------------------------------------
	//								torusGraphStep
	//_______________________________________________________________________
	static public void torusGraphStep(int startFrame, int endFrame)  {

		int		frameNo=0,
				aI=0,
				bI=0;
				
		double	aRad=0,
				bRad=0,
				rWC[] = new double[4],
				rVC[] = new double[4];

		g = App.graph.getGraphics();
		g.setColor( Color.black );		
		for( frameNo=startFrame; frameNo<=endFrame; frameNo++ )  {
			ptXprev[1] = ptX[1];
			ptYprev[1] = ptY[1];
			aRad = y[origin][1][frameNo];
			bRad = arm2Abs ? (y[origin][1][frameNo] + y[origin][2][frameNo] + Math.PI/2 ) : 
							  y[origin][2][frameNo];
			aI = (int) (aRad / Torus.da) % Torus.nStepsDa;
			bI = (int) (bRad / Torus.db) % Torus.nStepsDb;
			aI = aI < 0 ? aI + Torus.nStepsDa : aI;
			bI = bI < 0 ? bI + Torus.nStepsDb : bI;
			Torus.getWC( aRad, bRad, rWC );
			Torus.getVC( rWC, rVC );
			ptX[1] = Misc.pix( Torus.pixMaxLeft, Torus.pixMaxRight, Torus.torusXmin, Torus.torusXmax, rVC[1]);
			ptY[1] = Misc.pix( Torus.pixMaxDown, Torus.pixMaxUp, Torus.torusYmin, Torus.torusYmax, rVC[2]);
			if (Torus.polygons[aI][bI].visible)  {	// front side of torus
				if ( !App.chkboxCircles.getState()  &&  !App.chkboxBackside.getState() )   
					g.drawLine(ptXprev[1],ptYprev[1],ptX[1],ptY[1]);
				else  {    // bold line 
					g.drawLine(ptXprev[1],     ptYprev[1],     ptX[1],     ptY[1]);
					g.drawLine(ptXprev[1] + 1, ptYprev[1],     ptX[1] + 1, ptY[1]);
					g.drawLine(ptXprev[1],     ptYprev[1] - 1, ptX[1],     ptY[1] - 1);
				}
			}
			else  {	// backside of torus
				if ( App.chkboxBackside.getState() == true )  {
					g.drawLine(ptXprev[1], ptYprev[1], ptX[1], ptY[1]);
				}
			}
		}
		g.dispose();
	}

	//-----------------------------------------------------------------------
	//								start
	//_______________________________________________________________________
	static public void start()  {

		if (phase==0)  {
			App.btnStop.enable();
			App.btnPause.enable();
			App.btnStart.disable();
			App.textPosArm1.disable();
			App.textPosArm2.disable();
			App.textRotArm1.disable();
			App.textRotArm2.disable();
			App.textDposArm1.disable();
			App.textDposArm2.disable();
			App.textDrotArm1.disable();
			App.textDrotArm2.disable();
			App.readParameters();
			App.readStartvalues();
			resetAnimation();
			Runge_Kutta(y[origin], dt, nStepsPerPhase);
			Runge_Kutta(y[clone], dt, nStepsPerPhase);
			getMinMax();
			phase = 1;
			if (graphType == "Time" )
				initTimeGraph();
			else if  (graphType =="Phase" )
				initPhaseGraph();
			else if (graphType == "Torus") 
				initTorusGraph();
			threadAnim = new Thread(App.graph);
			threadAnim.start();
		}
	}


	//-----------------------------------------------------------------------
	//								pauseContinue
	//_______________________________________________________________________
	static public void pauseContinue()  {
		if (phase>0)  {
			if (!pause)  {
				App.labCurTime.setText("Paus");
				App.textCurTime.setText( "T="+String.valueOf(milliSecs / 1000) + "s" );
				App.btnPause.setLabel("Continue");
				threadAnim.suspend();
				pause = !pause;
				if (graphType=="Torus")
					initTorusGraph();
				
			}
			else  {
				App.labCurTime.setText("Time");
				App.textCurTime.setText( String.valueOf(milliSecs / 1000) + "s" );
				pause = !pause;
				if (graphType=="Torus")
					initTorusGraph();
				threadAnim.resume();
				App.btnPause.setLabel("Pause");
			}
			
		}
	}

	//-----------------------------------------------------------------------
	//								stop
	//_______________________________________________________________________
	static public void stop()  {
		threadAnim.stop();
		App.textCurTime.setText("");
		resetAnimation();
		App.btnPause.setLabel("Pause");
		App.btnStart.enable();
		App.textPosArm1.enable();
		App.textPosArm2.enable();
		App.textRotArm1.enable();
		App.textRotArm2.enable();
		App.textDposArm1.enable();
		App.textDposArm2.enable();
		App.textDrotArm1.enable();
		App.textDrotArm2.enable();

		App.btnPause.disable();
		App.btnStop.disable();
		App.graph.repaint();
		App.pendulum.repaint();
	}

	//-----------------------------------------------------------------------
	//								run
	//_______________________________________________________________________
	public void run()  {
	
		while(true)  {

			App.textCurTime.setText( String.valueOf(milliSecs / 1000) + "s" );
			milliSecs += (int) (frameDuration * 1000);
			curFrameNo += 1;
			if (curFrameNo < nFramesPerPhase)  {
				if (runGraph)  {
					if (graphType == "Time" || graphType == "Phase" )
						graphStep(curFrameNo,curFrameNo);	
					else if (graphType == "Torus")
						torusGraphStep(curFrameNo,curFrameNo);
				}
			}
			else  { // new graphTime phase
				phase += 1;
				curFrameNo = 0;
				curTstart += graphTime;
				y[origin][1][0] = y[origin][1][nFramesPerPhase - 1];
				y[origin][2][0] = y[origin][2][nFramesPerPhase - 1];
				y[origin][3][0] = y[origin][3][nFramesPerPhase - 1];
				y[origin][4][0] = y[origin][4][nFramesPerPhase - 1];				
				y[clone][1][0] = y[clone][1][nFramesPerPhase - 1];
				y[clone][2][0] = y[clone][2][nFramesPerPhase - 1];
				y[clone][3][0] = y[clone][3][nFramesPerPhase - 1];
				y[clone][4][0] = y[clone][4][nFramesPerPhase - 1];
				Runge_Kutta(y[origin], dt, nStepsPerPhase );
				Runge_Kutta(y[clone], dt, nStepsPerPhase );
				getMinMax();
				if (graphType == "Time")
					initTimeGraph();
				else if  ( graphType == "Phase" )
					initPhaseGraph();
				else if (graphType == "Torus")
					initTorusGraph();
			}
			if (graphType=="Ebox")  {
				energy( y[origin][1][curFrameNo], y[origin][2][curFrameNo], 
					    y[origin][3][curFrameNo], y[origin][4][curFrameNo] );
				energyDiagram();
			}
			App.pendulum.drawPendulum(y[origin][1][curFrameNo], y[origin][2][curFrameNo]);
			try { Thread.sleep( (int) (frameDuration*1000) ); }
			catch(InterruptedException e) {;}
		}
	}

}