VERSION 5.00
Begin VB.Form frmProgram 
   Caption         =   "Program"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Visible         =   0   'False
End
Attribute VB_Name = "frmProgram"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Option Explicit

Dim frmP As Object
Dim picP_W As Long
Dim picP_H As Long

Dim dual As Boolean

Const Pi As Double = 3.14159265
Const g As Double = 9.8
Const simOne As Long = 1
Const simTwo As Long = 2

Const colArm1 As Long = &H404000
Const colArm2 As Long = &H800080
Const colPendulum As Long = &H40C0&
Const colEk As Long = &HC00000
Const colEp As Long = &H808000

Const dt As Double = 0.001              'timeStep in RungeKutta
Const frameDuration As Double = 0.02


Dim virgin As Boolean
Dim txtActive As Boolean
Dim phase As Long 'equals zero before start, then graphtime intervalNo after start
Dim paus As Boolean
Dim mPerPix As Double
Dim topMargin As Long

Dim axis1_x As Long
Dim axis1_y As Long
Dim axis2_x As Long
Dim axis2_y As Long

' Parameters Arm 1 (m, kg)
Dim a1 As Double
Dim b1 As Double
Dim r1 As Double
Dim m1Arm As Double
Dim m1Big As Double
Dim m1 As Double
Dim m1Pos As Double
Dim k1 As Double    ' friction parameter 1/k ~damping time

' Parameters Arm 2 (m, kg)
Dim a2 As Double
Dim b2 As Double
Dim r2 As Double
Dim m2Arm As Double
Dim m2 As Double
Dim m2Pos As Double
Dim k2 As Double

' variables position and motion

' arm 1
Dim pos1_Abs As Double
Dim phi1(2) As Double
Dim w1Hz As Double
Dim w1(2) As Double

' arm2
Dim pos2_Abs As Double
Dim phi2(2) As Double
Dim w2Hz As Double
Dim w2(2) As Double

' Constants during simulation
'---- moments of inertia-----------
Dim I_arm1 As Double
Dim I_m1Big As Double
Dim I_m1 As Double
Dim I_arm2 As Double
Dim I_m2 As Double

'---- misc constants------
Dim a As Double
Dim A_1 As Double
Dim A_2 As Double
Dim b As Double
Dim c As Double
Dim D As Double
Dim E As Double

'--- time ---
Dim graphTime As Double
Dim oldGraphTime As Double
Dim nSteps As Long
Dim nStepsPerFrame As Long
Dim stepNo As Long
Dim milliSecs  As Long
Dim nFrames As Long

'motion variables
Dim y1() As Double
Dim y2() As Double
Dim y3() As Double
Dim y4() As Double

'energy
Dim Ek_1 As Double
Dim Ek_2 As Double
Dim Ek As Double
Dim Ep_1 As Double
Dim Ep_2 As Double
Dim Ep As Double
Dim Etot_1 As Double
Dim Etot_2 As Double
Dim Etot As Double

' various min and max values during graphtime simulation
Dim pos1_min(2) As Double
Dim pos1_max(2) As Double
Dim pos2Abs_min(2) As Double
Dim pos2Abs_max(2) As Double
Dim pos2Rel_min(2) As Double
Dim pos2Rel_max(2) As Double
Dim pos12Abs_min As Double
Dim pos12Abs_max As Double
Dim pos12Rel_min As Double
Dim pos12Rel_max As Double

Dim w1_min(2) As Double
Dim w1_max(2) As Double
Dim w2Abs_min(2) As Double
Dim w2Abs_max(2) As Double
Dim w2Rel_min(2) As Double
Dim w2Rel_max(2) As Double

Dim w12Abs_min As Double
Dim w12Abs_max As Double
Dim w12Rel_min As Double
Dim w12Rel_max As Double

Dim E12_min As Double
Dim E12_max As Double
Dim Ekp_min As Double
Dim Ekp_max As Double
Dim Ekp12_min As Double
Dim Ekp12_max As Double
Dim Emin As Double
Dim Emax As Double


Dim xPixOld(4) As Long
Dim yPixOld(4) As Long
Dim xPixNew(4) As Long
Dim yPixNew(4) As Long

Dim pixYmax As Long
Dim pixYmin As Long
Dim pixXmin As Long
Dim pixXmax As Long

Dim yMin As Double
Dim yMax As Double
Dim xMin As Double
Dim xMax As Double

Dim y0Pix As Long
Dim x0Pix As Long

'Torus parameters ---------------------------
Const TorusMargin As Long = 20
Const r_a As Double = 3
Const r_b As Double = 1
Const da_circles As Double = 2 * Pi / 20
Const db_circles As Double = 2 * Pi / 12
Const da As Double = 2 * Pi / 200        'da db should be multiple of 4
Const db As Double = 2 * Pi / 80
Const view As Double = 30 * Pi / 180

Dim nDaSteps As Long
Dim nDbSteps As Long

' Lighting model for torus
Const L_amb As Double = 2   ' Backgrund lightlevel
Const L_dir As Double = 7   ' Lightlevel for directed lightsource
Const L_max As Double = 15  ' Normation of light values L=Lamb+Ldir  Lmax gives max light=white
Const Lx As Double = 0      ' Normed direction to lightsource
Const Ly As Double = 0
Const Lz As Double = 1
Dim H As Single             ' Hue of torus  Red=0 yellow=60 greenn=120 cyan=180 Blue=240 Magenta=300
Dim L As Single
Dim S As Single             ' Colorsaturation of torus, greylevel=0 pure color=1

Dim torusXmin As Double
Dim torusXmax As Double
Dim torusYmin As Double
Dim torusYmax As Double
Dim pixTxMin As Long
Dim pixTxMax As Long
Dim pixTyMin As Long
Dim pixTyMax As Long

Dim vc_database() As Double
Dim r(3, 3) As Double

Private Type Point
    x As Long
    y As Long
End Type

Private Type TorusInfo
    Nx As Double
    Ny As Double
    Nz As Double
    visible As Boolean
    xMin As Double
    xMax As Double
    yMin As Double
    yMax As Double
    xCtr As Double
    yCtr As Double
    zCtr As Double
    pixYtop As Long     ' info for filling polygonarea
    nScanlines As Long
    pixLeftEdge() As Long
    pixRightEdge() As Long
    color As Long
End Type

Private Type segmentInfo    ' extension of circular crosssection segment of torus
    xMin As Double
    xMax As Double
    yMin As Double
    yMax As Double
End Type

Dim aSegment() As segmentInfo
Dim torus() As TorusInfo
'---------------------------------------------


'***************************************************************************************
'                               Form_Load()
'***************************************************************************************
Private Sub Form_Load()
Dim left As Long
Dim top As Long
Dim pixWidth As Long
Dim retVal As Variant

dual = False
pixWidth = Screen.Width / Screen.TwipsPerPixelX
If pixWidth < 1000 Then
    topMargin = 10
    Set frmP = frmPendulum800
ElseIf pixWidth < 1100 Then
    topMargin = 10
    Set frmP = frmPendulum1024
Else
    topMargin = 30
    Set frmP = frmPendulum1200
End If
picP_W = frmP.picPendulum.ScaleWidth
picP_H = frmP.picPendulum.ScaleHeight
frmP.Show
virgin = True
paus = False
setTorusData
printTorus
txtActive = False
milliSecs = 0
stepNo = 0
phase = 0
setStandard
axis1_x = frmP.picPendulum.ScaleWidth \ 2
axis1_y = frmP.picPendulum.ScaleHeight \ 2
frmP.picPendulum.FillStyle = vbFSSolid
frmP.picPendBuf.FillStyle = vbFSSolid
mPerPix = 2.5 * (r1 + r2) / frmP.picPendulum.ScaleWidth
SetStartValues
Parameters
nSteps = CLng(graphTime / dt)
ReDim y1(2, nSteps)
ReDim y2(2, nSteps)
ReDim y3(2, nSteps)
ReDim y4(2, nSteps)
Constants
energy phi1(simOne), phi2(simOne), w1(simOne), w2(simOne)
showEnergyValues Ek_1, Ek_2, Ep_1, Ep_2
frmP.scr_m1Pos.Value = 50
frmP.scr_m2Pos.Value = 50
left = (Screen.Width - frmP.Width) \ 2
top = (Screen.Height - frmP.Height) \ 2
frmP.left = left
frmP.top = top
End Sub


'***************************************************************************************
'                               setStandard()
'***************************************************************************************
Private Sub setStandard()
'standardvalues as in original physical pendulum

graphTime = 10
oldGraphTime = 10

' Parameters Arm 1 (m, kg)
a1 = 0.67
b1 = 0.075
r1 = a1 / 2
m1Arm = 0.438
m1Big = 0.541
m1 = 0.242
k1 = 0

' Parameters Arm 2 (m, kg)
a2 = 0.68
b2 = 0.07
r2 = a2 / 2
m2Arm = 0.565
m2 = 0.246
k2 = 0

mPerPix = 2.5 * (r1 + r2) / frmP.picPendulum.ScaleWidth
End Sub


'***************************************************************************************
'                              Parameters
'***************************************************************************************
Private Sub Parameters()

frmP.txtGraphTime = Str(graphTime)
' --------Arm1---------
frmP.txtArm1L = Str(1000 * a1)
frmP.txtArm1W = Str(1000 * b1)
frmP.txtArm1Mass = Str(1000 * m1Arm)
frmP.txtArm1bigM = Str(1000 * m1Big)
frmP.txtArm1m = Str(1000 * m1)
frmP.scr_m1Pos.Value = 50
m1Pos = r1 * CDbl(frmP.scr_m1Pos.Value) / 100
k1 = 0
frmP.txtArm1k = Str(2 * k1)

' --------Arm2---------
frmP.txtArm2L = Str(1000 * a2)
frmP.txtArm2W = Str(1000 * b2)
frmP.txtArm2Mass = Str(1000 * m2Arm)
frmP.txtArm2m = Str(1000 * m2)
frmP.scr_m2Pos.Value = 50
m2Pos = r2 * CDbl(frmP.scr_m2Pos.Value) / 100
k2 = 0
frmP.txtArm2k = Str(2 * k2)
End Sub



'***************************************************************************************
'                              readParameters
'***************************************************************************************
Private Sub readParameters()

graphTime = Val(frmP.txtGraphTime)

nSteps = CLng(graphTime / dt)
nStepsPerFrame = CLng(frameDuration / dt)
nFrames = CLng(graphTime / frameDuration)

If graphTime <> oldGraphTime Then
    ReDim y1(2, nSteps)
    ReDim y2(2, nSteps)
    ReDim y3(2, nSteps)
    ReDim y4(2, nSteps)
End If
oldGraphTime = graphTime

' --------Arm1---------
a1 = Val(frmP.txtArm1L) / 1000
r1 = a1 / 2
b1 = Val(frmP.txtArm1W) / 1000
m1Arm = Val(frmP.txtArm1Mass) / 1000
m1Big = Val(frmP.txtArm1bigM) / 1000
m1 = Val(frmP.txtArm1m) / 1000
m1Pos = r1 * CDbl(frmP.scr_m1Pos.Value) / 100
k1 = Val(frmP.txtArm1k) / 2

' --------Arm2---------
a2 = Val(frmP.txtArm2L) / 1000
r2 = a2 / 2
b2 = Val(frmP.txtArm2W) / 1000
m2Arm = Val(frmP.txtArm2Mass) / 1000
m2 = Val(frmP.txtArm2m) / 1000
m2Pos = r2 * CDbl(frmP.scr_m2Pos.Value) / 100
k2 = Val(frmP.txtArm2k) / 2

mPerPix = 2.5 * (r1 + r2) / frmP.picPendulum.ScaleWidth
End Sub


'***************************************************************************************
'                              cmdDefault_Click
'***************************************************************************************
Public Sub cmdDefault_Click()
setStandard
Parameters
SetStartValues
cmdStop_Click
End Sub

'***************************************************************************************
'                              cmdShow_Click
'***************************************************************************************
Public Sub cmdShow_Click()
readParameters
update
End Sub

'***************************************************************************************
'                              SetStartValues
'***************************************************************************************
Private Sub SetStartValues()
' --------Arm1---------
pos1_Abs = 40
frmP.txtArm1Pos0 = Str(pos1_Abs)
phi1(simOne) = Pi * (pos1_Abs - 90) / 180
w1Hz = -0.3
frmP.txtArm1Rot0 = "-0.3"
w1(simOne) = w1Hz * 2 * Pi

' --------Arm2---------
pos2_Abs = -20
frmP.txtArm2Pos0 = Str(pos2_Abs)
phi2(simOne) = Pi * (pos2_Abs - 90) / 180 - phi1(simOne)
w2Hz = 0.3
frmP.txtArm2Rot0 = "0.3"
w2(simOne) = w2Hz * 2 * Pi

' ----butterflyEffect------
frmP.txtDiffPosArm1 = "0.1"
frmP.txtDiffPosArm2 = "0.1"
frmP.txtDiffRotArm1 = "0.1"
frmP.txtDiffRotArm2 = "0.1"
End Sub

'***************************************************************************************
'                              ReadStartValues
'***************************************************************************************
Private Sub ReadStartValues()
' --------Arm1---------
phi1(simOne) = Pi * (Val(frmP.txtArm1Pos0) - 90) / 180
w1Hz = Val(frmP.txtArm1Rot0)
w1(simOne) = w1Hz * 2 * Pi
k1 = Val(frmP.txtArm1k) / 2
m1Pos = r1 * CDbl(frmP.scr_m1Pos.Value) / 100

' --------Arm2---------
phi2(simOne) = Pi * (Val(frmP.txtArm2Pos0) - 90) / 180 - phi1(simOne)
w2Hz = Val(frmP.txtArm2Rot0)
w2(simOne) = w2Hz * 2 * Pi
k2 = Val(frmP.txtArm2k) / 2
m2Pos = r2 * CDbl(frmP.scr_m2Pos.Value) / 100
End Sub

'***************************************************************************************
'                              Constants
'***************************************************************************************
Private Sub Constants()
'---inertia---
I_arm1 = m1Arm * (a1 ^ 2 + b1 ^ 2) / 12
I_m1Big = m1Big * r1 ^ 2
I_m1 = m1 * m1Pos ^ 2
I_arm2 = m2Arm * (a2 ^ 2 + b2 ^ 2) / 12
I_m2 = m2 * m2Pos ^ 2
'---misc---
a = 0.5 * (I_arm1 + I_m1Big + I_m1 + I_arm2 + I_m2 + (m2Arm + m2) * r1 ^ 2)
A_1 = 0.5 * (I_arm1 + I_m1Big + I_m1)
A_2 = 0.5 * (I_arm2 + I_m2 + (m2 + m2Arm) * r1 ^ 2)
b = m2 * r1 * m2Pos
c = 0.5 * (I_arm2 + I_m2)
D = (m1Big * r1 + m1 * m1Pos - (m2Arm + m2) * r1) * g
E = m2 * m2Pos * g
End Sub

'***************************************************************************************
'                                       f_g
'***************************************************************************************
Private Sub f_g(y1 As Double, y2 As Double, y3 As Double, y4 As Double, _
                ByRef f As Double, ByRef g As Double)
Dim cos_y1 As Double
Dim cos_y2 As Double
Dim cos_y1py2 As Double
Dim sin_y2 As Double
Dim f1 As Double
Dim f2 As Double
Dim f3 As Double

cos_y1 = Cos(y1)
cos_y2 = Cos(y2)
cos_y1py2 = Cos(y1 + y2)
sin_y2 = Sin(y2)
f1 = 2 * c * D * cos_y1 + (4 * c * (k1 * A_1 + k2 * A_2) - k2 * (4 * c * c + b * b * cos_y2 * cos_y2)) * y3
f2 = b * E * cos_y2 * cos_y1py2 + 4 * b * c * y3 * y4 * sin_y2 _
    + (2 * b * c - b * b * cos_y2) * y3 * y3 * sin_y2 + 2 * b * c * y4 * y4 * sin_y2
f3 = (2 * c - b * cos_y2) ^ 2 - 4 * c * (a - b * cos_y2)
f = (f1 + f2) / f3
g = (2 * (b * cos_y2 - a) * f - 2 * b * y3 * y4 * sin_y2 - b * y4 * y4 * sin_y2 - D * cos_y1 _
    - E * cos_y1py2 + 2 * (k2 * b * cos_y2 - k1 * A_1 - k2 * A_2) * y3 - k2 * (2 * c - b * cos_y2) * y4) _
     / (2 * c - b * cos_y2)
End Sub

'***************************************************************************************
'                                 Runge_Kutta
'***************************************************************************************
Private Sub Runge_Kutta(dt As Double, nSteps As Long)
Dim i As Long
Dim simNo As Long
Dim nSims As Long
Dim oldI As Long
Dim newI As Long
Dim k(4, 4) As Double
Dim f As Double
Dim g As Double

If dual Then nSims = 2 Else nSims = 1
For simNo = 1 To nSims
    For i = 0 To nSteps - 1
        oldI = i
        newI = i + 1
        Call f_g(y1(simNo, oldI), y2(simNo, oldI), y3(simNo, oldI), y4(simNo, oldI), f, g)
        k(1, 1) = y3(simNo, oldI)
        k(1, 2) = y4(simNo, oldI)
        k(1, 3) = f
        k(1, 4) = g
    
        Call f_g(y1(simNo, oldI) + dt / 2 * k(1, 1), y2(simNo, oldI) + dt / 2 * k(1, 2), _
                 y3(simNo, oldI) + dt / 2 * k(1, 3), y4(simNo, oldI) + dt / 2 * k(1, 4), f, g)
        k(2, 1) = y3(simNo, oldI) + dt / 2 * k(1, 3)
        k(2, 2) = y4(simNo, oldI) + dt / 2 * k(1, 4)
        k(2, 3) = f
        k(2, 4) = g
    
        Call f_g(y1(simNo, oldI) + dt / 2 * k(2, 1), y2(simNo, oldI) + dt / 2 * k(2, 2), _
                 y3(simNo, oldI) + dt / 2 * k(2, 3), y4(simNo, oldI) + dt / 2 * k(2, 4), f, g)
        k(3, 1) = y3(simNo, oldI) + dt / 2 * k(2, 3)
        k(3, 2) = y4(simNo, oldI) + dt / 2 * k(2, 4)
        k(3, 3) = f
        k(3, 4) = g
    
        Call f_g(y1(simNo, oldI) + dt * k(3, 1), y2(simNo, oldI) + dt * k(3, 2), _
                 y3(simNo, oldI) + dt * k(3, 3), y4(simNo, oldI) + dt * k(3, 4), f, g)
        k(4, 1) = y3(simNo, oldI) + dt * k(3, 3)
        k(4, 2) = y4(simNo, oldI) + dt * k(3, 4)
        k(4, 3) = f
        k(4, 4) = g
    
        y1(simNo, newI) = y1(simNo, oldI) + dt / 6 * (k(1, 1) + 2 * k(2, 1) + 2 * k(3, 1) + k(4, 1))
        y2(simNo, newI) = y2(simNo, oldI) + dt / 6 * (k(1, 2) + 2 * k(2, 2) + 2 * k(3, 2) + k(4, 2))
        y3(simNo, newI) = y3(simNo, oldI) + dt / 6 * (k(1, 3) + 2 * k(2, 3) + 2 * k(3, 3) + k(4, 3))
        y4(simNo, newI) = y4(simNo, oldI) + dt / 6 * (k(1, 4) + 2 * k(2, 4) + 2 * k(3, 4) + k(4, 4))
    Next i
Next simNo
End Sub

'***************************************************************************************
'                               energy
'***************************************************************************************
Private Sub energy(phi1 As Double, phi2 As Double, w1 As Double, w2 As Double)
Dim cos_phi2 As Double
Dim sin_phi1 As Double

cos_phi2 = Cos(phi2)
sin_phi1 = Sin(phi1)

Ek_1 = A_1 * w1 ^ 2
Ek_2 = A_2 * w1 ^ 2 - b * w1 ^ 2 * cos_phi2 + c * w2 ^ 2 + (2 * c - b * cos_phi2) * w1 * w2
Ek = Ek_1 + Ek_2
Ep_1 = (m1Big * r1 + m1 * m1Pos) * g * sin_phi1
Ep_2 = m2Arm * g * (-r1 * sin_phi1) + m2 * g * (-r1 * sin_phi1 + m2Pos * Sin(phi1 + phi2))
Ep = Ep_1 + Ep_2
Etot_1 = Ek_1 + Ep_1
Etot_2 = Ek_2 + Ep_2
Etot = Ek + Ep
End Sub

'***************************************************************************************
'                               showEnergyValues
'***************************************************************************************
Private Sub showEnergyValues(Ek1 As Double, Ek2 As Double, Ep1 As Double, Ep2 As Double)

frmP.lblEk1.Caption = Format(Ek1, "0.00")
frmP.lblEk2.Caption = Format(Ek2, "0.00")
frmP.lblEp1.Caption = Format(Ep1, "0.00")
frmP.lblEp2.Caption = Format(Ep2, "0.00")
frmP.lblEtot1.Caption = Format(Ek1 + Ep1, "0.00")
frmP.lblEtot2.Caption = Format(Ek2 + Ep2, "0.00")
frmP.lblEk.Caption = Format(Ek1 + Ek2, "0.00")
frmP.lblEp.Caption = Format(Ep1 + Ep2, "0.00")
frmP.lblEtot.Caption = Format(Ek1 + Ek2 + Ep1 + Ep2, "0.00")
End Sub

'***************************************************************************************
'                              getEnergyMaxMin
'***************************************************************************************
Private Sub getEnergyMaxMin(ByRef Emin As Double, ByRef Emax As Double)
Dim Ep1_min As Double
Dim Ep2_min As Double
Dim Ep1_max As Double
Dim Ep2_max As Double
Dim Ep_min As Double
Dim Ep_max As Double
Dim Ek_max As Double

energy 3 * Pi / 2, 0, 0, 0
Ep1_min = Ep_1
Ep1_max = -Ep1_min
energy Pi / 2, Pi, 0, 0
Ep2_min = Ep_2
Ep2_max = -Ep2_min
Ep_min = Min(Ep1_min, Ep2_min) ' not correct
Ep_max = -Ep_min

energy phi1(simOne), phi2(simOne), w1(simOne), w2(simOne)
Ek_max = Ek + (Ep - Ep_min) ' not correct but pragmatic
Emax = Ek_max + Ep_max
Emin = Ep_min
End Sub

'***************************************************************************************
'                              getMinMax
'***************************************************************************************
Private Sub getMinMax()
Dim stepNo As Long
Dim simNo As Long
Dim nSims As Long
Dim pos1(2) As Double
Dim pos2Abs(2) As Double
Dim pos2Rel(2) As Double

Dim Ek_1_min As Double
Dim Ek_2_min As Double
Dim Ek_min As Double
Dim Ep_1_min As Double
Dim Ep_2_min As Double
Dim Ep_min As Double
Dim E1_min As Double
Dim E2_min As Double
Dim Etot_min As Double

Dim Ek_1_max As Double
Dim Ek_2_max As Double
Dim Ek_max As Double
Dim Ep_1_max As Double
Dim Ep_2_max As Double
Dim Ep_max As Double
Dim E1_max As Double
Dim E2_max As Double
Dim Etot_max As Double

nStepsPerFrame = CLng(frameDuration / dt)

If dual Then nSims = 2 Else nSims = 1
For simNo = 1 To nSims
    pos1_min(simNo) = y1(simNo, 0) + Pi / 2
    pos1_max(simNo) = y1(simNo, 0) + Pi / 2
    pos2Abs_min(simNo) = y1(simNo, 0) + y2(simNo, 0) + Pi / 2
    pos2Abs_max(simNo) = y1(simNo, 0) + y2(simNo, 0) + Pi / 2
    pos2Rel_min(simNo) = y2(simNo, 0)
    pos2Rel_max(simNo) = y2(simNo, 0)
    w1_min(simNo) = y3(simNo, 0)
    w1_max(simNo) = y3(simNo, 0)
    
    w2Rel_min(simNo) = y4(simNo, 0)
    w2Rel_max(simNo) = y4(simNo, 0)
    
    w2Abs_min(simNo) = y3(simNo, 0) + y4(simNo, 0)
    w2Abs_max(simNo) = y3(simNo, 0) + y4(simNo, 0)
Next simNo
energy y1(simOne, 0), y2(simOne, 0), y3(simOne, 0), y4(simOne, 0)

Ek_1_min = Ek_1: Ek_1_max = Ek_1
Ek_2_min = Ek_2: Ek_2_max = Ek_2
Ep_1_min = Ep_1: Ep_1_max = Ep_1
Ep_2_min = Ep_2: Ep_2_max = Ep_2
E1_min = Etot_1 = 1: E1_max = Etot_1
E2_min = Etot_2: E2_max = Etot_2
Ek_min = Ek: Ek_max = Ek
Ep_min = Ep: Ep_max = Ep
Etot_min = Etot: Etot_max = Etot

For stepNo = nStepsPerFrame To nSteps Step nStepsPerFrame
    For simNo = 1 To nSims
        pos1(simNo) = y1(simNo, stepNo) + Pi / 2
        pos2Abs(simNo) = y1(simNo, stepNo) + y2(simNo, stepNo) + Pi / 2
        pos2Rel(simNo) = y2(simNo, stepNo)
        If pos1(simNo) < pos1_min(simNo) Then pos1_min(simNo) = pos1(simNo)
        If pos1(simNo) > pos1_max(simNo) Then pos1_max(simNo) = pos1(simNo)
        If pos2Abs(simNo) < pos2Abs_min(simNo) Then pos2Abs_min(simNo) = pos2Abs(simNo)
        If pos2Abs(simNo) > pos2Abs_max(simNo) Then pos2Abs_max(simNo) = pos2Abs(simNo)
        If pos2Rel(simNo) < pos2Rel_min(simNo) Then pos2Rel_min(simNo) = pos2Rel(simNo)
        If pos2Rel(simNo) > pos2Rel_max(simNo) Then pos2Rel_max(simNo) = pos2Rel(simNo)


        If y3(simNo, stepNo) < w1_min(simNo) Then w1_min(simNo) = y3(simNo, stepNo)
        If y3(simNo, stepNo) > w1_max(simNo) Then w1_max(simNo) = y3(simNo, stepNo)
        
        If y4(simNo, stepNo) < w2Rel_min(simNo) Then w2Rel_min(simNo) = y4(simNo, stepNo)
        If y4(simNo, stepNo) > w2Rel_max(simNo) Then w2Rel_max(simNo) = y4(simNo, stepNo)
        
        If y3(simNo, stepNo) + y4(simNo, stepNo) < w2Abs_min(simNo) Then _
                w2Abs_min(simNo) = y3(simNo, stepNo) + y4(simNo, stepNo)
        If y3(simNo, stepNo) + y4(simNo, stepNo) > w2Abs_max(simNo) Then _
                w2Abs_max(simNo) = y3(simNo, stepNo) + y4(simNo, stepNo)
    Next simNo
    energy y1(simOne, stepNo), y2(simOne, stepNo), y3(simOne, stepNo), y4(simOne, stepNo)

    If Ek_1 < Ek_1_min Then Ek_1_min = Ek_1
    If Ek_1 > Ek_1_max Then Ek_1_max = Ek_1
    If Ek_2 < Ek_2_min Then Ek_2_min = Ek_2
    If Ek_2 > Ek_2_max Then Ek_2_max = Ek_2

    If Ep_1 < Ep_1_min Then Ep_1_min = Ep_1
    If Ep_1 > Ep_1_max Then Ep_1_max = Ep_1
    If Ep_2 < Ep_2_min Then Ep_2_min = Ep_2
    If Ep_2 > Ep_2_max Then Ep_2_max = Ep_2

    If Etot_1 < E1_min Then E1_min = Etot_1
    If Etot_1 > E1_max Then E1_max = Etot_1
    If Etot_2 < E2_min Then E2_min = Etot_2
    If Etot_2 > E2_max Then E2_max = Etot_2

    If Ek < Ek_min Then Ek_min = Ek
    If Ek > Ek_max Then Ek_max = Ek
    If Ep < Ep_min Then Ep_min = Ep
    If Ep > Ep_max Then Ep_max = Ep

    If Etot < Etot_min Then Etot_min = Etot
    If Etot > Etot_max Then Etot_max = Etot
Next stepNo
pos12Abs_min = Min(pos1_min(1), pos2Abs_min(1))
pos12Abs_max = Max(pos1_max(1), pos2Abs_max(1))
pos12Rel_min = Min(pos1_min(1), pos2Rel_min(1))
pos12Rel_max = Max(pos1_max(1), pos2Rel_max(1))

w12Abs_min = Min(w1_min(1), w2Abs_min(1))
w12Abs_max = Max(w1_max(1), w2Abs_max(1))
w12Rel_min = Min(w1_min(1), w2Rel_min(1))
w12Rel_max = Max(w1_max(1), w2Rel_max(1))

E12_min = Min(Min(E1_min, E2_min), Etot_min)
E12_max = Max(Max(E1_max, E2_max), Etot_max)
Ekp_min = Min(Min(Ek_min, Ep_min), Etot_min)
Ekp_max = Max(Max(Ek_max, Ek_max), Etot_max)
Ekp12_min = Min(Min(Ek_1_min, Ek_2_min), Min(Ep_1_min, Ep_2_min))
Ekp12_max = Max(Max(Ek_1_max, Ek_2_max), Max(Ep_1_max, Ep_2_max))
End Sub

'***************************************************************************************
'                              pix
'***************************************************************************************
Public Function pix(pixDown As Long, pixUp As Long, _
                    mini As Double, maxi As Double, xy As Double) As Long
If Abs(maxi - mini) < 0.00001 Then maxi = mini + 0.00001
pix = pixDown + CLng((xy - mini) / (maxi - mini) * CDbl(pixUp - pixDown))
End Function

'***************************************************************************************
'                              setEnergy
'***************************************************************************************
Private Sub setEnergy()
Dim E0pix As Long
Dim pixYmax As Long
Dim Epix As Long

If Not frmP.opt_None Then frmP.picPendulum.top = topMargin
pixYmax = frmP.picEnergy.ScaleHeight
E0pix = pix(pixYmax, 0, Emin, Emax, 0)
frmP.xAxis.y1 = E0pix
frmP.xAxis.y2 = E0pix

' Ek1
frmP.box_Ek1.top = pix(pixYmax, 0, Emin, Emax, Ek_1)
frmP.box_Ek1.Height = Abs(frmP.box_Ek1.top - E0pix)
' Ep1
Epix = pix(pixYmax, 0, Emin, Emax, Ep_1)
If Ep_1 > 0 Then
    frmP.box_Ep1.top = Epix
Else
    frmP.box_Ep1.top = E0pix
End If
frmP.box_Ep1.Height = Abs(Epix - E0pix)
' Ek2
frmP.box_Ek2.top = pix(pixYmax, 0, Emin, Emax, Ek_2)
frmP.box_Ek2.Height = Abs(frmP.box_Ek2.top - E0pix)
' Ep2
Epix = pix(pixYmax, 0, Emin, Emax, Ep_2)
If Ep_2 > 0 Then
    frmP.box_Ep2.top = Epix
Else
    frmP.box_Ep2.top = E0pix
End If
frmP.box_Ep2.Height = Abs(Epix - E0pix)
' E1
Epix = pix(pixYmax, 0, Emin, Emax, Etot_1)
If Etot_1 > 0 Then
    frmP.box_E1.top = Epix
Else
    frmP.box_E1.top = E0pix
End If
frmP.box_E1.Height = Abs(Epix - E0pix)
' E2
Epix = pix(pixYmax, 0, Emin, Emax, Etot_2)
If Etot_2 > 0 Then
    frmP.box_E2.top = Epix
Else
    frmP.box_E2.top = E0pix
End If
frmP.box_E2.Height = Abs(Epix - E0pix)
' Ek
frmP.box_Ek.top = pix(pixYmax, 0, Emin, Emax, Ek)
frmP.box_Ek.Height = Abs(frmP.box_Ek.top - E0pix)
' Ep
Epix = pix(pixYmax, 0, Emin, Emax, Ep)
If Ep > 0 Then
    frmP.box_Ep.top = Epix
Else
    frmP.box_Ep.top = E0pix
End If
frmP.box_Ep.Height = Abs(Epix - E0pix)
' Etot
Epix = pix(pixYmax, 0, Emin, Emax, Etot)
If Etot > 0 Then
    frmP.box_Etot.top = Epix
Else
    frmP.box_Etot.top = E0pix
End If
frmP.box_Etot.Height = Abs(Epix - E0pix)
End Sub

'***************************************************************************************
'                              update
'***************************************************************************************
Private Sub update()

ReadStartValues
Constants
energy phi1(simOne), phi2(simOne), w1(simOne), w2(simOne)
showEnergyValues Ek_1, Ek_2, Ep_1, Ep_2
getEnergyMaxMin Emin, Emax
setEnergy
frmP.picGraph.Cls
pic_Redraw phi1(simOne), phi2(simOne)
If frmP.opt_torus Then
    graphTorus
End If
End Sub

'***************************************************************************************
'                               cmdStart_Click
'***************************************************************************************
Public Sub cmdStart_Click()
Dim simNo As Long
Dim nSims As Long

virgin = False
paus = False
milliSecs = 0
stepNo = 0
phase = 0
readParameters
Constants
ReadStartValues
frmP.cmdPaus.Caption = "&Paus"
If phase = 0 Then
    phase = 1
End If
frmP.timer.Interval = 1000 * frameDuration     ' interval measured in ms

y1(simOne, 0) = phi1(simOne)
y2(simOne, 0) = phi2(simOne)
y3(simOne, 0) = w1(simOne)
y4(simOne, 0) = w2(simOne)
If dual Then
    readButterfly
    y1(simTwo, 0) = phi1(simTwo)
    y2(simTwo, 0) = phi2(simTwo)
    y3(simTwo, 0) = w1(simTwo)
    y4(simTwo, 0) = w2(simTwo)
End If
Runge_Kutta dt, nSteps
getMinMax
frmP.chk_circles.visible = False
frmP.chk_backside.visible = False
frmP.lblTorusArm1.visible = False
frmP.lblTorusArm2.visible = False
If dual Or Not (frmP.opt_None Or frmP.opt_Energy) Then
    If frmP.opt_torus And Not dual Then
        graphTorus
    Else
        graph
    End If
End If
frmP.timer.Enabled = True
End Sub

'***************************************************************************************
'                               cmdPaus_Click
'***************************************************************************************
Public Sub cmdPaus_Click()
If phase > 0 Then
    If Not paus Then
        frmP.Caption = "Paus  T=" + Str(milliSecs \ 1000) + "s"
        frmP.cmdPaus.Caption = "&Fortstt"
        If frmP.opt_torus And Not dual Then
            frmP.chk_circles.visible = True
            frmP.chk_backside.visible = True
            frmP.lblTorusArm1.visible = True
            frmP.lblTorusArm2.visible = True
            torusAxes
        End If
        frmP.timer.Enabled = False
    ElseIf paus Then
        frmP.cmdPaus.Caption = "&Paus"
        frmP.chk_circles.visible = False
        frmP.chk_backside.visible = False
        frmP.lblTorusArm1.visible = False
        frmP.lblTorusArm2.visible = False
        If frmP.opt_torus And Not dual Then graphTorus
        frmP.timer.Enabled = True
    End If
    paus = Not paus
End If
End Sub

'***************************************************************************************
'                               cmdStop_Click
'***************************************************************************************
Public Sub cmdStop_Click()
paus = False
milliSecs = 0
stepNo = 0
phase = 0
frmP.Caption = "Pendeln"
frmP.cmdPaus.Caption = "&Paus"
frmP.timer.Enabled = False
update
If Not (frmP.opt_None Or frmP.opt_Energy) Then
    If frmP.opt_torus Then
        frmP.chk_circles.visible = True
        frmP.chk_backside.visible = True
        graphTorus
    Else
        graph
    End If
End If
End Sub

'***************************************************************************************
'                               timer_Timer()
'***************************************************************************************
Public Sub timer_Timer()
Dim i As Integer
Dim phi1(2) As Double
Dim phi2(2) As Double
Dim frameNo As Long
Dim simNo As Long

frmP.Caption = "T=" + Str(milliSecs \ 1000) + "s"
milliSecs = milliSecs + frmP.timer.Interval

stepNo = stepNo + nStepsPerFrame
If stepNo < nSteps Then
    phi1(simOne) = y1(simOne, stepNo)
    phi2(simOne) = y2(simOne, stepNo)
    w1(simOne) = y3(simOne, stepNo)
    w2(simOne) = y4(simOne, stepNo)
    If dual Or Not (frmP.opt_None Or frmP.opt_Energy) Then
        If frmP.chk_RealTime.Value = vbChecked Then
            frameNo = CLng(CDbl(stepNo) / nStepsPerFrame)
            If frmP.opt_torus And Not dual Then
                graphicTorusStep frameNo
            Else
                graphicStep frameNo
            End If
        End If
    End If
Else ' new GraphTime phase
    phase = phase + 1
    stepNo = 0
    y1(simOne, 0) = y1(simOne, nSteps)
    y2(simOne, 0) = y2(simOne, nSteps)
    y3(simOne, 0) = y3(simOne, nSteps)
    y4(simOne, 0) = y4(simOne, nSteps)
    If dual Then
        y1(simTwo, 0) = y1(simTwo, nSteps)
        y2(simTwo, 0) = y2(simTwo, nSteps)
        y3(simTwo, 0) = y3(simTwo, nSteps)
        y4(simTwo, 0) = y4(simTwo, nSteps)
    End If
    Runge_Kutta dt, nSteps
    getMinMax
    phi1(simOne) = y1(simOne, 0)
    phi2(simOne) = y2(simOne, 0)
    w1(simOne) = y3(simOne, 0)
    w2(simOne) = y4(simOne, 0)
    If dual Or Not (frmP.opt_None Or frmP.opt_Energy) Then
        If frmP.opt_torus Then
            graphTorus
        Else
            graph
        End If
    End If
End If
If frmP.opt_Energy Then
    energy phi1(simOne), phi2(simOne), w1(simOne), w2(simOne)
    showEnergyValues Ek_1, Ek_2, Ep_1, Ep_2
    setEnergy
End If
pic_Redraw phi1(simOne), phi2(simOne)
End Sub

'***************************************************************************************
'                                   pic_Redraw
'***************************************************************************************
Private Sub pic_Redraw(phi1 As Double, phi2 As Double)

frmP.picPendBuf.Cls
frmP.picPendBuf.DrawWidth = picP_W \ 10
frmP.picPendBuf.Line (picP_W \ 4, picP_H - 1)-(3 * picP_W \ 4, picP_H - 1), &H40C0&
frmP.picPendBuf.Line (picP_W \ 2, picP_H)-(picP_W \ 2, picP_H \ 2), &H40C0&
frmP.picPendBuf.DrawWidth = 1
posArm1 phi1, r1, m1Pos
posArm2 phi1, r1, phi2, r2, m2Pos
frmP.picPendulum.Picture = frmP.picPendBuf.Image
End Sub

'***************************************************************************************
'                              posArm1
'***************************************************************************************
Private Sub posArm1(Phi As Double, r As Double, mPos As Double)
Dim r_x As Long
Dim r_y As Long
Dim mPos_x As Long
Dim mPos_y As Long
Dim pixArmW As Long

r_x = CLng(r * Cos(Phi) / mPerPix)
r_y = CLng(r * Sin(Phi) / mPerPix)
pixArmW = b1 / mPerPix
'arm1
frmP.picPendBuf.DrawWidth = b1 / mPerPix
frmP.picPendBuf.Line (axis1_x - r_x, axis1_y + r_y)-(axis1_x + r_x, axis1_y - r_y), colArm1
frmP.picPendBuf.DrawWidth = 1
'axis1
frmP.picPendBuf.FillColor = &HC0E0FF
frmP.picPendBuf.Circle (axis1_x, axis1_y), 5
'm1Big
frmP.picPendBuf.FillColor = &H80C0FF
frmP.picPendBuf.Circle (axis1_x + r_x, axis1_y - r_y), pixArmW \ 2 - 2
'm1
mPos_x = CLng(mPos * Cos(Phi) / mPerPix)
mPos_y = CLng(mPos * Sin(Phi) / mPerPix)
frmP.picPendBuf.FillColor = &H808080
frmP.picPendBuf.Circle (axis1_x + mPos_x, axis1_y - mPos_y), pixArmW \ 3
End Sub
'***************************************************************************************
'                              posArm2
'***************************************************************************************
Private Sub posArm2(phi1 As Double, r1 As Double, phi2 As Double, r2 As Double, m2Pos As Double)
Dim r2_x As Long
Dim r2_y As Long
Dim m2Pos_x As Long
Dim m2Pos_y As Long
Dim pixArmW As Long

axis2_x = axis1_x - CLng(((r1 - b1 / 2) * Cos(phi1)) / mPerPix)
axis2_y = axis1_y + CLng(((r1 - b1 / 2) * Sin(phi1)) / mPerPix)
r2_x = CLng(r2 * Cos(phi1 + phi2) / mPerPix)
r2_y = CLng(r2 * Sin(phi1 + phi2) / mPerPix)
pixArmW = b2 / mPerPix
'arm2
frmP.picPendBuf.DrawWidth = pixArmW
frmP.picPendBuf.Line (axis2_x - r2_x, axis2_y + r2_y)-(axis2_x + r2_x, axis2_y - r2_y), colArm2
frmP.picPendBuf.DrawWidth = 1
'axis2
frmP.picPendBuf.FillColor = &HC0E0FF
frmP.picPendBuf.Circle (axis2_x, axis2_y), 5
'm2
m2Pos_x = CLng(m2Pos * Cos(phi1 + phi2) / mPerPix)
m2Pos_y = CLng(m2Pos * Sin(phi1 + phi2) / mPerPix)
frmP.picPendBuf.FillColor = &H808080
frmP.picPendBuf.Circle (axis2_x + m2Pos_x, axis2_y - m2Pos_y), pixArmW \ 3
End Sub

'***************************************************************************************
'                              scr_m1Pos_Change
'***************************************************************************************
Public Sub scr_m1Pos_Change()
Dim m1Pos_x As Long
Dim m1Pos_y As Long

m1Pos = r1 * CDbl(frmP.scr_m1Pos.Value) / 100
m1Pos_x = CLng(m1Pos * Cos(phi1(simOne)) / mPerPix)
m1Pos_y = CLng(m1Pos * Sin(phi1(simOne)) / mPerPix)
update
End Sub
'***************************************************************************************
'                              scr_m2Pos_Change
'***************************************************************************************
Public Sub scr_m2Pos_Change()
Dim m2Pos_x As Long
Dim m2Pos_y As Long

m2Pos = r2 * CDbl(frmP.scr_m2Pos.Value) / 100
m2Pos_x = CLng(m2Pos * Cos(phi1(simOne) + phi2(simOne)) / mPerPix)
m2Pos_y = CLng(m2Pos * Sin(phi1(simOne) + phi2(simOne)) / mPerPix)
update
End Sub


'***************************************************************************************
'                              graphTorus
'***************************************************************************************
Private Sub graphTorus()
Dim a As Double
Dim b As Double
Dim rWC(3) As Double
Dim rVC(3) As Double
Dim framesToDraw As Long
Dim frameNo As Long

frmP.picPendulum.top = topMargin
frmP.picEnergy.visible = False
frmP.frameEnergy.visible = False
frmP.picGraph.visible = False
frmP.picTorus.visible = True
frmP.picTorus.Cls

a = y1(simOne, 1)
If frmP.opt_PosAbs Then
    b = y1(simOne, 1) + y2(simOne, 1) + Pi / 2
ElseIf frmP.opt_PosRel Then
    b = y2(simOne, 1)
End If
getWC a, b, rWC
getVC rWC, rVC
xPixNew(0) = pix(pixTxMin, pixTxMax, torusXmin, torusXmax, rVC(1))
yPixNew(0) = pix(pixTyMin, pixTyMax, torusYmin, torusYmax, rVC(2))
frmP.picTorus.Picture = frmP.picTorusBuffer.Image
If phase = 0 Then
    torusAxes
    torusDot phi1(simOne), phi2(simOne)
End If
If frmP.chk_circles.Value = vbChecked Then circles
If phase > 0 Then
    If frmP.chk_RealTime.Value = vbChecked And _
            stepNo > 0 And stepNo < nSteps Then 'graph called while drawing
        framesToDraw = CLng(CDbl(stepNo) / nStepsPerFrame)
        For frameNo = 1 To framesToDraw
            graphicTorusStep (frameNo)
        Next frameNo
    End If
    If Not frmP.chk_RealTime.Value = vbChecked Then
        For frameNo = 1 To nFrames
            graphicTorusStep (frameNo)
        Next frameNo
    End If
End If
End Sub

'***************************************************************************************
'                              graphicTorusStep
'***************************************************************************************
Private Sub graphicTorusStep(frameNo As Long)
Dim a As Double
Dim b As Double
Dim aI As Long
Dim bI As Long
Dim rWC(3) As Double
Dim rVC(3) As Double

xPixOld(0) = xPixNew(0)
yPixOld(0) = yPixNew(0)
a = y1(simOne, CLng(frameNo * nStepsPerFrame))
If frmP.opt_PosAbs Then
    b = y1(simOne, CLng(frameNo * nStepsPerFrame)) + y2(simOne, CLng(frameNo * nStepsPerFrame)) + Pi / 2
ElseIf frmP.opt_PosRel Then
    b = y2(simOne, CLng(frameNo * nStepsPerFrame))
End If
aI = CLng(a / da) Mod nDaSteps
If aI < 0 Then aI = aI + nDaSteps
bI = CLng(b / db) Mod nDbSteps
If bI < 0 Then bI = bI + nDbSteps
getWC a, b, rWC
getVC rWC, rVC
xPixNew(0) = pix(pixTxMin, pixTxMax, torusXmin, torusXmax, rVC(1))
yPixNew(0) = pix(pixTyMin, pixTyMax, torusYmin, torusYmax, rVC(2))
If torus(aI, bI).visible Then
    If Not frmP.chk_circles.Value = vbChecked And Not frmP.chk_backside.Value = vbChecked Then
        frmP.picTorus.DrawWidth = 1
    Else
        frmP.picTorus.DrawWidth = 2
    End If
    frmP.picTorus.Line (xPixOld(0), yPixOld(0))-(xPixNew(0), yPixNew(0)), vbBlack
Else
    If frmP.chk_backside.Value = vbChecked Then
        frmP.picTorus.DrawWidth = 1
        frmP.picTorus.Line (xPixOld(0), yPixOld(0))-(xPixNew(0), yPixNew(0)), vbBlack
    End If
End If
End Sub

'***************************************************************************************
'                              setAxes
'***************************************************************************************
Private Sub setAxes(y0Pix As Long, pixYmin As Long, pixYmax As Long, _
                    x0Pix As Long, pixXmin As Long, pixXmax As Long, _
                    xMin As Double, xMax As Double, yMin As Double, yMax As Double)
Dim i As Long
Dim axesInMargin As Boolean

axesInMargin = False
' adjustment when out of scale
If Not (frmP.opt_pos2_pos1 Or frmP.opt_w2_w1 Or frmP.opt_w1_pos1 Or frmP.opt_w2_pos2) Then
    If y0Pix > pixYmin Or y0Pix < pixYmax Then  ' out of scale
        axesInMargin = True
        y0Pix = frmP.y_axis.y1 + 10
    End If
Else  ' phase diagram
    If y0Pix > pixYmin Or y0Pix < pixYmax Or x0Pix < pixXmin Or x0Pix > pixXmax Then
        axesInMargin = True
        y0Pix = frmP.y_axis.y1 + 10
        x0Pix = frmP.x_axis.X1 - 10
    End If
End If

'postion frame away from axis
If y0Pix > frmP.picGraph.ScaleHeight \ 2 Then
    frmP.Frame_Info.top = frmP.picGraph.ScaleHeight \ 8
Else
    frmP.Frame_Info.top = 5 * frmP.picGraph.ScaleHeight \ 8
End If
'-------------------------------xAxis-------------------------------
frmP.x_axis.y1 = y0Pix
frmP.x_axis.y2 = y0Pix
frmP.lbl_xAxis.top = y0Pix - frmP.lbl_xAxis.Height \ 2
If frmP.opt_None Then
    frmP.lbl_xAxis = ""
ElseIf (frmP.opt_pos2_pos1 Or frmP.opt_w2_w1 Or _
        frmP.opt_w1_pos1 Or frmP.opt_w2_pos2) And Not dual Then
    If frmP.opt_pos2_pos1 Then frmP.lbl_xAxis.Caption = "arm1 (varv)"
    If frmP.opt_w2_w1 Then frmP.lbl_xAxis.Caption = "arm1 (varv/s)"
    If frmP.opt_w1_pos1 Or frmP.opt_w2_pos2 Then frmP.lbl_xAxis.Caption = "Lge (varv)"
    frmP.xTickMin.visible = True
    frmP.xTickMax.visible = True
    frmP.xTickMin.y1 = y0Pix - 3
    frmP.xTickMin.y2 = y0Pix + 4
    frmP.xTickMax.y1 = y0Pix - 3
    frmP.xTickMax.y2 = y0Pix + 4
    frmP.lbl_xMin.visible = True
    frmP.lbl_xMax.visible = True
    frmP.lbl_xMin.top = y0Pix + 6
    frmP.lbl_xMax.top = y0Pix + 6
    For i = 0 To 3
        frmP.xTick(i).visible = False
        frmP.lblx(i).visible = False
    Next i
Else   ' time on xAxis
    frmP.lbl_xAxis = "Tid (s)"
    frmP.xTickMin.visible = False
    frmP.xTickMax.visible = False
    frmP.lbl_xMin.visible = False
    frmP.lbl_xMax.visible = False
    For i = 0 To 3
        frmP.xTick(i).visible = True
        frmP.lblx(i).visible = True
        frmP.xTick(i).y1 = y0Pix - 3
        frmP.xTick(i).y2 = y0Pix + 4
        If phase > 0 Then
            frmP.lblx(i).Caption = Format((phase - 1) * graphTime + (i + 1) / 4 * graphTime, "0.0")
        Else
            frmP.lblx(i).Caption = ""
        End If
        frmP.lblx(i).top = y0Pix + 6
    Next i
End If
'---------------------------------yAxis-------------------------------
frmP.y_axis.X1 = x0Pix
frmP.y_axis.X2 = x0Pix
frmP.lbl_yMin.visible = True: frmP.lbl_yMax.visible = True
frmP.yTickMin.X1 = x0Pix - 3
frmP.yTickMin.X2 = x0Pix + 4
frmP.yTickMax.X1 = x0Pix - 3
frmP.yTickMax.X2 = x0Pix + 4
frmP.lbl_yMin.left = x0Pix - frmP.lbl_yMin.Width - 5
frmP.lbl_yMax.left = x0Pix - frmP.lbl_yMax.Width - 5
If frmP.opt_None Then
    frmP.lbl_yAxis = ""
ElseIf frmP.opt_pos_t Or (dual And (frmP.opt_diff_pos1 Or frmP.opt_diff_pos2)) Then
    frmP.lbl_yAxis = "Lge (varv)"
ElseIf frmP.opt_w_t Or (dual And (frmP.opt_diff_w1 Or frmP.opt_diff_w2)) Then
    frmP.lbl_yAxis = "Rotation (varv/s)"
ElseIf frmP.opt_pos2_pos1 Then
    frmP.lbl_yAxis = "arm2 (varv)"
ElseIf frmP.opt_w2_w1 Then
    frmP.lbl_yAxis = "arm2 (varv/s)"
ElseIf frmP.opt_w1_pos1 Or frmP.opt_w2_pos2 Then
    frmP.lbl_yAxis = "Rotation (varv/s)"
Else ' Energy Time
    frmP.lbl_yAxis = "Energi (J)"
End If
frmP.lbl_yAxis.left = Max(10, x0Pix - frmP.lbl_yAxis.Width \ 2)
If phase > 0 Then ' avoid clash with minmax label and axis
    If Abs((yMin - 0) / (yMax - yMin)) < 0.1 And Not axesInMargin Then _
        frmP.lbl_yMin.visible = False: frmP.lbl_yMin = "" Else frmP.lbl_yMin = Format(yMin, "0.0")
    If Abs((yMax - 0) / (yMax - yMin)) < 0.1 And Not axesInMargin Then _
        frmP.lbl_yMax.visible = False: frmP.lbl_yMax = "" Else frmP.lbl_yMax = Format(yMax, "0.0")
    If Abs((xMin - 0) / (xMax - xMin)) < 0.1 And Not axesInMargin Then _
        frmP.lbl_xMin.visible = False: frmP.lbl_xMin = "" Else frmP.lbl_xMin = Format(xMin, "0.0")
    If Abs((xMax - 0) / (xMax - xMin)) < 0.1 And Not axesInMargin Then _
        frmP.lbl_xMax.visible = False: frmP.lbl_xMax = "" Else frmP.lbl_xMax = Format(xMax, "0.0")
End If
End Sub

'***************************************************************************************
'                              graph
'***************************************************************************************
Private Sub graph()
Dim frameNo As Long
Dim i As Long
Dim pos1(2) As Double
Dim pos2(2) As Double
Dim w1(2) As Double
Dim w2(2) As Double
Dim nFramesToDraw As Long
Dim simNo As Long

frmP.picPendulum.top = topMargin
frmP.lblBox1.FontBold = False: frmP.lblBox2.FontBold = False
frmP.lblBox3.FontBold = False: frmP.lblBox4.FontBold = False
frmP.picEnergy.visible = False
frmP.frameEnergy.visible = False
frmP.picTorus.visible = False
frmP.picGraph.visible = True
frmP.picGraph.Cls
If phase > 0 Then
    pos1(simOne) = (y1(simOne, 1) + Pi / 2) / (2 * Pi)
    w1(simOne) = y3(simOne, 1)
    If frmP.opt_PosAbs Then
        pos2(simOne) = (y1(simOne, 1) + y2(simOne, 1) + Pi / 2) / (2 * Pi)
        w2(simOne) = y3(simOne, 1) + y4(simOne, 1)
    ElseIf frmP.opt_PosRel Then
        pos2(simOne) = y2(simOne, 1) / (2 * Pi)
        w2(simOne) = y4(simOne, 1)
    End If
    If dual Then
        pos1(simTwo) = (y1(simTwo, 1) + Pi / 2) / (2 * Pi)
        w1(simTwo) = y3(simTwo, 1)
        If frmP.opt_PosAbs Then
            pos2(simTwo) = (y1(simTwo, 1) + y2(simTwo, 1) + Pi / 2) / (2 * Pi)
            w2(simTwo) = y3(simTwo, 1) + y4(simTwo, 1)
        ElseIf frmP.opt_PosRel Then
            pos2(simTwo) = y2(simTwo, 1) / (2 * Pi)
            w2(simTwo) = y4(simTwo, 1)
        End If
    End If
End If
' GraphArea
pixYmax = frmP.yTickMax.y1
pixYmin = frmP.yTickMin.y1
pixXmax = frmP.xTickMax.X1
pixXmin = frmP.xTickMin.X1
' for time on x-axis
xMin = 0
xMax = graphTime
If dual Then
    frmP.box1.visible = True: frmP.lblBox1.visible = True
    frmP.box2.visible = True: frmP.lblBox2.visible = True
    frmP.box1.FillColor = colEk: frmP.lblBox1 = "Original"
    frmP.box2.FillColor = colEp: frmP.lblBox2 = "Kopia"
    frmP.box3.visible = False: frmP.lblBox3.visible = False
    frmP.box4.visible = False: frmP.lblBox4.visible = False
    If phase > 0 Then
        If frmP.opt_diff_pos1 Then
            yMin = Min(pos1_min(simOne), pos1_min(simTwo)) / (2 * Pi)
            yMax = Max(pos1_max(simOne), pos1_max(simTwo)) / (2 * Pi)
            yPixNew(1) = pix(pixYmin, pixYmax, yMin, yMax, pos1(simOne))
            yPixNew(2) = pix(pixYmin, pixYmax, yMin, yMax, pos1(simTwo))
        ElseIf frmP.opt_diff_pos2 Then
            If frmP.opt_PosAbs Then
                yMin = Min(pos2Abs_min(simOne), pos2Abs_min(simTwo)) / (2 * Pi)
                yMax = Max(pos2Abs_max(simOne), pos2Abs_max(simTwo)) / (2 * Pi)
            ElseIf frmP.opt_PosRel Then
                yMin = Min(pos2Rel_min(simOne), pos2Rel_min(simTwo)) / (2 * Pi)
                yMax = Max(pos2Rel_max(simOne), pos2Rel_max(simTwo)) / (2 * Pi)
            End If
            yPixNew(1) = pix(pixYmin, pixYmax, yMin, yMax, pos2(simOne))
            yPixNew(2) = pix(pixYmin, pixYmax, yMin, yMax, pos2(simTwo))
        ElseIf frmP.opt_diff_w1 Then
            yMin = Min(w1_min(simOne), w1_min(simTwo)) / (2 * Pi)
            yMax = Max(w1_max(simOne), w1_max(simTwo)) / (2 * Pi)
            yPixNew(1) = pix(pixYmin, pixYmax, yMin, yMax, w1(simOne) / (2 * Pi))
            yPixNew(2) = pix(pixYmin, pixYmax, yMin, yMax, w1(simTwo) / (2 * Pi))
        ElseIf frmP.opt_diff_w2 Then
            If frmP.opt_PosAbs Then
                yMin = Min(w2Abs_min(simOne), w2Abs_min(simTwo)) / (2 * Pi)
                yMax = Max(w2Abs_max(simOne), w2Abs_max(simTwo)) / (2 * Pi)
            ElseIf frmP.opt_PosRel Then
                yMin = Min(w2Rel_min(simOne), w2Rel_min(simTwo)) / (2 * Pi)
                yMax = Max(w2Rel_max(simOne), w2Rel_max(simTwo)) / (2 * Pi)
            End If
            yPixNew(1) = pix(pixYmin, pixYmax, yMin, yMax, w2(simOne) / (2 * Pi))
            yPixNew(2) = pix(pixYmin, pixYmax, yMin, yMax, w2(simTwo) / (2 * Pi))
        End If
        xPixNew(1) = pixXmin
        xPixNew(2) = pixXmin
    End If
ElseIf frmP.opt_pos_t Then
    frmP.box1.visible = True: frmP.lblBox1.visible = True
    frmP.box2.visible = True: frmP.lblBox2.visible = True
    frmP.box1.FillColor = colArm1: frmP.lblBox1 = "Arm1"
    frmP.box2.FillColor = colArm2: frmP.lblBox2 = "Arm2"
    frmP.box3.visible = False: frmP.lblBox3.visible = False
    frmP.box4.visible = False: frmP.lblBox4.visible = False
    If phase > 0 Then
        If frmP.opt_PosAbs Then
            yMin = pos12Abs_min / (2 * Pi)
            yMax = pos12Abs_max / (2 * Pi)
        ElseIf frmP.opt_PosRel Then
            yMin = pos12Rel_min / (2 * Pi)
            yMax = pos12Rel_max / (2 * Pi)
        End If
        yPixNew(1) = pix(pixYmin, pixYmax, yMin, yMax, pos1(simOne))
        yPixNew(2) = pix(pixYmin, pixYmax, yMin, yMax, pos2(simOne))
        xPixNew(1) = pixXmin
        xPixNew(2) = pixXmin
    End If
ElseIf frmP.opt_pos2_pos1 Then
    frmP.box1.visible = False: frmP.lblBox1.visible = False
    frmP.box2.visible = False: frmP.lblBox2.visible = False
    frmP.box3.visible = False: frmP.lblBox3.visible = False
    frmP.box4.visible = False: frmP.lblBox4.visible = False
    If phase > 0 Then
        If frmP.opt_PosAbs Then
            yMin = pos2Abs_min(simOne) / (2 * Pi)
            yMax = pos2Abs_max(simOne) / (2 * Pi)
        ElseIf frmP.opt_PosRel Then
            yMin = pos2Rel_min(simOne) / (2 * Pi)
            yMax = pos2Rel_max(simOne) / (2 * Pi)
        End If
        xMin = pos1_min(simOne) / (2 * Pi)
        xMax = pos1_max(simOne) / (2 * Pi)
        xPixNew(1) = pix(pixXmin, pixXmax, xMin, xMax, pos1(simOne))
        yPixNew(1) = pix(pixYmin, pixYmax, yMin, yMax, pos2(simOne))
    End If
ElseIf frmP.opt_w_t Then
    frmP.box1.visible = True: frmP.lblBox1.visible = True
    frmP.box2.visible = True: frmP.lblBox2.visible = True
    frmP.box1.FillColor = colArm1: frmP.lblBox1 = "Arm1"
    frmP.box2.FillColor = colArm2: frmP.lblBox2 = "Arm2"
    frmP.box3.visible = False: frmP.lblBox3.visible = False
    frmP.box4.visible = False: frmP.lblBox4.visible = False
    If phase > 0 Then
        If frmP.opt_PosAbs Then
            yMin = w12Abs_min / (2 * Pi)
            yMax = w12Abs_max / (2 * Pi)
        ElseIf frmP.opt_PosRel Then
            yMin = w12Rel_min / (2 * Pi)
            yMax = w12Rel_max / (2 * Pi)
        End If
        yPixNew(1) = pix(pixYmin, pixYmax, yMin, yMax, w1(simOne) / (2 * Pi))
        yPixNew(2) = pix(pixYmin, pixYmax, yMin, yMax, w2(simOne) / (2 * Pi))
        xPixNew(1) = pixXmin
        xPixNew(2) = pixXmin
    End If
ElseIf frmP.opt_w2_w1 Then
    frmP.box1.visible = False: frmP.lblBox1.visible = False
    frmP.box2.visible = False: frmP.lblBox2.visible = False
    frmP.box3.visible = False: frmP.lblBox3.visible = False
    frmP.box4.visible = False: frmP.lblBox4.visible = False
    If phase > 0 Then
        If frmP.opt_PosAbs Then
            yMin = w2Abs_min(simOne) / (2 * Pi)
            yMax = w2Abs_max(simOne) / (2 * Pi)
        ElseIf frmP.opt_PosRel Then
            yMin = w2Rel_min(simOne) / (2 * Pi)
            yMax = w2Rel_max(simOne) / (2 * Pi)
        End If
        xMin = w1_min(simOne) / (2 * Pi)
        xMax = w1_max(simOne) / (2 * Pi)
        xPixNew(1) = pix(pixXmin, pixXmax, xMin, xMax, w1(simOne) / (2 * Pi))
        yPixNew(1) = pix(pixYmin, pixYmax, yMin, yMax, w2(simOne) / (2 * Pi))
    End If
ElseIf frmP.opt_w1_pos1 Then
    frmP.box1.visible = True: frmP.lblBox1.visible = True
    frmP.box1.FillColor = colArm1: frmP.lblBox1 = "Arm1"
    frmP.box2.visible = False: frmP.lblBox2.visible = False
    frmP.box3.visible = False: frmP.lblBox3.visible = False
    frmP.box4.visible = False: frmP.lblBox4.visible = False
    If phase > 0 Then
        yMin = w1_min(simOne) / (2 * Pi)
        yMax = w1_max(simOne) / (2 * Pi)
        xMin = pos1_min(simOne) / (2 * Pi)
        xMax = pos1_max(simOne) / (2 * Pi)
        xPixNew(1) = pix(pixXmin, pixXmax, xMin, xMax, pos1(simOne))
        yPixNew(1) = pix(pixYmin, pixYmax, yMin, yMax, w1(simOne) / (2 * Pi))
    End If
ElseIf frmP.opt_w2_pos2 Then
    frmP.box1.visible = True: frmP.lblBox1.visible = True
    frmP.box1.FillColor = colArm2: frmP.lblBox1 = "Arm2"
    frmP.box2.visible = False: frmP.lblBox2.visible = False
    frmP.box3.visible = False: frmP.lblBox3.visible = False
    frmP.box4.visible = False: frmP.lblBox4.visible = False
    If phase > 0 Then
            If frmP.opt_PosAbs Then
            yMin = w2Abs_min(simOne) / (2 * Pi)
            yMax = w2Abs_max(simOne) / (2 * Pi)
            xMin = pos2Abs_min(simOne) / (2 * Pi)
            xMax = pos2Abs_max(simOne) / (2 * Pi)
        ElseIf frmP.opt_PosRel Then
            yMin = w2Rel_min(simOne) / (2 * Pi)
            yMax = w2Rel_max(simOne) / (2 * Pi)
            xMin = pos2Rel_min(simOne) / (2 * Pi)
            xMax = pos2Rel_max(simOne) / (2 * Pi)
        End If
        xPixNew(1) = pix(pixXmin, pixXmax, xMin, xMax, pos2(simOne))
        yPixNew(1) = pix(pixYmin, pixYmax, yMin, yMax, w2(simOne) / (2 * Pi))
    End If
ElseIf frmP.opt_E1_E2 Then
    frmP.box1.visible = True: frmP.lblBox1.visible = True
    frmP.box2.visible = True: frmP.lblBox2.visible = True
    frmP.box3.visible = True: frmP.lblBox3.visible = True
    frmP.box1.FillColor = colArm1: frmP.lblBox1 = "Arm1"
    frmP.box2.FillColor = colArm2: frmP.lblBox2 = "Arm2"
    frmP.box3.FillColor = colPendulum: frmP.lblBox3 = "Totalt"
    frmP.box4.visible = False: frmP.lblBox4.visible = False
    If phase > 0 Then
        yMin = E12_min
        yMax = E12_max
        energy y1(simOne, 1), y2(simOne, 1), y3(simOne, 1), y4(simOne, 1)
        yPixNew(1) = pix(pixYmin, pixYmax, yMin, yMax, Etot_1)
        yPixNew(2) = pix(pixYmin, pixYmax, yMin, yMax, Etot_2)
        yPixNew(3) = pix(pixYmin, pixYmax, yMin, yMax, Etot)
        xPixNew(1) = pixXmin
        xPixNew(2) = pixXmin
        xPixNew(3) = pixXmin
    End If
ElseIf frmP.opt_Ek_Ep Then
    frmP.box1.visible = True: frmP.lblBox1.visible = True
    frmP.box2.visible = True: frmP.lblBox2.visible = True
    frmP.box3.visible = True: frmP.lblBox3.visible = True
    frmP.box1.FillColor = colEk: frmP.lblBox1 = "Kinetisk"
    frmP.box2.FillColor = colEp: frmP.lblBox2 = "Lges"
    frmP.box3.FillColor = colPendulum: frmP.lblBox3 = "Totalt"
    frmP.box4.visible = False: frmP.lblBox4.visible = False
    If phase > 0 Then
        yMin = Ekp_min
        yMax = Ekp_max
        energy y1(simOne, 1), y2(simOne, 1), y3(simOne, 1), y4(simOne, 1)
        yPixNew(1) = pix(pixYmin, pixYmax, yMin, yMax, Ek)
        yPixNew(2) = pix(pixYmin, pixYmax, yMin, yMax, Ep)
        yPixNew(3) = pix(pixYmin, pixYmax, yMin, yMax, Etot)
        xPixNew(1) = pixXmin
        xPixNew(2) = pixXmin
        xPixNew(3) = pixXmin
    End If
ElseIf frmP.opt_Ekp12 Then
    frmP.box1.visible = True: frmP.lblBox1.visible = True
    frmP.box2.visible = True: frmP.lblBox2.visible = True
    frmP.box3.visible = True: frmP.lblBox3.visible = True
    frmP.box4.visible = True: frmP.lblBox4.visible = True
    frmP.lblBox1.FontBold = True
    frmP.box1.FillColor = colArm1: frmP.lblBox1 = "Kin. Arm1"
    frmP.box2.FillColor = colArm1: frmP.lblBox2 = "Pot."
    frmP.lblBox3.FontBold = True
    frmP.box3.FillColor = colArm2: frmP.lblBox3 = "Kin. Arm2"
    frmP.box4.FillColor = colArm2: frmP.lblBox4 = "Pot."
    If phase > 0 Then
        yMin = Ekp12_min
        yMax = Ekp12_max
        energy y1(simOne, 1), y2(simOne, 1), y3(simOne, 1), y4(simOne, 1)
        yPixNew(1) = pix(pixYmin, pixYmax, yMin, yMax, Ek_1)
        yPixNew(2) = pix(pixYmin, pixYmax, yMin, yMax, Ep_1)
        yPixNew(3) = pix(pixYmin, pixYmax, yMin, yMax, Ek_2)
        yPixNew(4) = pix(pixYmin, pixYmax, yMin, yMax, Ep_2)
        xPixNew(1) = pixXmin
        xPixNew(2) = pixXmin
        xPixNew(3) = pixXmin
        xPixNew(4) = pixXmin
    End If
End If
If phase > 0 Then ' avoid clash with minmax label and axis
    If frmP.opt_pos2_pos1 Or frmP.opt_w2_w1 Or frmP.opt_w1_pos1 Or frmP.opt_w2_pos2 Then
        x0Pix = pix(pixXmin, pixXmax, xMin, xMax, 0)
    Else ' time  on xAxis
        x0Pix = frmP.xTickMin.X1
    End If
    y0Pix = pix(pixYmin, pixYmax, yMin, yMax, 0)
End If
If virgin Then
    If dual Then
        x0Pix = frmP.xTickMin.X1
        y0Pix = frmP.picGraph.ScaleHeight \ 2
    ElseIf frmP.opt_pos2_pos1 Or frmP.opt_w2_w1 Or frmP.opt_w1_pos1 Or frmP.opt_w2_pos2 Then
        x0Pix = (frmP.xTickMin.X1 + frmP.xTickMax.X1) \ 2
        y0Pix = frmP.picGraph.ScaleHeight \ 2
    ElseIf frmP.opt_pos_t Or frmP.opt_w_t Then
        x0Pix = frmP.xTickMin.X1
        y0Pix = frmP.picGraph.ScaleHeight \ 2
    Else ' time  on xAxis
        x0Pix = frmP.xTickMin.X1
        y0Pix = 3 * frmP.picGraph.ScaleHeight \ 4
    End If
End If
setAxes y0Pix, pixYmin, pixYmax, x0Pix, pixXmin, pixXmax, xMin, xMax, yMin, yMax
If phase > 0 Then
    If frmP.chk_RealTime.Value = vbChecked And _
                stepNo > 0 And stepNo < nSteps Then 'graph called while drawing
        nFramesToDraw = CLng(CDbl(stepNo) / nStepsPerFrame)
        For frameNo = 1 To nFramesToDraw
            graphicStep frameNo
        Next frameNo
    End If
    If Not frmP.chk_RealTime.Value = vbChecked Then
        For frameNo = 1 To nFrames
            graphicStep frameNo
        Next frameNo
    End If
End If
End Sub

'***************************************************************************************
'                              graphicStep
'***************************************************************************************
Private Sub graphicStep(frameNo As Long)
Dim pos1(2) As Double
Dim pos2(2) As Double
Dim w1(2) As Double
Dim w2(2) As Double
Dim yVal(4) As Double
Dim i As Long
Dim nGraphs As Long
Dim dWidth(4) As Long
Dim col(4) As Long


pos1(simOne) = (y1(simOne, CLng(frameNo * nStepsPerFrame)) + Pi / 2) / (2 * Pi)
w1(simOne) = y3(simOne, CLng(frameNo * nStepsPerFrame))
If frmP.opt_PosAbs Then
    pos2(simOne) = (y1(simOne, CLng(frameNo * nStepsPerFrame)) + y2(simOne, CLng(frameNo * nStepsPerFrame)) + Pi / 2) / (2 * Pi)
    w2(simOne) = y3(simOne, CLng(frameNo * nStepsPerFrame)) + y4(simOne, CLng(frameNo * nStepsPerFrame))
ElseIf frmP.opt_PosRel Then
    pos2(simOne) = y2(simOne, CLng(frameNo * nStepsPerFrame)) / (2 * Pi)
    w2(simOne) = y4(simOne, CLng(frameNo * nStepsPerFrame))
End If
If (frmP.opt_pos2_pos1 Or frmP.opt_w2_w1 Or frmP.opt_w1_pos1 Or frmP.opt_w2_pos2) And Not dual Then
    xPixOld(1) = xPixNew(1)
    yPixOld(1) = yPixNew(1)
    If frmP.opt_pos2_pos1 Then
        xPixNew(1) = pix(pixXmin, pixXmax, xMin, xMax, pos1(simOne))
        yPixNew(1) = pix(pixYmin, pixYmax, yMin, yMax, pos2(simOne))
        col(1) = vbBlack
    ElseIf frmP.opt_w2_w1 Then
        xPixNew(1) = pix(pixXmin, pixXmax, xMin, xMax, w1(simOne) / (2 * Pi))
        yPixNew(1) = pix(pixYmin, pixYmax, yMin, yMax, w2(simOne) / (2 * Pi))
        col(1) = vbBlack
    ElseIf frmP.opt_w1_pos1 Then
        xPixNew(1) = pix(pixXmin, pixXmax, xMin, xMax, pos1(simOne))
        yPixNew(1) = pix(pixYmin, pixYmax, yMin, yMax, w1(simOne) / (2 * Pi))
        col(1) = colArm1
    ElseIf frmP.opt_w2_pos2 Then
        xPixNew(1) = pix(pixXmin, pixXmax, xMin, xMax, pos2(simOne))
        yPixNew(1) = pix(pixYmin, pixYmax, yMin, yMax, w2(simOne) / (2 * Pi))
        col(1) = colArm2
    End If
    frmP.picGraph.Line (xPixOld(1), yPixOld(1))-(xPixNew(1), yPixNew(1)), col(1)
Else ' time on xAxis
    For i = 1 To 4
        dWidth(i) = 1
        xPixOld(i) = xPixNew(i)
        yPixOld(i) = yPixNew(i)
        xPixNew(i) = pix(pixXmin, pixXmax, xMin, xMax, frameNo * frameDuration)
    Next i
    energy y1(simOne, CLng(frameNo * nStepsPerFrame)), y2(simOne, CLng(frameNo * nStepsPerFrame)), _
           y3(simOne, CLng(frameNo * nStepsPerFrame)), y4(simOne, CLng(frameNo * nStepsPerFrame))
    If dual Then
        nGraphs = 2
        pos1(simTwo) = (y1(simTwo, CLng(frameNo * nStepsPerFrame)) + Pi / 2) / (2 * Pi)
        w1(simTwo) = y3(simTwo, CLng(frameNo * nStepsPerFrame))
        If frmP.opt_PosAbs Then
            pos2(simTwo) = (y1(simTwo, CLng(frameNo * nStepsPerFrame)) + _
                            y2(simTwo, CLng(frameNo * nStepsPerFrame)) + Pi / 2) / (2 * Pi)
            w2(simTwo) = y3(simTwo, CLng(frameNo * nStepsPerFrame)) + _
                         y4(simTwo, CLng(frameNo * nStepsPerFrame))
        ElseIf frmP.opt_PosRel Then
            pos2(simTwo) = y2(simTwo, CLng(frameNo * nStepsPerFrame)) / (2 * Pi)
            w2(simTwo) = y4(simTwo, CLng(frameNo * nStepsPerFrame))
        End If
        If frmP.opt_diff_pos1 Then
            yVal(1) = pos1(simOne)
            yVal(2) = pos1(simTwo)
        ElseIf frmP.opt_diff_pos2 Then
            yVal(1) = pos2(simOne)
            yVal(2) = pos2(simTwo)
        ElseIf frmP.opt_diff_w1 Then
            yVal(1) = w1(simOne) / (2 * Pi)
            yVal(2) = w1(simTwo) / (2 * Pi)
        ElseIf frmP.opt_diff_w2 Then
            yVal(1) = w2(simOne) / (2 * Pi)
            yVal(2) = w2(simTwo) / (2 * Pi)
        End If
        yPixNew(1) = pix(pixYmin, pixYmax, yMin, yMax, yVal(1))
        yPixNew(2) = pix(pixYmin, pixYmax, yMin, yMax, yVal(2))
        col(1) = colEk: col(2) = colEp
    ElseIf frmP.opt_pos_t Then
        nGraphs = 2
        yPixNew(1) = pix(pixYmin, pixYmax, yMin, yMax, pos1(simOne))
        yPixNew(2) = pix(pixYmin, pixYmax, yMin, yMax, pos2(simOne))
        col(1) = colArm1: col(2) = colArm2
    ElseIf frmP.opt_w_t Then
        nGraphs = 2
        yPixNew(1) = pix(pixYmin, pixYmax, yMin, yMax, w1(simOne) / (2 * Pi))
        yPixNew(2) = pix(pixYmin, pixYmax, yMin, yMax, w2(simOne) / (2 * Pi))
        col(1) = colArm1: col(2) = colArm2
    ElseIf frmP.opt_E1_E2 Then
        nGraphs = 3
        yPixNew(1) = pix(pixYmin, pixYmax, yMin, yMax, Etot_1)
        yPixNew(2) = pix(pixYmin, pixYmax, yMin, yMax, Etot_2)
        yPixNew(3) = pix(pixYmin, pixYmax, yMin, yMax, Etot)
        col(1) = colArm1: col(2) = colArm2: col(3) = colPendulum
        dWidth(3) = 2
    ElseIf frmP.opt_Ek_Ep Then
        nGraphs = 3
        yPixNew(1) = pix(pixYmin, pixYmax, yMin, yMax, Ek)
        yPixNew(2) = pix(pixYmin, pixYmax, yMin, yMax, Ep)
        yPixNew(3) = pix(pixYmin, pixYmax, yMin, yMax, Etot)
        col(1) = colEk: col(2) = colEp: col(3) = colPendulum
        dWidth(3) = 2
    ElseIf frmP.opt_Ekp12 Then
        nGraphs = 4
        yPixNew(1) = pix(pixYmin, pixYmax, yMin, yMax, Ek_1)
        yPixNew(2) = pix(pixYmin, pixYmax, yMin, yMax, Ep_1)
        yPixNew(3) = pix(pixYmin, pixYmax, yMin, yMax, Ek_2)
        yPixNew(4) = pix(pixYmin, pixYmax, yMin, yMax, Ep_2)
        col(1) = colArm1: col(2) = colArm1: col(3) = colArm2: col(4) = colArm2
        dWidth(1) = 2: dWidth(3) = 2
    End If
    For i = 1 To nGraphs
        frmP.picGraph.DrawWidth = dWidth(i)
        frmP.picGraph.Line (xPixOld(i), yPixOld(i))-(xPixNew(i), yPixNew(i)), col(i)
    Next i
    frmP.picGraph.DrawWidth = 1
End If
End Sub


'***************************************************************************************
'                              getRmatrix
'***************************************************************************************
Private Sub getRmatrix()
r(1, 1) = 1: r(1, 2) = 0: r(1, 3) = 0
r(2, 1) = 0: r(2, 2) = Cos(view): r(2, 3) = -Sin(view)
r(3, 1) = 0: r(3, 2) = Sin(view): r(3, 3) = Cos(view)
End Sub
'***************************************************************************************
'                              getWC WorldCoordinates
'***************************************************************************************
Private Sub getWC(a As Double, b As Double, rWC() As Double)
Dim r_xz  As Double

r_xz = r_a + r_b * Cos(b)
rWC(1) = r_xz * Cos(a)
rWC(2) = r_b * Sin(b)
rWC(3) = -r_xz * Sin(a)
End Sub
'***************************************************************************************
'                              getVC ViewCoordinates
'***************************************************************************************
Private Sub getVC(rWC() As Double, rVC() As Double)
Dim i As Long
Dim j As Long

For i = 1 To 3
    rVC(i) = 0
    For j = 1 To 3
        rVC(i) = rVC(i) + r(i, j) * rWC(j)
    Next j
Next i
End Sub
'***************************************************************************************
'                              initiateData
'           visibility true, torus_X_Y_min_max  viewCoordinate database
'***************************************************************************************
Private Sub initiatedata(stepsDa As Long, stepsDb As Long)
Dim aI As Long
Dim bI As Long
Dim r_wc(3) As Double
Dim r_vc(3) As Double

torusXmin = 0
torusXmax = 0
torusYmin = 0
torusYmax = 0
For aI = 0 To stepsDa - 1
    For bI = 0 To stepsDb - 1
        torus(aI, bI).visible = True
        getWC CDbl(aI) * da, CDbl(bI) * db, r_wc
        getVC r_wc, r_vc
        If r_vc(1) < torusXmin Then torusXmin = r_vc(1)
        If r_vc(1) > torusXmax Then torusXmax = r_vc(1)
        If r_vc(2) < torusYmin Then torusYmin = r_vc(2)
        If r_vc(2) > torusYmax Then torusYmax = r_vc(2)
        vc_database(aI, bI, 1) = r_vc(1)
        vc_database(aI, bI, 2) = r_vc(2)
        vc_database(aI, bI, 3) = r_vc(3)
    Next bI
Next aI
End Sub
'***************************************************************************************
'                              getVC_DB
'***************************************************************************************
Private Sub getVC_DB(aI As Long, bI As Long, rVC() As Double)

rVC(1) = vc_database(aI, bI, 1)
rVC(2) = vc_database(aI, bI, 2)
rVC(3) = vc_database(aI, bI, 3)
End Sub
'***************************************************************************************
'                              vectorSub
'***************************************************************************************
Private Sub vectorSub(a() As Double, b() As Double, A_B() As Double)
A_B(1) = a(1) - b(1)
A_B(2) = a(2) - b(2)
A_B(3) = a(3) - b(3)
End Sub
'***************************************************************************************
'                              getNormal
'***************************************************************************************
Private Sub getNormal(a() As Double, b() As Double, N() As Double)
Dim L As Double
' crossproduct of unit length
N(1) = a(2) * b(3) - a(3) * b(2)
N(2) = a(3) * b(1) - a(1) * b(3)
N(3) = a(1) * b(2) - a(2) * b(1)
L = Sqr(N(1) ^ 2 + N(2) ^ 2 + N(3) ^ 2)
N(1) = N(1) / L
N(2) = N(2) / L
N(3) = N(3) / L
End Sub
'***************************************************************************************
'                              getColor
'***************************************************************************************
Private Function getColor(Nx As Double, Ny As Double, Nz As Double, _
                     Lx As Double, Ly As Double, Lz As Double) As Long
Dim L As Double
Dim r As Single
Dim g As Single
Dim b As Single

L = (L_amb + L_dir * (Nx * Lx + Ny * Ly + Nz * Lz)) / L_max
HLStoRGB H, CSng(L), S, r, g, b
getColor = RGB(CInt(r * 255), CInt(g * 255), CInt(b * 255))
End Function
'***************************************************************************************
'                              setScanInfo
'***************************************************************************************
Private Sub setScanInfo(aI As Long, bI As Long, _
            r_vc() As Double, rpa_vc() As Double, rpb_vc() As Double, rpab_vc() As Double)

Dim p(4) As Point
Dim ps(4) As Point

Dim topI As Long
Dim i As Long
Dim yI As Long
Dim pt2 As Long
Dim nLines As Long
Dim dxOdy As Double
Dim scanlineNo As Long

' points stored in postive anticlockwise direction for all (a,b) with Nz outwards
p(0).x = pix(pixTxMin, pixTxMax, torusXmin, torusXmax, r_vc(1))
p(0).y = pix(pixTyMin, pixTyMax, torusYmin, torusYmax, r_vc(2))
p(1).x = pix(pixTxMin, pixTxMax, torusXmin, torusXmax, rpa_vc(1))
p(1).y = pix(pixTyMin, pixTyMax, torusYmin, torusYmax, rpa_vc(2))
p(2).x = pix(pixTxMin, pixTxMax, torusXmin, torusXmax, rpab_vc(1))
p(2).y = pix(pixTyMin, pixTyMax, torusYmin, torusYmax, rpab_vc(2))
p(3).x = pix(pixTxMin, pixTxMax, torusXmin, torusXmax, rpb_vc(1))
p(3).y = pix(pixTyMin, pixTyMax, torusYmin, torusYmax, rpb_vc(2))

'sort so that ps(0) is at top with preserved cyclic order
topI = 0
For i = 0 To 3
    If p(i).y < p(topI).y Then topI = i
Next i
ps(0).x = p(topI).x: ps(0).y = p(topI).y
ps(1).x = p((topI + 1) Mod 4).x: ps(1).y = p((topI + 1) Mod 4).y
ps(2).x = p((topI + 2) Mod 4).x: ps(2).y = p((topI + 2) Mod 4).y
ps(3).x = p((topI + 3) Mod 4).x: ps(3).y = p((topI + 3) Mod 4).y

'fill in LeftEdge and RightEdge pixValues for each scanline
nLines = Max4(p(0).y, p(1).y, p(2).y, p(3).y) - Min4(p(0).y, p(1).y, p(2).y, p(3).y)
torus(aI, bI).pixYtop = ps(0).y
torus(aI, bI).nScanlines = nLines
ReDim torus(aI, bI).pixLeftEdge(nLines)
ReDim torus(aI, bI).pixRightEdge(nLines)
' leftedges
scanlineNo = 0
For pt2 = 1 To 3
    If ps(pt2).y > ps(pt2 - 1).y Then
        nLines = ps(pt2).y - ps(pt2 - 1).y
        dxOdy = CDbl((ps(pt2).x - ps(pt2 - 1).x)) / CDbl(ps(pt2).y - ps(pt2 - 1).y)
        For yI = 1 To nLines
            torus(aI, bI).pixLeftEdge(scanlineNo + yI) = ps(pt2 - 1).x + CLng((yI - 1) * dxOdy)
        Next yI
        scanlineNo = scanlineNo + nLines
    End If
Next pt2
' right edges
scanlineNo = 0
For pt2 = 3 To 1 Step -1
    If ps(pt2).y > ps((pt2 + 1) Mod 4).y Then
        nLines = ps(pt2).y - ps((pt2 + 1) Mod 4).y
        dxOdy = CDbl((ps(pt2).x - ps((pt2 + 1) Mod 4).x)) / CDbl(ps(pt2).y - ps((pt2 + 1) Mod 4).y)
        For yI = 1 To nLines
            torus(aI, bI).pixRightEdge(scanlineNo + yI) = ps((pt2 + 1) Mod 4).x + CLng((yI - 1) * dxOdy)
        Next yI
        scanlineNo = scanlineNo + nLines
    End If
Next pt2
End Sub

'***************************************************************************************
'                              hidSurfRemove
'***************************************************************************************
Private Sub hidSurfRemove()
Dim aI As Long
Dim bI As Long
Dim a2I As Long
Dim b2I As Long
Dim b2Index As Long
Dim a2Istart As Long
Dim a2Iend As Long
Dim b2Istart As Long
Dim b2Iend As Long
Dim continue As Boolean

b2Istart = 3 * (nDbSteps \ 4)
b2Iend = 5 * (nDbSteps \ 4) - 1
For aI = 0 To (nDaSteps \ 2) - 1 'aI,bI surface to test for removal
    For bI = (nDbSteps \ 4) - 1 To 3 * (nDbSteps \ 4) - 1
        If aI < nDaSteps \ 4 Then
            a2Istart = 3 * (nDaSteps \ 4)
            a2Iend = nDaSteps - 1
        Else
            a2Istart = nDaSteps \ 2
            a2Iend = 3 * (nDaSteps \ 4) - 1
        End If
        a2I = a2Istart
        continue = True     'a2I,b2I hiding surfaces
        Do While continue And a2I <= a2Iend
            If torus(aI, bI).xCtr > aSegment(a2I).xMin And _
                    torus(aI, bI).xCtr < aSegment(a2I).xMax And _
                    torus(aI, bI).yCtr > aSegment(a2I).yMin And _
                    torus(aI, bI).yCtr < aSegment(a2I).yMax Then
                b2I = b2Istart
                Do While continue And b2I <= b2Iend
                    b2Index = b2I Mod nDbSteps
                    If torus(aI, bI).xCtr > torus(a2I, b2Index).xMin And _
                            torus(aI, bI).xCtr < torus(a2I, b2Index).xMax And _
                            torus(aI, bI).yCtr > torus(a2I, b2Index).yMin And _
                            torus(aI, bI).yCtr < torus(a2I, b2Index).yMax And _
                            torus(a2I, b2Index).zCtr > torus(aI, bI).zCtr Then  ' zaxis direct towards viewer
                        torus(aI, bI).visible = False
                        continue = False
                    End If
                    b2I = b2I + 1
                Loop
            End If
            a2I = a2I + 1
        Loop
    Next bI
Next aI
End Sub

'***************************************************************************************
'                              setTorusData
'***************************************************************************************
Private Sub setTorusData()
Dim aI As Long
Dim bI As Long
Dim r_vc(3) As Double
Dim rpa_vc(3) As Double
Dim rpb_vc(3) As Double
Dim rpab_vc(3) As Double

Dim rda_vc(3) As Double ' incr.vector along big circle (arm1)
Dim rdb_vc(3) As Double ' incr. vector along small circle (arm2)
Dim N(3) As Double
Dim a2I As Long
Dim b2I As Long

Dim r As Single
Dim g As Single
Dim b As Single

r = CSng(colPendulum Mod 256) / 256
g = CSng((colPendulum Mod (65536)) \ 256) / 256
b = CSng(colPendulum \ (65536)) / 256
RGBtoHLS r, g, b, H, L, S


pixTxMin = TorusMargin
pixTxMax = frmP.picTorus.ScaleWidth - TorusMargin
pixTyMin = frmP.picTorus.ScaleHeight - TorusMargin
pixTyMax = TorusMargin

' make database with VCs for (a,b) points
nDaSteps = CLng(2 * Pi / da)
nDbSteps = CLng(2 * Pi / db)
ReDim aSegment(nDaSteps)
ReDim vc_database(nDaSteps, nDbSteps, 3)
ReDim torus(nDaSteps, nDbSteps)
getRmatrix
initiatedata nDaSteps, nDbSteps

'fill tabletorus with info on (a,b) points
For aI = 0 To nDaSteps - 1
    aSegment(0).xMin = 1000
    aSegment(0).xMax = -1000
    aSegment(0).yMin = 1000
    aSegment(0).yMax = -1000
    For bI = 0 To nDbSteps - 1
        getVC_DB aI, bI, r_vc
        getVC_DB (aI + 1) Mod nDaSteps, bI, rpa_vc
        getVC_DB aI, (bI + 1) Mod nDbSteps, rpb_vc
        getVC_DB (aI + 1) Mod nDaSteps, (bI + 1) Mod nDbSteps, rpab_vc
        torus(aI, bI).xCtr = (r_vc(1) + rpa_vc(1) + rpb_vc(1) + rpab_vc(1)) / 4
        torus(aI, bI).yCtr = (r_vc(2) + rpa_vc(2) + rpb_vc(2) + rpab_vc(2)) / 4
        torus(aI, bI).zCtr = (r_vc(3) + rpa_vc(3) + rpb_vc(3) + rpab_vc(3)) / 4
        vectorSub rpa_vc, r_vc, rda_vc
        vectorSub rpb_vc, r_vc, rdb_vc
        getNormal rda_vc, rdb_vc, N
        If N(3) <= 0 Then
            torus(aI, bI).visible = False
        Else  ' set Data for polyArea (a,b) (directed to viewer)
            torus(aI, bI).Nx = N(1)
            torus(aI, bI).Ny = N(2)
            torus(aI, bI).Nz = N(3)
            torus(aI, bI).color = getColor(N(1), N(2), N(3), Lx, Ly, Lz)
            setScanInfo aI, bI, r_vc, rpa_vc, rpb_vc, rpab_vc
            'update MinMax for aSegment
            torus(aI, bI).xMin = Min4(r_vc(1), rpa_vc(1), rpb_vc(1), rpab_vc(1))
            torus(aI, bI).xMax = Max4(r_vc(1), rpa_vc(1), rpb_vc(1), rpab_vc(1))
            torus(aI, bI).yMin = Min4(r_vc(2), rpa_vc(2), rpb_vc(2), rpab_vc(2))
            torus(aI, bI).yMax = Max4(r_vc(2), rpa_vc(2), rpb_vc(2), rpab_vc(2))
            If xMin < aSegment(aI).xMin Then aSegment(aI).xMin = xMin
            If xMax > aSegment(aI).xMax Then aSegment(aI).xMax = xMax
            If yMin < aSegment(aI).yMin Then aSegment(aI).yMin = yMin
            If yMax > aSegment(aI).yMax Then aSegment(aI).yMax = yMax
        End If
    Next bI
Next aI
hidSurfRemove
End Sub

'***************************************************************************************
'                              printTorus
'***************************************************************************************
Private Sub printTorus()
Dim aI As Long
Dim bI As Long
Dim yI As Long
Dim yTop As Long


frmP.picTorusBuffer.Cls
For aI = 0 To nDaSteps - 1
    For bI = 0 To nDbSteps - 1
        If torus(aI, bI).visible Then
            yTop = torus(aI, bI).pixYtop
            For yI = 0 To torus(aI, bI).nScanlines ' - 1
                frmP.picTorusBuffer.Line (torus(aI, bI).pixLeftEdge(yI), yTop + yI)- _
                              (torus(aI, bI).pixRightEdge(yI), yTop + yI), torus(aI, bI).color
            Next yI
        End If
    Next bI
Next aI
End Sub

'***************************************************************************************
'                              Circles
'***************************************************************************************
Private Sub circles()
Dim a As Double
Dim b As Double
Dim aI As Long
Dim bI As Long
Dim rWC(3) As Double
Dim rVC(3) As Double
Dim ptX As Double
Dim ptY As Double
Dim ptXprev As Double
Dim ptYprev As Double
Dim color As Long

frmP.picTorus.DrawWidth = 1
For a = 0 To 2 * Pi Step da_circles
    getWC a, 0, rWC
    getVC rWC, rVC
    ptXprev = pix(pixTxMin, pixTxMax, torusXmin, torusXmax, rVC(1))
    ptYprev = pix(pixTyMin, pixTyMax, torusYmin, torusYmax, rVC(2))
    For b = db To 2 * Pi + db Step db
        getWC a, b, rWC
        getVC rWC, rVC
        ptX = pix(pixTxMin, pixTxMax, torusXmin, torusXmax, rVC(1))
        ptY = pix(pixTyMin, pixTyMax, torusYmin, torusYmax, rVC(2))
        aI = CLng(a / da)
        bI = CLng(b / db) Mod nDbSteps
        If torus(aI, bI).visible Then
            frmP.picTorus.Line (ptXprev, ptYprev)-(ptX, ptY), RGB(50, 50, 50) 'vbBlack
        End If
        ptXprev = ptX
        ptYprev = ptY
    Next b
Next a
For b = 0 To 2 * Pi Step db_circles
    getWC 0, b, rWC
    getVC rWC, rVC
    ptXprev = pix(pixTxMin, pixTxMax, torusXmin, torusXmax, rVC(1))
    ptYprev = pix(pixTyMin, pixTyMax, torusYmin, torusYmax, rVC(2))
    For a = da To 2 * Pi + da Step da
        getWC a, b, rWC
        getVC rWC, rVC
        ptX = pix(pixTxMin, pixTxMax, torusXmin, torusXmax, rVC(1))
        ptY = pix(pixTyMin, pixTyMax, torusYmin, torusYmax, rVC(2))
        aI = CLng(a / da) Mod nDaSteps
        bI = CLng(b / db)
        If torus(aI, bI).visible Then
            frmP.picTorus.Line (ptXprev, ptYprev)-(ptX, ptY), RGB(50, 50, 50) 'vbBlack
        End If
        ptXprev = ptX
        ptYprev = ptY
    Next a
Next b
End Sub

'***************************************************************************************
'                              torusAxes
'***************************************************************************************
Private Sub torusAxes()
Dim a0 As Double
Dim b0 As Double
Dim a As Double
Dim b As Double
Dim aI As Long
Dim bI As Long
Dim rWC(3) As Double
Dim rVC(3) As Double
Dim ptX As Long
Dim ptY As Long
Dim ptXprev As Long
Dim ptYprev As Long
Dim color As Long

a0 = -Pi / 2
b0 = 0
frmP.picTorus.DrawWidth = 3

'a axis arm1
getWC a0, b0, rWC
getVC rWC, rVC
ptXprev = pix(pixTxMin, pixTxMax, torusXmin, torusXmax, rVC(1))
ptYprev = pix(pixTyMin, pixTyMax, torusYmin, torusYmax, rVC(2))
For a = a0 To a0 + 2 * Pi / 55 Step da
    getWC a, b0, rWC
    getVC rWC, rVC
    ptX = pix(pixTxMin, pixTxMax, torusXmin, torusXmax, rVC(1))
    ptY = pix(pixTyMin, pixTyMax, torusYmin, torusYmax, rVC(2))
    frmP.picTorus.Line (ptXprev, ptYprev)-(ptX, ptY), vbBlack
    ptXprev = ptX
    ptYprev = ptY
Next a

getWC a0, b0, rWC
getVC rWC, rVC
ptXprev = pix(pixTxMin, pixTxMax, torusXmin, torusXmax, rVC(1))
ptYprev = pix(pixTyMin, pixTyMax, torusYmin, torusYmax, rVC(2))
For b = b0 To b0 + 2 * Pi / 16 Step db
    getWC a0, b, rWC
    getVC rWC, rVC
    ptX = pix(pixTxMin, pixTxMax, torusXmin, torusXmax, rVC(1))
    ptY = pix(pixTyMin, pixTyMax, torusYmin, torusYmax, rVC(2))
    frmP.picTorus.Line (ptXprev, ptYprev)-(ptX, ptY), vbBlack
    ptXprev = ptX
    ptYprev = ptY
Next b

frmP.picTorus.DrawWidth = 1
frmP.lblTorusArm1.visible = True
frmP.lblTorusArm2.visible = True
End Sub

'***************************************************************************************
'                              torusDot
'***************************************************************************************
Private Sub torusDot(phi1 As Double, phi2 As Double)
Dim a As Double
Dim b As Double
Dim aI As Long
Dim bI As Long
Dim rWC(3) As Double
Dim rVC(3) As Double
Dim xPix As Long
Dim yPix As Long
Dim color As Long

a = phi1
If frmP.opt_PosAbs Then
    b = phi1 + phi2 + Pi / 2
ElseIf frmP.opt_PosRel Then
    b = phi2
End If
aI = CLng(a / da) Mod nDaSteps
If aI < 0 Then aI = aI + nDaSteps
bI = CLng(b / db) Mod nDbSteps
If bI < 0 Then bI = bI + nDbSteps
getWC a, b, rWC
getVC rWC, rVC
xPix = pix(pixTxMin, pixTxMax, torusXmin, torusXmax, rVC(1))
yPix = pix(pixTyMin, pixTyMax, torusYmin, torusYmax, rVC(2))

If torus(aI, bI).visible Then
    frmP.picTorus.FillStyle = vbFSSolid
    frmP.picTorus.FillColor = vbBlack
    frmP.picTorus.Circle (xPix, yPix), 3, vbBlack
Else
    If frmP.chk_backside Then
        frmP.picTorus.FillStyle = vbFSTransparent
        frmP.picTorus.Circle (xPix, yPix), 3, vbBlack
    End If
End If
End Sub


'***************************************************************************************
'                              readButterfly
'***************************************************************************************
Public Sub readButterfly()
Dim delta_phi1 As Double
Dim delta_phi2 As Double
Dim delta_w1 As Double
Dim delta_w2 As Double

delta_phi1 = Pi * Val(frmP.txtDiffPosArm1) / 180
delta_phi2 = Pi * Val(frmP.txtDiffPosArm2) / 180
delta_w1 = Pi * Val(frmP.txtDiffRotArm1) / 180
delta_w2 = Pi * Val(frmP.txtDiffRotArm2) / 180

phi1(simTwo) = phi1(simOne) + delta_phi1
phi2(simTwo) = phi2(simOne) + delta_phi2
w1(simTwo) = w1(simOne) + delta_w1
w2(simTwo) = w2(simOne) + delta_w2
End Sub


'***************************************************************************************
'                               numKey
'***************************************************************************************
Private Function numKey(keycode As Integer) As Boolean
If (keycode >= vbKey0 And keycode <= vbKey9) Or _
   (keycode >= vbKeyNumpad0 And keycode <= vbKeyNumpad9) Or _
   (keycode = 189 Or keycode = 109) Then  ' keycode is minus signThen
   numKey = True
Else
    numKey = False
End If
End Function

'***************************************************************************************
'                              txtGraphTime
'***************************************************************************************
Public Sub txtGraphTime_KeyDown(keycode As Integer, Shift As Integer)
If Not txtActive And numKey(keycode) Then
    frmP.txtGraphTime = ""
    txtActive = True
End If
End Sub
Public Sub txtGraphTime_LostFocus()
txtActive = False
End Sub
'***************************************************************************************
'                              txtArm1k
'***************************************************************************************
Public Sub txtArm1k_KeyDown(keycode As Integer, Shift As Integer)
If Not txtActive And numKey(keycode) Then
    frmP.txtArm1k = ""
    txtActive = True
End If
End Sub
Public Sub txtArm1k_LostFocus()
txtActive = False
End Sub
'***************************************************************************************
'                              txtArm2k
'***************************************************************************************
Public Sub txtArm2k_KeyDown(keycode As Integer, Shift As Integer)
If Not txtActive And numKey(keycode) Then
    frmP.txtArm2k = ""
    txtActive = True
End If
End Sub
Public Sub txtArm2k_LostFocus()
txtActive = False
End Sub
'***************************************************************************************
'                              txtArm1L
'***************************************************************************************
Public Sub txtArm1L_KeyDown(keycode As Integer, Shift As Integer)
If Not txtActive And numKey(keycode) Then
    frmP.txtArm1L = ""
    txtActive = True
End If
End Sub
Public Sub txtArm1L_LostFocus()
txtActive = False
End Sub
'***************************************************************************************
'                              txtArm2L
'***************************************************************************************
Public Sub txtArm2L_KeyDown(keycode As Integer, Shift As Integer)
If Not txtActive And numKey(keycode) Then
    frmP.txtArm2L = ""
    txtActive = True
End If
End Sub
Public Sub txtArm2L_LostFocus()
txtActive = False
End Sub
'***************************************************************************************
'                              txtArm1W
'***************************************************************************************
Public Sub txtArm1W_KeyDown(keycode As Integer, Shift As Integer)
If Not txtActive And numKey(keycode) Then
    frmP.txtArm1W = ""
    txtActive = True
End If
End Sub
Public Sub txtArm1W_LostFocus()
txtActive = False
End Sub
'***************************************************************************************
'                              txtArm2W
'***************************************************************************************
Public Sub txtArm2W_KeyDown(keycode As Integer, Shift As Integer)
If Not txtActive And numKey(keycode) Then
    frmP.txtArm2W = ""
    txtActive = True
End If
End Sub
Public Sub txtArm2W_LostFocus()
txtActive = False
End Sub
'***************************************************************************************
'                              txtArm1Mass
'***************************************************************************************
Public Sub txtArm1Mass_KeyDown(keycode As Integer, Shift As Integer)
If Not txtActive And numKey(keycode) Then
    frmP.txtArm1Mass = ""
    txtActive = True
End If
End Sub
Public Sub txtArm1Mass_LostFocus()
txtActive = False
End Sub
'***************************************************************************************
'                              txtArm2Mass
'***************************************************************************************
Public Sub txtArm2Mass_KeyDown(keycode As Integer, Shift As Integer)
If Not txtActive And numKey(keycode) Then
    frmP.txtArm2Mass = ""
    txtActive = True
End If
End Sub
Public Sub txtArm2Mass_LostFocus()
txtActive = False
End Sub
'***************************************************************************************
'                              txtArm1m
'***************************************************************************************
Public Sub txtArm1m_KeyDown(keycode As Integer, Shift As Integer)
If Not txtActive And numKey(keycode) Then
    frmP.txtArm1m = ""
    txtActive = True
End If
End Sub
Public Sub txtArm1m_LostFocus()
txtActive = False
End Sub
'***************************************************************************************
'                              txtArm2m
'***************************************************************************************
Public Sub txtArm2m_KeyDown(keycode As Integer, Shift As Integer)
If Not txtActive And numKey(keycode) Then
    frmP.txtArm2m = ""
    txtActive = True
End If
End Sub
Public Sub txtArm2m_LostFocus()
txtActive = False
End Sub
'***************************************************************************************
'                              txtArm1bigM
'***************************************************************************************
Public Sub txtArm1bigM_KeyDown(keycode As Integer, Shift As Integer)
If Not txtActive And numKey(keycode) Then
    frmP.txtArm1bigM = ""
    txtActive = True
End If
End Sub
Public Sub txtArm1bigM_LostFocus()
txtActive = False
End Sub

'***************************************************************************************
'                              txtArm1Pos0
'***************************************************************************************
Public Sub txtArm1Pos0_KeyDown(keycode As Integer, Shift As Integer)
If Not txtActive And numKey(keycode) Then
    frmP.txtArm1Pos0 = ""
    txtActive = True
End If
End Sub
Public Sub txtArm1Pos0_LostFocus()
txtActive = False
update
End Sub
'***************************************************************************************
'                              txtArm2Pos0
'***************************************************************************************
Public Sub txtArm2Pos0_KeyDown(keycode As Integer, Shift As Integer)
If Not txtActive And numKey(keycode) Then
    frmP.txtArm2Pos0 = ""
    txtActive = True
End If
End Sub
Public Sub txtArm2Pos0_LostFocus()
txtActive = False
update
End Sub
'***************************************************************************************
'                              txtArm1Rot0
'***************************************************************************************
Public Sub txtArm1Rot0_KeyDown(keycode As Integer, Shift As Integer)
If Not txtActive And numKey(keycode) Then
    frmP.txtArm1Rot0 = ""
    txtActive = True
End If
End Sub
Public Sub txtArm1Rot0_LostFocus()
txtActive = False
update
End Sub
'***************************************************************************************
'                              txtArm2Rot0
'***************************************************************************************
Public Sub txtArm2Rot0_KeyDown(keycode As Integer, Shift As Integer)
If Not txtActive And numKey(keycode) Then
    frmP.txtArm2Rot0 = ""
    txtActive = True
End If
End Sub
Public Sub txtArm2Rot0_LostFocus()
txtActive = False
update
End Sub
'***************************************************************************************
'                              txtEps
'***************************************************************************************
Public Sub txtEps_KeyDown(keycode As Integer, Shift As Integer)
If Not txtActive And numKey(keycode) Then
    frmP.txtEps = ""
    txtActive = True
End If
End Sub
Public Sub txtEps_LostFocus()
txtActive = False
update
End Sub
'***************************************************************************************
'                              txtDiffPosArm1
'***************************************************************************************
Public Sub txtDiffPosArm1_KeyDown(keycode As Integer, Shift As Integer)
If Not txtActive And numKey(keycode) Then
    frmP.txtDiffPosArm1 = ""
    txtActive = True
End If
End Sub
Public Sub txtDiffPosArm1_LostFocus()
txtActive = False
update
End Sub
'***************************************************************************************
'                              txtDiffPosArm2
'***************************************************************************************
Public Sub txtDiffPosArm2_KeyDown(keycode As Integer, Shift As Integer)
If Not txtActive And numKey(keycode) Then
    frmP.txtDiffPosArm2 = ""
    txtActive = True
End If
End Sub
Public Sub txtDiffPosArm2_LostFocus()
txtActive = False
update
End Sub
'***************************************************************************************
'                              txtDiffRotArm1
'***************************************************************************************
Public Sub txtDiffRotArm1_KeyDown(keycode As Integer, Shift As Integer)
If Not txtActive And numKey(keycode) Then
    frmP.txtDiffRotArm1 = ""
    txtActive = True
End If
End Sub
Public Sub txtDiffRotArm1_LostFocus()
txtActive = False
update
End Sub
'***************************************************************************************
'                              txtDiffRotArm2
'***************************************************************************************
Public Sub txtDiffRotArm2_KeyDown(keycode As Integer, Shift As Integer)
If Not txtActive And numKey(keycode) Then
    frmP.txtDiffRotArm2 = ""
    txtActive = True
End If
End Sub
Public Sub txtDiffRotArm2_LostFocus()
txtActive = False
update
End Sub

'***************************************************************************************
'                              chk_RealTime_Click
'***************************************************************************************
Public Sub chk_RealTime_Click()
If Not (frmP.opt_None Or frmP.opt_Energy Or frmP.opt_torus) And phase > 0 Then
    graph
End If
If frmP.opt_torus Then
    graphTorus
End If
End Sub
'***************************************************************************************
'                              opt_PosAbs_Click
'***************************************************************************************
Public Sub opt_PosAbs_Click()
If Not (frmP.opt_None Or frmP.opt_Energy Or frmP.opt_torus) And phase > 0 Then
    graph
End If
If frmP.opt_torus Then
    graphTorus
End If
End Sub
'***************************************************************************************
'                              opt_PosRel_Click
'***************************************************************************************
Public Sub opt_PosRel_Click()
If Not (frmP.opt_None Or frmP.opt_Energy Or frmP.opt_torus) And phase > 0 Then
    graph
End If
If frmP.opt_torus Then
    graphTorus
End If
End Sub
'***************************************************************************************
'                              chk_butterfly_Click
'***************************************************************************************
Public Sub chk_butterfly_Click()
If frmP.chk_butterfly.Value = Checked Then
    cmdStop_Click
    frmP.frame_start_butterfly.visible = True
    frmP.frame_graph_butterfly.visible = True
    frmP.frame_charts.visible = False
    dual = True
    readButterfly
    graph
Else
    cmdStop_Click
    frmP.frame_start_butterfly.visible = False
    frmP.frame_graph_butterfly.visible = False
    frmP.frame_charts.visible = True
    dual = False
    If frmP.opt_None Then
        opt_none_click
    ElseIf frmP.opt_Energy Then
        opt_Energy_Click
    ElseIf frmP.opt_torus Then
        graphTorus
    Else
        graph
    End If
End If
End Sub

'------------------------- opt_None_MouseDown ------------------------------------------
Public Sub opt_none_click()
frmP.picPendulum.top = (frmP.ScaleHeight - frmP.picPendulum.ScaleWidth) \ 2
frmP.picEnergy.visible = False
frmP.frameEnergy.visible = False
frmP.picGraph.visible = False
frmP.picTorus.visible = False
End Sub
'------------------------- opt_Energy_Click ------------------------------------------
Public Sub opt_Energy_Click()
frmP.picPendulum.top = topMargin
frmP.picGraph.visible = False
frmP.picTorus.visible = False
frmP.picEnergy.visible = True
frmP.frameEnergy.visible = True
End Sub
'------------------------- opt_torus_Click ------------------------------------------
Public Sub opt_torus_Click()
graphTorus
End Sub
'------------------------- opt_pos_t_Click ------------------------------------------
Public Sub opt_pos_t_Click()
graph
End Sub
'------------------------- opt_pos2_pos1_t_Click ------------------------------------------
Public Sub opt_pos2_pos1_Click()
graph
End Sub
'------------------------- opt_w_t_Click ------------------------------------------
Public Sub opt_w_t_Click()
graph
End Sub
'------------------------- opt_w2_w1_t_Click ------------------------------------------
Public Sub opt_w2_w1_Click()
graph
End Sub
'------------------------- opt_E1_E2_t_Click ------------------------------------------
Public Sub opt_E1_E2_Click()
graph
End Sub
'------------------------- opt_Ek_Ep_t_Click ------------------------------------------
Public Sub opt_Ek_Ep_Click()
graph
End Sub
'------------------------- opt_Ekp12_t_Click ------------------------------------------
Public Sub opt_Ekp12_Click()
graph
End Sub
'------------------------- opt_diff_pos1_Click ------------------------------------------
Public Sub opt_diff_pos1_Click()
graph
End Sub
'------------------------- opt_diff_pos2_Click ------------------------------------------
Public Sub opt_diff_pos2_Click()
graph
End Sub
'------------------------- opt_diff_w1_Click ------------------------------------------
Public Sub opt_diff_w1_Click()
graph
End Sub
'------------------------- opt_diff_w2_Click ------------------------------------------
Public Sub opt_diff_w2_Click()
graph
End Sub
'------------------------- opt_w1_pos1_Click ------------------------------------------
Public Sub opt_w1_pos1_Click()
graph
End Sub
'------------------------- opt_w2_pos2_Click ------------------------------------------
Public Sub opt_w2_pos2_Click()
graph
End Sub
'------------------------- chk_circles_Click ------------------------------------------
Public Sub chk_circles_Click()
If frmP.chk_circles.Value = vbChecked Then
    circles
Else
    frmP.picTorus.Picture = frmP.picTorusBuffer.Image
    graphTorus
    torusAxes
End If
End Sub

'******************************  Min   ************************************
Private Function Min(a As Variant, b As Variant) As Variant
If a < b Then
    Min = a
Else
    Min = b
End If
End Function
'******************************  Max   ************************************
Private Function Max(a As Variant, b As Variant) As Variant
If a > b Then
    Max = a
Else
    Max = b
End If
End Function
'******************************  Min4   ************************************
Private Function Min4(a As Variant, b As Variant, c As Variant, D As Variant) As Variant
If a < b Then Min4 = a Else Min4 = b
If c < Min4 Then Min4 = c
If D < Min4 Then Min4 = D
End Function
'******************************  Max4   ************************************
Private Function Max4(a As Variant, b As Variant, c As Variant, D As Variant) As Variant
If a > b Then Max4 = a Else Max4 = b
If c > Max4 Then Max4 = c
If D > Max4 Then Max4 = D
End Function


