(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 3.0,
MathReader 3.0, or any compatible application. The data for the notebook 
starts with the line of stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     42266,       1503]*)
(*NotebookOutlinePosition[     42949,       1527]*)
(*  CellTagsIndexPosition[     42905,       1523]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
    \(Ek = 
      \((A - B\ Cos[\[CurlyPhi]2[t]])\)\ \(\[CurlyPhi]1'\)[t]^2 + 
        c\ \(\[CurlyPhi]2'\)[t]^2 + 
        \((2  c - B\ Cos[\[CurlyPhi]2[t]])\)\ \(\[CurlyPhi]1'\)[t]\ 
          \(\[CurlyPhi]2'\)[t]\)], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{
      \((\(0.102109708333333348`\[InvisibleSpace]\) - 
            0.0140097000000000004`\ Cos[\[CurlyPhi]2[t]])\), " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["\[CurlyPhi]1", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{
      \((2\ c - 0.0140097000000000004`\ Cos[\[CurlyPhi]2[t]])\), " ", 
        RowBox[{
          SuperscriptBox["\[CurlyPhi]1", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], " ", 
        RowBox[{
          SuperscriptBox["\[CurlyPhi]2", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"c", " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["\[CurlyPhi]2", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Ep = 
      d\ Sin[\[CurlyPhi]1[t]] + e\ Sin[\[CurlyPhi]1[t] + \[CurlyPhi]2[t]]\)], 
  "Input"],

Cell[BoxData[
    \(d\ Sin[\[CurlyPhi]1[t]] + e\ Sin[\[CurlyPhi]1[t] + \[CurlyPhi]2[t]]\)], 
  "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(L = Ek - Ep\)], "Input"],

Cell[BoxData[
    RowBox[{
    \(\(-d\)\ Sin[\[CurlyPhi]1[t]]\), "-", 
      \(e\ Sin[\[CurlyPhi]1[t] + \[CurlyPhi]2[t]]\), "+", 
      RowBox[{
      \((\(0.102109708333333348`\[InvisibleSpace]\) - 
            0.0140097000000000004`\ Cos[\[CurlyPhi]2[t]])\), " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["\[CurlyPhi]1", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
      RowBox[{
      \((\(0.0291114416666666731`\[InvisibleSpace]\) - 
            0.0140097000000000004`\ Cos[\[CurlyPhi]2[t]])\), " ", 
        RowBox[{
          SuperscriptBox["\[CurlyPhi]1", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], " ", 
        RowBox[{
          SuperscriptBox["\[CurlyPhi]2", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"0.0145557208333333365`", " ", 
        SuperscriptBox[
          RowBox[{
            SuperscriptBox["\[CurlyPhi]2", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}], "2"]}]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(dis = 
      \((k1\ A1\  + k2\ A2)\)\ \(\[CurlyPhi]1'\)[t]^2 - 
        k2\ B\ \(\[CurlyPhi]1'\)[t]^2\ Cos[\[CurlyPhi]2[t]] + 
        k2\ c\ \(\[CurlyPhi]2'\)[t]^2 + 
        k2 \((2  c - B\ Cos[\[CurlyPhi]2[t]])\) \(\[CurlyPhi]1'\)[t] 
          \(\[CurlyPhi]2'\)[t]\)], "Input"],

Cell[BoxData[
    \(0\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(qi = {\[CurlyPhi]1, \[CurlyPhi]2}; 
    Qi = Map[\((\(-D[dis, D[#[t], t]]\))\)&, qi]\)], "Input"],

Cell[BoxData[
    \({0, 0}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(Lag[L_, qi_List, Qi_List] := 
      MapThread[\((D[D[L, D[#1[t], t]], t] - D[L, #1[t]] == #2)\)&, {qi, Qi}]
        \)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(eqn = Lag[L, qi, Qi]\)], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{
          RowBox[{
          \(d\ Cos[\[CurlyPhi]1[t]]\), "+", 
            \(e\ Cos[\[CurlyPhi]1[t] + \[CurlyPhi]2[t]]\), "+", 
            RowBox[{
            "0.0280194000000000009`", " ", \(Sin[\[CurlyPhi]2[t]]\), " ", 
              RowBox[{
                SuperscriptBox["\[CurlyPhi]1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], " ", 
              RowBox[{
                SuperscriptBox["\[CurlyPhi]2", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{
            "0.0140097000000000004`", " ", \(Sin[\[CurlyPhi]2[t]]\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["\[CurlyPhi]2", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{
            "2", " ", 
              \((\(0.102109708333333348`\[InvisibleSpace]\) - 
                  0.0140097000000000004`\ Cos[\[CurlyPhi]2[t]])\), " ", 
              RowBox[{
                SuperscriptBox["\[CurlyPhi]1", "\[DoublePrime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{
            \((\(0.0291114416666666731`\[InvisibleSpace]\) - 
                  0.0140097000000000004`\ Cos[\[CurlyPhi]2[t]])\), " ", 
              RowBox[{
                SuperscriptBox["\[CurlyPhi]2", "\[DoublePrime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}], "==", "0"}], 
        ",", 
        RowBox[{
          RowBox[{\(e\ Cos[\[CurlyPhi]1[t] + \[CurlyPhi]2[t]]\), "-", 
            RowBox[{
            "0.0140097000000000004`", " ", \(Sin[\[CurlyPhi]2[t]]\), " ", 
              SuperscriptBox[
                RowBox[{
                  SuperscriptBox["\[CurlyPhi]1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
            RowBox[{"0.`", " ", \(Sin[\[CurlyPhi]2[t]]\), " ", 
              RowBox[{
                SuperscriptBox["\[CurlyPhi]1", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}], " ", 
              RowBox[{
                SuperscriptBox["\[CurlyPhi]2", "\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{
            \((\(0.0291114416666666731`\[InvisibleSpace]\) - 
                  0.0140097000000000004`\ Cos[\[CurlyPhi]2[t]])\), " ", 
              RowBox[{
                SuperscriptBox["\[CurlyPhi]1", "\[DoublePrime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{"0.0291114416666666731`", " ", 
              RowBox[{
                SuperscriptBox["\[CurlyPhi]2", "\[DoublePrime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}], "==", 
          "0"}]}], "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(init = {\[CurlyPhi]1[0] == Pi/180 \((40.  - 90)\), 
        \[CurlyPhi]2[0] == Pi/180 \((\(-20. \) - 40. )\), 
        \(\[CurlyPhi]1'\)[0] == \(-0.3\)*2\ Pi, 
        \(\[CurlyPhi]2'\)[0] == 0.3*2\ Pi}\)], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
      \(\[CurlyPhi]1[0] == \(-0.872664625997164833`\)\), ",", 
        \(\[CurlyPhi]2[0] == \(-1.04719755119659763`\)\), ",", 
        RowBox[{
          RowBox[{
            SuperscriptBox["\[CurlyPhi]1", "\[Prime]",
              MultilineFunction->None], "[", "0", "]"}], "==", 
          \(-1.88495559215387586`\)}], ",", 
        RowBox[{
          RowBox[{
            SuperscriptBox["\[CurlyPhi]2", "\[Prime]",
              MultilineFunction->None], "[", "0", "]"}], "==", 
          "1.88495559215387586`"}]}], "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \({a1 = 0.67, a2 = 0.68, b1 = 0.075, b2 = 0.07, r1 = a1/2, r2 = a2/2, 
      marm1 = 0.438, marm2 = 0.565, m1 = 0.242, m2 = 0.246, mBig = 0.541}\)], 
  "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        StyleBox["0.670000000000000017`",
          StyleBoxAutoDelete->True,
          PrintPrecision->2], ",", 
        StyleBox["0.680000000000000071`",
          StyleBoxAutoDelete->True,
          PrintPrecision->2], ",", 
        StyleBox["0.075`",
          StyleBoxAutoDelete->True,
          PrintPrecision->2], ",", 
        StyleBox["0.0700000000000000088`",
          StyleBoxAutoDelete->True,
          PrintPrecision->1], ",", "0.335000000000000008`", ",", 
        "0.340000000000000035`", ",", 
        StyleBox["0.437999999999999989`",
          StyleBoxAutoDelete->True,
          PrintPrecision->3], ",", 
        StyleBox["0.564999999999999946`",
          StyleBoxAutoDelete->True,
          PrintPrecision->3], ",", 
        StyleBox["0.241999999999999992`",
          StyleBoxAutoDelete->True,
          PrintPrecision->3], ",", 
        StyleBox["0.245999999999999996`",
          StyleBoxAutoDelete->True,
          PrintPrecision->3], ",", 
        StyleBox["0.541000000000000014`",
          StyleBoxAutoDelete->True,
          PrintPrecision->3]}], "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \({rm1 = 0.5\ r1, rm2 = 0.5\ r2, k1 = 0, \ k2 = 0, g = 9.8}\)], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
      "0.1675`", ",", "0.170000000000000017`", ",", "0", ",", "0", ",", 
        StyleBox["9.80000000000000071`",
          StyleBoxAutoDelete->True,
          PrintPrecision->2]}], "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \({Iarm1 = marm1 \((a1^2 + b1^2)\)/12, ImBig = mBig\ *r1^2, 
      Im1 = m1*rm1^2, Iarm2 = marm2 \((a2^2 + b2^2)\)/12, Im2 = m2*rm2^2}\)], 
  "Input"],

Cell[BoxData[
    \({0.0165901625000000034`, 0.0607137250000000161`, 
      0.00678961250000000227`, 0.0220020416666666696`, 
      0.00710939999999999994`}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \({A1 = \((Iarm1 + ImBig + Im1)\)/2, 
      A2 = \((Iarm2 + Im2 + m2*r1^2 + marm2*r1^2)\)/2, A = A1 + A2, 
      B = m2*r1*rm2, c = \((Iarm2 + Im2)\)/2}\)], "Input"],

Cell[BoxData[
    \({0.0420467500000000082`, 0.0600629583333333361`, 0.102109708333333348`, 
      0.0140097000000000004`, 0.0145557208333333365`}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \({d = \((mBig*r1 + m1*rm1 - marm2*r1 - m2*r1)\)*g, e = m2*rm2*g}\)], 
  "Input"],

Cell[BoxData[
    \({\(-0.489166999999999774`\), 0.409836000000000044`}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(sol = NDSolve[Join[eqn, init], qi, {t, 0, 10}]\)], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"{", 
        RowBox[{
          RowBox[{"\[CurlyPhi]1", "\[Rule]", 
            TagBox[\(InterpolatingFunction[{{0.`, 10.`}}, "<>"]\),
              False,
              Editable->False]}], ",", 
          RowBox[{"\[CurlyPhi]2", "\[Rule]", 
            TagBox[\(InterpolatingFunction[{{0.`, 10.`}}, "<>"]\),
              False,
              Editable->False]}]}], "}"}], "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Plot[Evaluate[{\[CurlyPhi]1[t], \[CurlyPhi]2[t]} /. sol], {t, 0, 10}]
      \)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0952381 0.312909 0.0146524 [
[.21429 .30041 -3 -9 ]
[.21429 .30041 3 0 ]
[.40476 .30041 -3 -9 ]
[.40476 .30041 3 0 ]
[.59524 .30041 -3 -9 ]
[.59524 .30041 3 0 ]
[.78571 .30041 -3 -9 ]
[.78571 .30041 3 0 ]
[.97619 .30041 -6 -9 ]
[.97619 .30041 6 0 ]
[.01131 .01986 -18 -4.5 ]
[.01131 .01986 0 4.5 ]
[.01131 .16638 -18 -4.5 ]
[.01131 .16638 0 4.5 ]
[.01131 .45943 -12 -4.5 ]
[.01131 .45943 0 4.5 ]
[.01131 .60596 -12 -4.5 ]
[.01131 .60596 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
.21429 .31291 m
.21429 .31916 L
s
[(2)] .21429 .30041 0 1 Mshowa
.40476 .31291 m
.40476 .31916 L
s
[(4)] .40476 .30041 0 1 Mshowa
.59524 .31291 m
.59524 .31916 L
s
[(6)] .59524 .30041 0 1 Mshowa
.78571 .31291 m
.78571 .31916 L
s
[(8)] .78571 .30041 0 1 Mshowa
.97619 .31291 m
.97619 .31916 L
s
[(10)] .97619 .30041 0 1 Mshowa
.125 Mabswid
.07143 .31291 m
.07143 .31666 L
s
.11905 .31291 m
.11905 .31666 L
s
.16667 .31291 m
.16667 .31666 L
s
.2619 .31291 m
.2619 .31666 L
s
.30952 .31291 m
.30952 .31666 L
s
.35714 .31291 m
.35714 .31666 L
s
.45238 .31291 m
.45238 .31666 L
s
.5 .31291 m
.5 .31666 L
s
.54762 .31291 m
.54762 .31666 L
s
.64286 .31291 m
.64286 .31666 L
s
.69048 .31291 m
.69048 .31666 L
s
.7381 .31291 m
.7381 .31666 L
s
.83333 .31291 m
.83333 .31666 L
s
.88095 .31291 m
.88095 .31666 L
s
.92857 .31291 m
.92857 .31666 L
s
.25 Mabswid
0 .31291 m
1 .31291 L
s
.02381 .01986 m
.03006 .01986 L
s
[(-20)] .01131 .01986 1 0 Mshowa
.02381 .16638 m
.03006 .16638 L
s
[(-10)] .01131 .16638 1 0 Mshowa
.02381 .45943 m
.03006 .45943 L
s
[(10)] .01131 .45943 1 0 Mshowa
.02381 .60596 m
.03006 .60596 L
s
[(20)] .01131 .60596 1 0 Mshowa
.125 Mabswid
.02381 .04917 m
.02756 .04917 L
s
.02381 .07847 m
.02756 .07847 L
s
.02381 .10778 m
.02756 .10778 L
s
.02381 .13708 m
.02756 .13708 L
s
.02381 .19569 m
.02756 .19569 L
s
.02381 .22499 m
.02756 .22499 L
s
.02381 .2543 m
.02756 .2543 L
s
.02381 .2836 m
.02756 .2836 L
s
.02381 .34221 m
.02756 .34221 L
s
.02381 .37152 m
.02756 .37152 L
s
.02381 .40082 m
.02756 .40082 L
s
.02381 .43013 m
.02756 .43013 L
s
.02381 .48874 m
.02756 .48874 L
s
.02381 .51804 m
.02756 .51804 L
s
.02381 .54735 m
.02756 .54735 L
s
.02381 .57665 m
.02756 .57665 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02381 .30012 m
.06244 .29067 L
.08255 .28625 L
.10458 .28072 L
.14415 .26686 L
.16372 .25751 L
.18466 .24597 L
.20453 .23485 L
.22611 .22419 L
.24511 .21659 L
.26604 .21004 L
.28587 .20523 L
.3069 .20134 L
.34719 .19479 L
.36573 .19105 L
.38596 .1859 L
.4071 .17879 L
.42719 .17025 L
.46783 .14844 L
.50696 .12896 L
.52837 .12113 L
.54854 .11579 L
.56862 .11186 L
.58709 .10907 L
.62658 .10485 L
.64644 .10227 L
.66455 .09932 L
.68406 .09512 L
.70498 .0889 L
.74482 .07224 L
.78315 .05157 L
.80254 .04216 L
.82393 .03337 L
.83368 .03007 L
.84419 .02708 L
.8632 .02303 L
.88324 .02001 L
.89332 .01884 L
.89899 .01828 L
.90434 .01783 L
.90927 .01749 L
.91462 .01719 L
.92395 .01683 L
.9449 .01616 L
.9601 .01552 L
.97619 .01472 L
s
.02381 .29756 m
.06244 .31138 L
.10458 .32714 L
.12507 .33289 L
.14415 .33859 L
.16254 .34636 L
.18221 .35769 L
.19185 .36339 L
.20208 .36857 L
.20742 .37076 L
.2133 .37273 L
.21871 .37417 L
.22365 .37521 L
.23359 .37674 L
.24427 .37806 L
.25417 .37951 L
.26358 .38147 L
.27317 .38427 L
.28339 .38823 L
.30178 .39752 L
.32175 .40858 L
.33226 .41355 L
.338 .41579 L
.34336 .41753 L
.34816 .41877 L
.35331 .41977 L
.35624 .42019 L
.35902 .4205 L
.36151 .42069 L
.36292 .42077 L
.36423 .42082 L
.36532 .42086 L
.36651 .42088 L
.36763 .42089 L
.36865 .42089 L
.36979 .42087 L
.37103 .42085 L
.37233 .42081 L
.37354 .42076 L
.37604 .42063 L
.37832 .42048 L
.38342 .4201 L
.38827 .41971 L
.39093 .41951 L
.39341 .41936 L
.39552 .41925 L
.39671 .4192 L
.39779 .41917 L
.39897 .41915 L
.40026 .41914 L
Mistroke
.40148 .41914 L
.40261 .41916 L
.40392 .41921 L
.40466 .41924 L
.40533 .41928 L
.40656 .41936 L
.4079 .41947 L
.41023 .41973 L
.41268 .42009 L
.41536 .42061 L
.41823 .42131 L
.42341 .42298 L
.42871 .42529 L
.43361 .42797 L
.44469 .4361 L
.46482 .45598 L
.47383 .46441 L
.48352 .47153 L
.48908 .47456 L
.49416 .47667 L
.49903 .47812 L
.50147 .47865 L
.50286 .4789 L
.50414 .47909 L
.50535 .47924 L
.50668 .47938 L
.50802 .47949 L
.50877 .47954 L
.50944 .47957 L
.51069 .47961 L
.51137 .47963 L
.51203 .47963 L
.51318 .47963 L
.51444 .47961 L
.51556 .47957 L
.51679 .47951 L
.51929 .47933 L
.52161 .47912 L
.52379 .47888 L
.534 .47754 L
.53957 .47684 L
.54228 .47656 L
.54475 .47635 L
.5459 .47627 L
.54714 .4762 L
.54832 .47615 L
.5494 .47611 L
.55055 .47608 L
.55182 .47607 L
.55314 .47608 L
Mistroke
.55437 .47611 L
.55503 .47614 L
.55573 .47617 L
.55703 .47624 L
.55828 .47634 L
.55945 .47644 L
.56209 .47675 L
.56491 .47719 L
.56991 .47826 L
.57461 .47961 L
.58341 .48295 L
.6035 .49375 L
.62198 .50453 L
.63107 .50888 L
.63608 .51082 L
.64082 .51232 L
.6435 .51301 L
.64641 .51364 L
.64883 .51406 L
.65021 .51426 L
.65151 .51442 L
.65282 .51455 L
.65402 .51465 L
.65531 .51473 L
.65598 .51477 L
.65669 .5148 L
.65788 .51483 L
.65898 .51484 L
.66019 .51483 L
.66149 .51479 L
.66272 .51474 L
.66408 .51466 L
.6655 .51455 L
.66682 .51443 L
.67174 .5138 L
.67709 .51287 L
.68285 .51169 L
.69331 .50949 L
.6984 .50861 L
.70061 .50831 L
.703 .50804 L
.70432 .50792 L
.70553 .50784 L
.70669 .50778 L
.70792 .50773 L
.70921 .50771 L
.71041 .50772 L
.71173 .50776 L
.71247 .50779 L
.71314 .50783 L
Mistroke
.71456 .50795 L
.71587 .50808 L
.71882 .50852 L
.72143 .50906 L
.72419 .5098 L
.72913 .51155 L
.73376 .51372 L
.7443 .52069 L
.75467 .53031 L
.76454 .54141 L
.77425 .55251 L
.78306 .56114 L
.79264 .56821 L
.7979 .57101 L
.80031 .57205 L
.80286 .57298 L
.80505 .57364 L
.80745 .57424 L
.80964 .57466 L
.81168 .57495 L
.81292 .57508 L
.8141 .57518 L
.81515 .57523 L
.8163 .57527 L
.81754 .57528 L
.81817 .57528 L
.81886 .57526 L
.82009 .57521 L
.82124 .57514 L
.82241 .57505 L
.82367 .57492 L
.82593 .57463 L
.83106 .57371 L
.84141 .5712 L
.85104 .56876 L
.85526 .56784 L
.85991 .56704 L
.86248 .5667 L
.86489 .56647 L
.86621 .56637 L
.86742 .56631 L
.86809 .56628 L
.86882 .56626 L
.86951 .56625 L
.87015 .56625 L
.87085 .56625 L
.8716 .56626 L
.87232 .56628 L
.87297 .56631 L
.87421 .56638 L
Mistroke
.87553 .56648 L
.87694 .56661 L
.87826 .56677 L
.88125 .56725 L
.88387 .56779 L
.88634 .5684 L
.89098 .56984 L
.9014 .57427 L
.92001 .58512 L
.93021 .5914 L
.93977 .59656 L
.94811 .60005 L
.9528 .60149 L
.95709 .60246 L
.9594 .60283 L
.96154 .60308 L
.96277 .60319 L
.96389 .60325 L
.96518 .6033 L
.9664 .60332 L
.96759 .60331 L
.96885 .60326 L
.96992 .6032 L
.9711 .60311 L
.97237 .60298 L
.97373 .60281 L
.97619 .60241 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40O003h00Oofmk8Fmk003oKg/Q
Kg/00?m_Nb5_N`005Fmk00<006mkKg/0ofmk2Fmk000EKg/00`00Kg]_N`3oKg/9Kg/001E_N`03001_
Nfmk0?m_N`U_N`005Fmk00<006mkKg/0ofmk2Fmk0009Kg/30003Kg/00`00Kg]_N`03Kg/00`00Kg]_
N`3nKg/30007Kg/000U_N`03001_Nfmk009_N`03001_N`0000A_N`03001_Nfmk0>Q_NaH000Y_N`00
16mk0`000fmk00L006mkKg]_N`00Kg/00004Kg/3003TKg/4000PKg/000Y_N`07001_NfmkKg/006mk
000016mk00<006mkKg/0gfmk1@0096mk0009Kg/00`00Kg/00002Kg/00`00Kg/00004Kg/00`00Kg]_
N`3KKg/4000YKg/000Y_N`03001_Nfmk009_N`03001_Nfmk00=_N`03001_Nfmk0=I_N`D002e_N`00
5Fmk00<006mkKg/0e6mk0P00<Vmk000EKg/00`00Kg]_N`3BKg/2000dKg/001E_N`03001_Nfmk0=1_
N`8003I_N`005Fmk00<006mkKg/0cVmk0P00>6mk000EKg/2003=Kg/2000jKg/001E_N`03001_Nfmk
0<Y_N`8003a_N`005Fmk00<006mkKg/0b6mk0P00?Vmk000EKg/00`00Kg]_N`36Kg/20010Kg/001E_
N`03001_Nfmk0<A_N`80049_N`005Fmk00<006mkKg/0`Vmk0P00A6mk000EKg/00`00Kg]_N`30Kg/2
0016Kg/001E_N`03001_Nfmk0;i_N`8004Q_N`005Fmk0P00_Fmk0P00BVmk000EKg/00`00Kg]_N`2j
Kg/2001<Kg/001E_N`03001_Nfmk0;Q_N`8004i_N`005Fmk00<006mkKg/0]6mk1000D6mk000EKg/0
0`00Kg]_N`2^Kg/6001DKg/001E_N`03001_Nfmk0:U_N`D005Y_N`005Fmk00<006mkKg/0Y6mk1@00
Gfmk000EKg/00`00Kg]_N`2LKg/8001TKg/001E_N`8009E_N`P006a_N`005Fmk00<006mkKg/0Sfmk
1@00M6mk000EKg/00`00Kg]_N`29Kg/6001iKg/001E_N`03001_Nfmk08E_N`@007m_N`005Fmk00<0
06mkKg/0PVmk0`00Pfmk000EKg/00`00Kg]_N`20Kg/20026Kg/001E_N`03001_Nfmk07i_N`8008Q_
N`005Fmk00<006mkKg/0O6mk0P00RVmk000EKg/2001lKg/00`00Kg]_N`2:Kg/001E_N`03001_Nfmk
07U_N`8008e_N`005Fmk00<006mkKg/0Mfmk0P00Sfmk000EKg/00`00Kg]_N`1fKg/00`00Kg]_N`2?
Kg/001E_N`03001_Nfmk07A_N`80099_N`005Fmk00<006mkKg/0LVmk0P00U6mk0008Kg/50002Kg/0
0`00Kg]_N`03Kg/00`00Kg]_N`1`Kg/2002FKg/000Y_N`07001_NfmkKg/006mk000016mk00<006mk
Kg/0KVmk0P00V6mk0004Kg/30003Kg/01`00Kg]_Nfmk001_N`0000A_N`<006a_N`8009Y_N`002Vmk
00L006mkKg]_N`00Kg/00004Kg/00`00Kg]_N`1ZKg/2002LKg/000Y_N`07001_NfmkKg/006mk0000
16mk00<006mkKg/0Ifmk0`00WVmk0009Kg/20004Kg/00`00Kg]_N`03Kg/00`00Kg]_N`1TKg/3002Q
Kg/001E_N`03001_Nfmk065_N`<00:A_N`005Fmk00<006mkKg/0GFmk1000Yfmk000EKg/00`00Kg]_
N`1HKg/5002[Kg/001E_N`03001_Nfmk05=_N`D00;1_N`005Fmk0P00CVmk1P00]Fmk000EKg/00`00
Kg]_N`17Kg/6002kKg/001E_N`03001_Nfmk049_N`D00<5_N`005Fmk00<006mkKg/0?Vmk1000aVmk
000EKg/00`00Kg]_N`0kKg/3003:Kg/001E_N`03001_Nfmk03Q_N`<00<e_N`005Fmk00<006mkKg/0
=Vmk0P00d6mk000EKg/00`00Kg]_N`0cKg/3003BKg/001E_N`80039_N`800=E_N`005Fmk00<006mk
Kg/0;fmk0P00efmk000EKg/00`00Kg]_N`0^Kg/00`00Kg]_N`3GKg/001E_N`03001_Nfmk02a_N`80
0=Y_N`005Fmk00<006mkKg/0:Vmk0P00g6mk000EKg/00`00Kg]_N`0XKg/2003NKg/001E_N`03001_
Nfmk02I_N`800>1_N`005Fmk00<006mkKg/096mk0P00hVmk000EKg/2000TKg/00`00Kg]_N`3RKg/0
01E_N`03001_Nfmk025_N`800>E_N`005Fmk00<006mkKg/07fmk0P00ifmk000EKg/00`00Kg]_N`0M
Kg/2003YKg/001E_N`03001_Nfmk01Y_N`<0019_N`<0039_N`<0031_N`8003=_N`03001_Nfmk02a_
N`D0009_N`03001_Nfmk00=_N`005Fmk00<006mkKg/066mk0P005Fmk00<006mkKg/0<fmk00<006mk
Kg/0;fmk00<006mk0000<Fmk00<006mk0000;fmk00L006mkKg]_N`00Kg/00004Kg/001E_N`03001_
Nfmk01E_N`<001Q_N`03001_Nfmk031_N`@0031_N`03001_N`00035_N`03001_N`0002m_N`07001_
NfmkKg/006mk000016mk000EKg/00`00Kg]_N`0@Kg/5000KKg/00`00Kg]_N`0`Kg/00`00Kg/0000a
Kg/2000cKg/00`00Kg]_N`0^Kg/01`00Kg]_Nfmk001_N`0000A_N`005Fmk0P002fmk1P007fmk00<0
06mk0000<Vmk0P00<Fmk00<006mkKg/0<Fmk00<006mk0000;fmk00L006mkKg]_N`00Kg/00004Kg/0
01E_N`03001_Nfmk00I_N`@002I_N`03001_Nfmk039_N`03001_Nfmk031_N`80039_N`03001_Nfmk
02e_N`8000A_N`03001_Nfmk00=_N`005Fmk00<006mkKg/00Vmk1000ofmk0fmk000EKg/5003oKg/7
Kg/001E_N`@00?m_N`Q_N`005Fmk00@006mkKg]_N`<00?m_N`E_N`005Fmk00<006mkKg/016mk0P00
ofmk0fmk000>Kg_o000C000001E_N`03001_Nfmk00U_N`<000]_N`03001_Nfmk00Y_N`03001_Nfmk
00Y_N`03001_Nfmk00Y_N`03001_Nfmk00Y_N`03001_Nfmk00Y_N`03001_Nfmk00Y_N`03001_Nfmk
00Y_N`03001_Nfmk00U_N`03001_Nfmk00Y_N`03001_Nfmk00Y_N`03001_Nfmk00Y_N`03001_Nfmk
00Y_N`03001_Nfmk00Y_N`03001_Nfmk00Y_N`03001_Nfmk00Y_N`03001_Nfmk00Y_N`03001_Nfmk
00Y_N`03001_Nfmk00Y_N`03001_Nfmk00E_N`005Fmk00<006mkKg/02Vmk00<006mk00000P0026mk
00<006mkKg/02Vmk00<006mkKg/02Vmk00<006mkKg/02Vmk00<006mkKg/02Vmk00<006mkKg/02Vmk
00<006mkKg/02Vmk00<006mkKg/02Vmk00<006mkKg/02Fmk00<006mkKg/02Vmk00<006mkKg/02Vmk
00<006mkKg/02Vmk00<006mkKg/02Vmk00<006mkKg/02Vmk00<006mkKg/02Vmk00<006mkKg/02Vmk
00<006mkKg/02Vmk00<006mkKg/02Vmk00<006mkKg/02Vmk00<006mkKg/01Fmk000EKg/00`00Kg]_
N`0?Kg/3003fKg/001E_N`03001_Nfmk019_N`<00?=_N`005Fmk00<006mkKg/05Fmk0P00lFmk000E
Kg/00`00Kg]_N`0GKg/5003/Kg/001E_N`03001_Nfmk01a_N`<00>U_N`005Fmk0P0086mk0P00ifmk
000EKg/00`00Kg]_N`0QKg/2003UKg/001E_N`03001_Nfmk02=_N`03001_Nfmk0>9_N`005Fmk00<0
06mkKg/096mk0P00hVmk000EKg/00`00Kg]_N`0VKg/2003PKg/001E_N`03001_Nfmk02Q_N`800=i_
N`005Fmk00<006mkKg/0:Vmk0P00g6mk000EKg/00`00Kg]_N`0/Kg/00`00Kg]_N`3IKg/001E_N`80
02i_N`<00=Q_N`005Fmk00<006mkKg/0<6mk1@00dfmk000EKg/00`00Kg]_N`0eKg/6003=Kg/001E_
N`03001_Nfmk03]_N`D00<Q_N`005Fmk00<006mkKg/0@6mk0`00aFmk000EKg/00`00Kg]_N`13Kg/2
0033Kg/001E_N`03001_Nfmk04E_N`800<5_N`005Fmk00<006mkKg/0Afmk0P00_fmk000EKg/2001:
Kg/00`00Kg]_N`2lKg/001E_N`03001_Nfmk04Y_N`800;a_N`005Fmk00<006mkKg/0C6mk0P00^Vmk
000EKg/00`00Kg]_N`1>Kg/2002hKg/001E_N`03001_Nfmk051_N`@00;A_N`005Fmk00<006mkKg/0
E6mk0`002Vmk1@00XVmk000EKg/00`00Kg]_N`1GKg/:0005Kg/5002MKg/001E_N`03001_Nfmk06]_
N`03001_Nfmk09Y_N`005Fmk0P00KFmk00<006mkKg/0VFmk000EKg/00`00Kg]_N`1]Kg/2002IKg/0
01E_N`03001_Nfmk06m_N`03001_Nfmk09I_N`005Fmk00<006mkKg/0L6mk00<006mkKg/0UFmk000E
Kg/00`00Kg]_N`1aKg/2002EKg/001E_N`03001_Nfmk07=_N`03001_Nfmk099_N`0026mk1@000Vmk
00<006mkKg/00fmk00<006mkKg/0M6mk00<006mkKg/0TFmk000:Kg/01`00Kg]_Nfmk001_N`0000A_
N`03001_Nfmk07E_N`03001_Nfmk091_N`002Vmk00L006mkKg]_N`00Kg/00004Kg/3001fKg/00`00
Kg]_N`2?Kg/000Y_N`07001_NfmkKg/006mk000016mk00<006mkKg/0MVmk00<006mkKg/0Sfmk000:
Kg/01`00Kg]_Nfmk001_N`0000A_N`03001_Nfmk07M_N`03001_Nfmk08i_N`002Fmk0P0016mk00<0
06mkKg/00fmk00<006mkKg/0N6mk0P00SVmk000EKg/00`00Kg]_N`1jKg/3002;Kg/001E_N`03001_
Nfmk07e_N`8000Q_N``007E_N`005Fmk00<006mkKg/0Ofmk200036mk0P00Lfmk000EKg/00`00Kg]_
N`2EKg/2001aKg/001E_N`8009Q_N`8006m_N`005Fmk00<006mkKg/0VFmk0P00KFmk000EKg/00`00
Kg]_N`2KKg/00`00Kg]_N`1ZKg/001E_N`03001_Nfmk09a_N`8006Y_N`005Fmk00<006mkKg/0WVmk
0P00J6mk000EKg/00`00Kg]_N`2PKg/2000EKg/2001?Kg/001E_N`03001_Nfmk0:9_N`<000e_N`/0
04]_N`005Fmk00<006mkKg/0YFmk3@002fmk0P00BFmk000EKg/20030Kg/20017Kg/001E_N`03001_
Nfmk0<5_N`03001_Nfmk04A_N`005Fmk00<006mkKg/0`Vmk00<006mkKg/0@fmk000EKg/00`00Kg]_
N`33Kg/00`00Kg]_N`12Kg/001E_N`03001_Nfmk0<A_N`03001_Nfmk045_N`005Fmk00<006mkKg/0
aFmk00<006mkKg/0@6mk000EKg/00`00Kg]_N`35Kg/00`00Kg]_N`10Kg/001E_N`03001_Nfmk0<I_
N`03001_Nfmk03m_N`005Fmk0P00b6mk00<006mkKg/0?Vmk000EKg/00`00Kg]_N`38Kg/00`00Kg]_
N`0mKg/001E_N`03001_Nfmk0<U_N`03001_Nfmk03a_N`005Fmk00<006mkKg/0bVmk00<006mkKg/0
>fmk000EKg/00`00Kg]_N`3;Kg/00`00Kg]_N`0jKg/001E_N`03001_Nfmk0<a_N`8001A_N`@0029_
N`005Fmk00<006mkKg/0cVmk0P003Fmk1@000fmk1@007Vmk000EKg/00`00Kg]_N`3@Kg/20006Kg/5
000=Kg/2000LKg/001E_N`800==_N`H001A_N`03001_Nfmk01U_N`005Fmk00<006mkKg/0kFmk0P00
6Fmk000EKg/00`00Kg]_N`3_Kg/2000GKg/001E_N`03001_Nfmk0?5_N`8001E_N`005Fmk00<006mk
Kg/0lfmk0P004fmk000EKg/00`00Kg]_N`3eKg/00`00Kg]_N`0@Kg/000U_N`<000=_N`03001_Nfmk
00=_N`03001_Nfmk0?I_N`80011_N`002Fmk00<006mkKg/00Vmk00<006mk000016mk00<006mkKg/0
n6mk2@001fmk000:Kg/01`00Kg]_Nfmk001_N`0000A_N`<00?m_N`U_N`002Vmk00L006mkKg]_N`00
Kg/00004Kg/00`00Kg]_N`3oKg/9Kg/000U_N`03001_N`00009_N`03001_N`0000A_N`03001_Nfmk
0?m_N`U_N`002Vmk00<006mkKg/00Vmk00<006mkKg/00fmk00<006mkKg/0ofmk2Fmk003oKg/QKg/0
0?m_Nb5_N`00ofmk8Fmk003oKg/QKg/00?m_Nb5_N`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-0.825959, -22.3051, 
  0.0385924, 0.250844}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ParametricPlot[
      Evaluate[{\[CurlyPhi]1[t], \[CurlyPhi]2[t]} /. sol], {t, 0, 10}]\)], 
  "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.97619 0.0467973 0.0442536 0.0282072 [
[.04024 .03175 -9 -9 ]
[.04024 .03175 9 0 ]
[.27423 .03175 -9 -9 ]
[.27423 .03175 9 0 ]
[.50822 .03175 -9 -9 ]
[.50822 .03175 9 0 ]
[.7422 .03175 -6 -9 ]
[.7422 .03175 6 0 ]
[.96369 .18529 -6 -4.5 ]
[.96369 .18529 0 4.5 ]
[.96369 .32633 -12 -4.5 ]
[.96369 .32633 0 4.5 ]
[.96369 .46736 -12 -4.5 ]
[.96369 .46736 0 4.5 ]
[.96369 .6084 -12 -4.5 ]
[.96369 .6084 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
.04024 .04425 m
.04024 .0505 L
s
[(-20)] .04024 .03175 0 1 Mshowa
.27423 .04425 m
.27423 .0505 L
s
[(-15)] .27423 .03175 0 1 Mshowa
.50822 .04425 m
.50822 .0505 L
s
[(-10)] .50822 .03175 0 1 Mshowa
.7422 .04425 m
.7422 .0505 L
s
[(-5)] .7422 .03175 0 1 Mshowa
.125 Mabswid
.08704 .04425 m
.08704 .048 L
s
.13384 .04425 m
.13384 .048 L
s
.18064 .04425 m
.18064 .048 L
s
.22743 .04425 m
.22743 .048 L
s
.32103 .04425 m
.32103 .048 L
s
.36783 .04425 m
.36783 .048 L
s
.41462 .04425 m
.41462 .048 L
s
.46142 .04425 m
.46142 .048 L
s
.55501 .04425 m
.55501 .048 L
s
.60181 .04425 m
.60181 .048 L
s
.64861 .04425 m
.64861 .048 L
s
.69541 .04425 m
.69541 .048 L
s
.789 .04425 m
.789 .048 L
s
.8358 .04425 m
.8358 .048 L
s
.8826 .04425 m
.8826 .048 L
s
.92939 .04425 m
.92939 .048 L
s
.25 Mabswid
0 .04425 m
1 .04425 L
s
.97619 .18529 m
.98244 .18529 L
s
[(5)] .96369 .18529 1 0 Mshowa
.97619 .32633 m
.98244 .32633 L
s
[(10)] .96369 .32633 1 0 Mshowa
.97619 .46736 m
.98244 .46736 L
s
[(15)] .96369 .46736 1 0 Mshowa
.97619 .6084 m
.98244 .6084 L
s
[(20)] .96369 .6084 1 0 Mshowa
.125 Mabswid
.97619 .07246 m
.97994 .07246 L
s
.97619 .10067 m
.97994 .10067 L
s
.97619 .12888 m
.97994 .12888 L
s
.97619 .15708 m
.97994 .15708 L
s
.97619 .2135 m
.97994 .2135 L
s
.97619 .2417 m
.97994 .2417 L
s
.97619 .26991 m
.97994 .26991 L
s
.97619 .29812 m
.97994 .29812 L
s
.97619 .35453 m
.97994 .35453 L
s
.97619 .38274 m
.97994 .38274 L
s
.97619 .41095 m
.97994 .41095 L
s
.97619 .43915 m
.97994 .43915 L
s
.97619 .49557 m
.97994 .49557 L
s
.97619 .52378 m
.97994 .52378 L
s
.97619 .55198 m
.97994 .55198 L
s
.97619 .58019 m
.97994 .58019 L
s
.97619 .01605 m
.97994 .01605 L
s
.25 Mabswid
.97619 0 m
.97619 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.93535 .01472 m
.90517 .04132 L
.89106 .05696 L
.88296 .0645 L
.8734 .07165 L
.85295 .08272 L
.82912 .09369 L
.7607 .13441 L
.74245 .14542 L
.72378 .15484 L
.7088 .16061 L
.69365 .16484 L
.67974 .16768 L
.66802 .17 L
.65865 .17254 L
.65378 .17437 L
.64952 .17641 L
.64155 .18173 L
.63748 .18542 L
.63402 .18922 L
.62699 .19916 L
.62125 .20978 L
.61204 .22928 L
.60676 .23863 L
.60405 .24241 L
.60148 .24533 L
.59863 .24785 L
.59581 .24968 L
.59421 .25046 L
.59269 .25104 L
.59098 .25152 L
.5901 .25171 L
.58911 .25188 L
.58819 .25199 L
.58772 .25203 L
.58721 .25207 L
.58628 .25211 L
.58541 .25212 L
.58487 .25212 L
.58436 .2521 L
.58339 .25206 L
.58283 .25202 L
.58232 .25198 L
.58114 .25187 L
.57712 .25132 L
.57255 .25054 L
.56802 .2498 L
.56568 .24946 L
.56344 .24919 L
.56079 .24895 L
Mistroke
.55935 .24886 L
.55854 .24882 L
.55779 .24879 L
.55646 .24876 L
.555 .24876 L
.5536 .24879 L
.55229 .24885 L
.55104 .24893 L
.54969 .24904 L
.54719 .24934 L
.54416 .24985 L
.54132 .25046 L
.53492 .25237 L
.52858 .25496 L
.51427 .26325 L
.49779 .27653 L
.46512 .31026 L
.44759 .32876 L
.43 .34486 L
.41588 .35484 L
.40827 .35891 L
.40148 .36171 L
.39781 .36289 L
.39443 .36377 L
.39146 .36436 L
.38833 .36482 L
.38673 .36499 L
.38582 .36506 L
.385 .36512 L
.38414 .36516 L
.38322 .3652 L
.38159 .36522 L
.38012 .3652 L
.37855 .36513 L
.37709 .36504 L
.37576 .36492 L
.3729 .36456 L
.3703 .36414 L
.36471 .36291 L
.35476 .36016 L
.35272 .35963 L
.35063 .35914 L
.34877 .35878 L
.34788 .35864 L
.34707 .35853 L
.34618 .35844 L
.34572 .35841 L
.34524 .35838 L
.34446 .35836 L
.34363 .35838 L
Mistroke
.34316 .3584 L
.34273 .35843 L
.34224 .35848 L
.34178 .35854 L
.34098 .35867 L
.34012 .35886 L
.33862 .35933 L
.33731 .35989 L
.33583 .36071 L
.33449 .36165 L
.33219 .36372 L
.32985 .36655 L
.32752 .37019 L
.3255 .37413 L
.32147 .38472 L
.31791 .39709 L
.31469 .40873 L
.31132 .41849 L
.30922 .42308 L
.30713 .42659 L
.30528 .42897 L
.30312 .43095 L
.30199 .43169 L
.30138 .43201 L
.30074 .4323 L
.30016 .43251 L
.29952 .43269 L
.29893 .43282 L
.29837 .43291 L
.29769 .43297 L
.29735 .43298 L
.29696 .43298 L
.29628 .43295 L
.29562 .43288 L
.29522 .43282 L
.29484 .43275 L
.29411 .4326 L
.29241 .43211 L
.2894 .43091 L
.28584 .42917 L
.27838 .4253 L
.27427 .4234 L
.27022 .42182 L
.26788 .42108 L
.26523 .42038 L
.26246 .41983 L
.26092 .4196 L
.26022 .41952 L
.25945 .41944 L
.25809 .41934 L
Mistroke
.25679 .41928 L
.2555 .41927 L
.2543 .41929 L
.25298 .41936 L
.25152 .41949 L
.24997 .41967 L
.24849 .4199 L
.24513 .42063 L
.24184 .42159 L
.23547 .42414 L
.22832 .42806 L
.22017 .4338 L
.20438 .44827 L
.18886 .46583 L
.15171 .51134 L
.13607 .52755 L
.1206 .5397 L
.11293 .54402 L
.10898 .54577 L
.10484 .54723 L
.10112 .54823 L
.09782 .54886 L
.09625 .54906 L
.09457 .54923 L
.093 .54932 L
.09157 .54935 L
.0901 .54933 L
.08857 .54926 L
.08728 .54915 L
.08588 .54899 L
.0844 .54877 L
.08285 .54848 L
.08012 .54783 L
.07503 .54614 L
.07074 .54424 L
.06142 .5389 L
.05791 .53668 L
.05442 .53459 L
.05166 .5332 L
.05022 .53263 L
.04895 .53225 L
.04828 .53211 L
.04791 .53205 L
.04757 .53201 L
.04696 .53196 L
.04631 .53196 L
.04568 .53201 L
.0451 .5321 L
.04458 .53223 L
.04404 .53241 L
Mistroke
.04345 .53266 L
.0429 .53294 L
.04171 .53375 L
.0406 .53479 L
.03946 .53616 L
.03754 .53933 L
.03597 .54293 L
.03456 .54723 L
.03328 .55242 L
.03239 .55725 L
.03159 .56288 L
.03091 .5691 L
.03033 .57577 L
.02984 .58177 L
.02938 .58694 L
.02887 .59158 L
.02836 .59523 L
.02773 .59854 L
.02737 .60001 L
.02701 .60115 L
.02666 .60204 L
.02646 .60243 L
.02627 .60273 L
.02609 .60295 L
.02593 .60311 L
.02575 .60323 L
.02555 .6033 L
.02545 .60332 L
.02534 .60332 L
.02515 .60326 L
.02503 .60321 L
.02493 .60314 L
.02469 .60293 L
.02447 .60268 L
.02427 .60239 L
.02381 .60156 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40O003h00Oofmk5fmk00<006mk
Kg/01fmk000;Kg/30003Kg/00`00Kg]_N`0iKg/50002Kg/00`00Kg]_N`0hKg/50002Kg/00`00Kg]_
N`0mKg/00`00Kg]_N`0mKg/00`00Kg]_N`07Kg/000]_N`03001_Nfmk009_N`03001_N`0003a_N`07
001_NfmkKg/006mk0000>fmk00L006mkKg]_N`00Kg/0000mKg/00`00Kg/0000nKg/00`00Kg]_N`07
Kg/000I_N`<000=_N`07001_NfmkKg/006mk0000=Vmk0`000fmk00<006mkKg/00fmk00<006mkKg/0
<fmk0`000fmk00L006mkKg]_N`00Kg/0000hKg/30004Kg/00`00Kg]_N`0lKg/00`00Kg]_N`07Kg/0
00a_N`07001_NfmkKg/006mk0000?6mk00@006mkKg]_N`8003a_N`07001_NfmkKg/006mk0000?Fmk
0P00<fmk00<006mkKg/02Fmk0P0026mk000;Kg/00`00Kg/00002Kg/00`00Kg/0000lKg/01@00Kg]_
Nfmk0000?Fmk00L006mkKg]_N`00Kg/0000mKg/00`00Kg]_N`0aKg/00`00Kg]_N`0:Kg/00`00Kg]_
N`07Kg/000a_N`03001_Nfmk009_N`03001_Nfmk03Y_N`8000=_N`<003Y_N`8000A_N`03001_Nfmk
03a_N`<0031_N`03001_Nfmk00]_N`03001_Nfmk00M_N`00ofmk1fmk0P003Vmk00<006mkKg/01fmk
003oKg/6Kg/00`00Kg]_N`0>Kg/00`00Kg]_N`07Kg/00?m_N`E_N`03001_Nfmk00m_N`03001_Nfmk
00M_N`00ofmk16mk00<006mkKg/046mk00<006mkKg/01fmk003oKg/3Kg/00`00Kg]_N`0AKg/00`00
Kg]_N`07Kg/00003Kg/000000?l001`0009_N`003Fmk00<006mkKg/02Vmk00<006mkKg/02Vmk00<0
06mkKg/02Vmk00<006mkKg/02fmk00<006mkKg/02Vmk00<006mkKg/02Vmk00<006mkKg/02fmk00<0
06mkKg/02Vmk00<006mkKg/02Vmk00<006mkKg/02Vmk00<006mkKg/02fmk00<006mkKg/02Vmk00<0
06mkKg/02Vmk00<006mkKg/02Vmk00<006mkKg/02fmk00<006mkKg/02Vmk00<006mkKg/02Vmk00<0
06mkKg/02Vmk00<006mkKg/00Vmk00<006mkKg/01Vmk00<006mkKg/02Vmk00<006mkKg/01fmk000=
Kg/00`00Kg]_N`0oKg/00`00Kg]_N`0oKg/00`00Kg]_N`10Kg/00`00Kg]_N`0YKg/00`00Kg]_N`0C
Kg/00`00Kg]_N`07Kg/00?m_N`03001_Nfmk01A_N`03001_Nfmk00M_N`00oVmk00<006mkKg/05Fmk
00<006mkKg/01fmk003mKg/00`00Kg]_N`0FKg/00`00Kg]_N`07Kg/00?a_N`03001_Nfmk01M_N`03
001_Nfmk00M_N`00nVmk0P006Vmk00<006mkKg/01fmk003hKg/2000LKg/20008Kg/00?I_N`8001i_
N`03001_Nfmk00M_N`00m6mk0P0086mk00<006mkKg/01fmk003bKg/2000RKg/00`00Kg]_N`07Kg/0
0?1_N`8002A_N`03001_Nfmk00M_N`00kVmk0P009Vmk00<006mkKg/01fmk003/Kg/2000XKg/00`00
Kg]_N`07Kg/00>Y_N`8002Y_N`03001_Nfmk00M_N`00jFmk00<006mkKg/0:Vmk0P0026mk003WKg/2
000]Kg/00`00Kg]_N`07Kg/00>E_N`8002m_N`03001_Nfmk00M_N`00i6mk00<006mkKg/0;fmk00<0
06mkKg/01fmk003RKg/2000bKg/00`00Kg]_N`07Kg/00>5_N`03001_Nfmk039_N`03001_Nfmk00M_
N`00gfmk0P00=Fmk00<006mkKg/01fmk003MKg/2000gKg/00`00Kg]_N`07Kg/00=a_N`03001_Nfmk
03M_N`8000Q_N`00fVmk0P00>Vmk00<006mkKg/01fmk003IKg/00`00Kg]_N`0jKg/00`00Kg]_N`07
Kg/00=M_N`8003e_N`03001_Nfmk00M_N`00eFmk0P00?fmk00<006mkKg/01fmk003CKg/20011Kg/0
0`00Kg]_N`07Kg/00=1_N`<004=_N`03001_Nfmk00M_N`00cFmk0`00AVmk00<006mkKg/01fmk003;
Kg/20019Kg/20008Kg/00<Q_N`<004]_N`03001_Nfmk00M_N`00a6mk1000CVmk00<006mkKg/01fmk
0031Kg/3001BKg/00`00Kg]_N`07Kg/00;a_N`D005E_N`03001_Nfmk00M_N`00^Vmk0P00FVmk00<0
06mkKg/01fmk002hKg/2001EKg/00`00Kg]_N`04Kg/00`00Kg]_N`07Kg/00;M_N`03001_Nfmk05A_
N`03001_N`0000E_N`03001_Nfmk00M_N`00]Vmk00<006mkKg/0Efmk00<006mkKg/00fmk0`001fmk
002eKg/00`00Kg]_N`1FKg/20006Kg/00`00Kg]_N`07Kg/00;A_N`03001_Nfmk05M_N`03001_Nfmk
00E_N`03001_Nfmk00M_N`00]6mk00<006mkKg/0Efmk0`001Fmk00<006mkKg/01fmk002cKg/00`00
Kg]_N`1PKg/00`00Kg]_N`07Kg/00;9_N`03001_Nfmk065_N`03001_Nfmk00M_N`00/Vmk00<006mk
Kg/0HFmk00<006mkKg/01fmk002aKg/00`00Kg]_N`1RKg/00`00Kg]_N`07Kg/00;5_N`03001_Nfmk
069_N`8000Q_N`00/6mk00<006mkKg/0Hfmk00<006mkKg/01fmk002`Kg/00`00Kg]_N`1SKg/00`00
Kg]_N`07Kg/00;1_N`03001_Nfmk06=_N`03001_Nfmk00M_N`00[fmk00<006mkKg/0I6mk00<006mk
Kg/01fmk002_Kg/00`00Kg]_N`1TKg/00`00Kg]_N`07Kg/00:i_N`03001_Nfmk06E_N`03001_Nfmk
00M_N`00[Fmk00<006mkKg/0IVmk00<006mkKg/01fmk002/Kg/00`00Kg]_N`1WKg/20008Kg/00:a_
N`03001_Nfmk06M_N`03001_Nfmk00M_N`00W6mk20001Vmk0P00JVmk00<006mkKg/01fmk002HKg/4
0008Kg/7001[Kg/00`00Kg]_N`07Kg/009I_N`8007i_N`03001_Nfmk00M_N`00U6mk0P00P6mk00<0
06mkKg/01fmk002CKg/00`00Kg]_N`20Kg/00`00Kg]_N`07Kg/0099_N`03001_Nfmk085_N`03001_
Nfmk00M_N`00T6mk0P00Q6mk0P0026mk002?Kg/00`00Kg]_N`24Kg/00`00Kg]_N`07Kg/008i_N`03
001_Nfmk08E_N`03001_Nfmk00M_N`00SFmk00<006mkKg/0QVmk00<006mkKg/01fmk002<Kg/00`00
Kg]_N`27Kg/00`00Kg]_N`07Kg/008]_N`03001_Nfmk08Q_N`03001_Nfmk00M_N`00RVmk00<006mk
Kg/0RFmk00<006mkKg/01fmk0029Kg/00`00Kg]_N`2:Kg/00`00Kg]_N`07Kg/008Q_N`03001_Nfmk
08]_N`8000Q_N`00Qfmk00<006mkKg/0S6mk00<006mkKg/01fmk0026Kg/00`00Kg]_N`2=Kg/00`00
Kg]_N`07Kg/008E_N`03001_Nfmk08i_N`03001_Nfmk00M_N`00Q6mk00<006mkKg/0Sfmk00<006mk
Kg/01fmk0023Kg/00`00Kg]_N`2@Kg/00`00Kg]_N`07Kg/008=_N`03001_Nfmk089_N`D0009_N`03
001_Nfmk00A_N`03001_Nfmk00M_N`00PVmk00<006mkKg/0QFmk00L006mkKg]_N`00Kg/00005Kg/0
0`00Kg]_N`07Kg/0085_N`03001_Nfmk08I_N`07001_NfmkKg/006mk00001Fmk0`001fmk0020Kg/0
0`00Kg]_N`27Kg/01`00Kg]_Nfmk001_N`0000E_N`03001_Nfmk00M_N`00Ofmk00<006mkKg/0R6mk
00L006mkKg]_N`00Kg/00005Kg/00`00Kg]_N`07Kg/007e_N`8008Y_N`8000A_N`03001_Nfmk00A_
N`03001_Nfmk00M_N`00O6mk00<006mkKg/0Ufmk00<006mkKg/01fmk001kKg/00`00Kg]_N`2HKg/0
0`00Kg]_N`07Kg/007U_N`8009]_N`03001_Nfmk00M_N`00N6mk00<006mkKg/0Vfmk00<006mkKg/0
1fmk001fKg/2002NKg/20008Kg/0065_N`D000i_N`800:1_N`03001_Nfmk00M_N`00H6mk0P0016mk
100026mk0P00XVmk00<006mkKg/01fmk001OKg/00`00Kg]_N`08Kg/8002TKg/00`00Kg]_N`07Kg/0
05i_N`03001_Nfmk0;E_N`03001_Nfmk00M_N`00GVmk00<006mkKg/0]Fmk00<006mkKg/01fmk001N
Kg/00`00Kg]_N`2eKg/00`00Kg]_N`07Kg/005e_N`03001_Nfmk0;I_N`03001_Nfmk00M_N`00GFmk
00<006mkKg/0]Vmk0P0026mk001LKg/00`00Kg]_N`2gKg/00`00Kg]_N`07Kg/005a_N`03001_Nfmk
0;M_N`03001_Nfmk00M_N`00Ffmk00<006mkKg/0^6mk00<006mkKg/01fmk001KKg/00`00Kg]_N`2h
Kg/00`00Kg]_N`07Kg/005]_N`03001_Nfmk0;Q_N`03001_Nfmk00M_N`00FVmk00<006mkKg/0^Fmk
00<006mkKg/01fmk001JKg/00`00Kg]_N`2iKg/00`00Kg]_N`07Kg/005Y_N`03001_Nfmk0;U_N`80
00Q_N`00FVmk00<006mkKg/0^Fmk00<006mkKg/01fmk0019Kg/3000>Kg/00`00Kg]_N`2iKg/00`00
Kg]_N`07Kg/004E_N`@000=_N`<000Y_N`03001_Nfmk0;Y_N`03001_Nfmk00M_N`00@fmk0P002Vmk
0`001Vmk00<006mkKg/0^fmk00<006mkKg/01fmk0012Kg/00`00Kg]_N`0=Kg/00`00Kg]_N`03Kg/0
0`00Kg]_N`2kKg/00`00Kg]_N`07Kg/0045_N`03001_Nfmk00m_N`D00;i_N`03001_Nfmk00M_N`00
@6mk00<006mkKg/0dfmk00<006mkKg/01fmk000oKg/00`00Kg]_N`3DKg/20008Kg/003e_N`800=M_
N`03001_Nfmk00M_N`00?6mk00<006mkKg/0efmk00<006mkKg/01fmk000kKg/00`00Kg]_N`3HKg/0
0`00Kg]_N`07Kg/003Y_N`03001_Nfmk0=U_N`03001_Nfmk00M_N`00>Fmk00<006mkKg/0fVmk00<0
06mkKg/01fmk000iKg/00`00Kg]_N`3<Kg/50002Kg/00`00Kg]_N`04Kg/00`00Kg]_N`07Kg/003Q_
N`03001_Nfmk0<m_N`07001_NfmkKg/006mk00001Fmk00<006mkKg/01fmk000gKg/00`00Kg]_N`3@
Kg/00`00Kg]_N`03Kg/00`00Kg]_N`03Kg/30007Kg/003I_N`03001_Nfmk0=5_N`04001_NfmkKg/2
0006Kg/00`00Kg]_N`07Kg/003E_N`03001_Nfmk0=9_N`05001_NfmkKg/00007Kg/00`00Kg]_N`07
Kg/003A_N`03001_Nfmk0=9_N`8000=_N`<000E_N`03001_Nfmk00M_N`00<fmk00<006mkKg/0h6mk
00<006mkKg/01fmk000bKg/00`00Kg]_N`3QKg/00`00Kg]_N`07Kg/0039_N`03001_Nfmk0>5_N`03
001_Nfmk00M_N`00<Fmk00<006mkKg/0hVmk00<006mkKg/01fmk000`Kg/00`00Kg]_N`3SKg/20008
Kg/002m_N`03001_Nfmk0>A_N`03001_Nfmk00M_N`00;Vmk00<006mkKg/0iFmk00<006mkKg/01fmk
000]Kg/00`00Kg]_N`3VKg/00`00Kg]_N`07Kg/002a_N`03001_Nfmk0>M_N`03001_Nfmk00M_N`00
:fmk00<006mkKg/0j6mk00<006mkKg/01fmk000ZKg/00`00Kg]_N`3YKg/00`00Kg]_N`07Kg/002Y_
N`03001_Nfmk0>U_N`03001_Nfmk00M_N`00:Fmk00<006mkKg/0jVmk0P0026mk000XKg/00`00Kg]_
N`3[Kg/00`00Kg]_N`07Kg/000i_N`8001M_N`03001_Nfmk0>a_N`03001_Nfmk00M_N`003Fmk0P00
00=_N`0000004fmk0P00kfmk00<006mkKg/01fmk000<Kg/00`00Kg]_N`03Kg/2000@Kg/00`00Kg]_
N`3_Kg/00`00Kg]_N`07Kg/000]_N`03001_Nfmk00I_N`03001_Nfmk00]_N`800?9_N`03001_Nfmk
00M_N`002fmk00<006mkKg/01fmk0`0026mk0P00m6mk00<006mkKg/01fmk000;Kg/00`00Kg]_N`0:
Kg/8003fKg/00`00Kg]_N`07Kg/000]_N`03001_Nfmk0?m_N`U_N`8000Q_N`002fmk00<006mkKg/0
ofmk2Fmk00<006mkKg/01fmk000:Kg/00`00Kg]_N`3oKg/:Kg/00`00Kg]_N`07Kg/000Y_N`03001_
Nfmk0?m_N`Y_N`03001_Nfmk00M_N`002Vmk00<006mkKg/0ofmk2Vmk00<006mkKg/01fmk000:Kg/0
0`00Kg]_N`3oKg/:Kg/00`00Kg]_N`07Kg/000Y_N`03001_Nfmk0?m_N`Y_N`03001_Nfmk00M_N`00
2Vmk00<006mkKg/0ofmk2Vmk00<006mkKg/01fmk000:Kg/00`00Kg]_N`3oKg/:Kg/20008Kg/000Y_
N`03001_Nfmk0?m_N`Y_N`03001_Nfmk00M_N`002Vmk00<006mkKg/0ofmk2Vmk00<006mkKg/01fmk
0009Kg/00`00Kg]_N`3oKg/;Kg/00`00Kg]_N`07Kg/000U_N`03001_Nfmk0?m_N`]_N`03001_Nfmk
00M_N`002Fmk00<006mkKg/0ofmk2fmk00<006mkKg/01fmk0008Kg/2003oKg/30003Kg/00`00Kg]_
N`04Kg/00`00Kg]_N`07Kg/000Q_N`800?m_N`03001_Nfmk009_N`03001_N`0000E_N`03001_Nfmk
00M_N`00ofmk2fmk00L006mkKg]_N`00Kg/00005Kg/30007Kg/00?m_N`]_N`07001_NfmkKg/006mk
00001Fmk00<006mkKg/01fmk003oKg/:Kg/00`00Kg/00002Kg/00`00Kg/00005Kg/00`00Kg]_N`07
Kg/00?m_N`]_N`03001_Nfmk009_N`03001_Nfmk00A_N`03001_Nfmk00M_N`00ofmk8Fmk0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-20.9947, -1.56906, 
  0.0753947, 0.125084}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]]
},
FrontEndVersion->"Microsoft Windows 3.0",
ScreenRectangle->{{0, 1280}, {0, 996}},
WindowSize->{1047, 918},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
StyleDefinitions -> "Report.nb"
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1731, 51, 242, 5, 35, "Input"],
Cell[1976, 58, 883, 21, 49, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2896, 84, 115, 3, 35, "Input"],
Cell[3014, 89, 104, 2, 49, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3155, 96, 44, 1, 35, "Input"],
Cell[3202, 99, 1059, 24, 68, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4298, 128, 301, 6, 35, "Input"],
Cell[4602, 136, 35, 1, 49, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4674, 142, 117, 2, 35, "Input"],
Cell[4794, 146, 40, 1, 49, "Output"]
}, Open  ]],
Cell[4849, 150, 149, 3, 35, "Input"],

Cell[CellGroupData[{
Cell[5023, 157, 53, 1, 35, "Input"],
Cell[5079, 160, 2854, 60, 106, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7970, 225, 235, 4, 35, "Input"],
Cell[8208, 231, 584, 14, 49, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[8829, 250, 178, 3, 35, "Input"],
Cell[9010, 255, 1141, 30, 49, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10188, 290, 90, 1, 35, "Input"],
Cell[10281, 293, 246, 6, 49, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10564, 304, 168, 3, 35, "Input"],
Cell[10735, 309, 170, 3, 49, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10942, 317, 183, 3, 35, "Input"],
Cell[11128, 322, 160, 2, 49, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11325, 329, 99, 2, 35, "Input"],
Cell[11427, 333, 85, 1, 49, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11549, 339, 79, 1, 35, "Input"],
Cell[11631, 342, 437, 11, 49, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[12105, 358, 109, 2, 35, "Input"],
Cell[12217, 362, 14721, 573, 194, 7144, 475, "GraphicsData", 
"PostScript", "Graphics"],
Cell[26941, 937, 130, 3, 49, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[27108, 945, 122, 3, 35, "Input"],
Cell[27233, 950, 14884, 545, 194, 6466, 437, "GraphicsData", 
"PostScript", "Graphics"],
Cell[42120, 1497, 130, 3, 49, "Output"]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

